--[[

	Quest Completist - qcLogger.lua
	Written by: Alistair Maxwell

--]]

qcLoggerData = {}

local function qcRound(num, idp)

	local mult = 10^(idp or 0)
	return math.floor(num * mult + 0.5) / mult

end

function qcParseData()

local infosection
local questsection
local parseversion = "Version:0.8"
local finalqueststring

	wipe(qcParsedData)

	for qcParsedIndex, qcParsed in pairs(qcDataToParse) do

		if (qcDataToParse[qcParsedIndex]["A"] == nil) then
			qcDataToParse[qcParsedIndex]["A"] = {}
		end

		if (qcDataToParse[qcParsedIndex]["A"]["NPCID"] ~= nil) then
			infosection = "{" .. qcDataToParse[qcParsedIndex]["A"]["NPCID"]
		else
			infosection = "{nil"
		end
		if (qcDataToParse[qcParsedIndex]["A"]["NPCN"] ~= nil) then
			infosection = infosection .. ', "' .. qcDataToParse[qcParsedIndex]["A"]["NPCN"] .. '"'
		else
			infosection = infosection .. ", nil"
		end
		if (qcDataToParse[qcParsedIndex]["A"]["Z"] ~= nil) then
			infosection = infosection .. ', "' .. qcDataToParse[qcParsedIndex]["A"]["Z"] .. '"'
		else
			infosection = infosection .. ", nil"
		end
		if (qcDataToParse[qcParsedIndex]["A"]["PX"] ~= nil) then
			infosection = infosection .. ", " .. qcRound(qcDataToParse[qcParsedIndex]["A"]["PX"], 1)
		else
			infosection = infosection .. ", nil"
		end
		if (qcDataToParse[qcParsedIndex]["A"]["PY"] ~= nil) then
			infosection = infosection .. ", " .. qcRound(qcDataToParse[qcParsedIndex]["A"]["PY"], 1)
		else
			infosection = infosection .. ", nil"
		end
		infosection = infosection .. ", nil}"
		--print(infosection)

		for qcQuestDatabaseIndex, qcQuestDatabase in ipairs(qcOldDatabase) do
			if (qcQuestDatabase[2] == qcParsedIndex) then
				-- This is our quest --

				questsection = "{" .. qcQuestDatabase[1]
				questsection = questsection .. ", " .. qcQuestDatabase[2] -- Possibly add detection of iR pr iD
				questsection = questsection .. ", " .. qcQuestDatabase[3]
				questsection = questsection .. ", " .. qcQuestDatabase[4]
				questsection = questsection .. ', "' .. qcQuestDatabase[5] .. '"'
				questsection = questsection .. ", " .. qcQuestDatabase[6]
				questsection = questsection .. ", " .. qcQuestDatabase[7]
				if (qcQuestDatabase[8] == nil) then
					questsection = questsection .. ", nil"
				else
					questsection = questsection .. ', "' .. qcQuestDatabase[8] .. '"'
				end
				if (qcQuestDatabase[9] == nil) then
					questsection = questsection .. ", 2"
				else
					questsection = questsection .. ", " .. qcQuestDatabase[9]
				end
				if (qcQuestDatabase[10] == nil) then
					questsection = questsection .. ", nil"
				else
					questsection = questsection .. ', "' .. qcQuestDatabase[10] .. '"'
				end

				finalqueststring = questsection .. ", " .. infosection .. "},"
				table.insert(qcParsedData, finalqueststring)
				break
			else
				if (qcQuestDatabaseIndex == #qcOldDatabase) then -- We have checked the entire database --
					print("TODO:" .. qcParsedIndex)
				end
			end
		end

	end

end

function qcGetQuestNPCData() -- Returns NPC GUID, NPC ID and NPC Name --

local qcNPCGUID
local qcNPCID
local qcNPCName

	qcNPCGUID = UnitGUID("target")
	qcNPCName = UnitName("target")

	if (qcNPCGUID == nil) then
		if (qcNPCName == nil) or (qcNPCName == "") then
			return nil, nil, nil
		else
			return nil, nil, qcNPCName
		end
	else
		qcNPCID = tonumber(strsub(qcNPCGUID, 7, 10), 16)
		if (qcNPCID == nil) or (qcNPCID == "") then
			if (qcNPCName == nil) or (qcNPCName == "") then
				return nil, nil, nil
			else
				return nil, nil, qcNPCName
			end
		end
		if (qcNPCName == nil) or (qcNPCName == "") then
			return nil, nil, nil
		end
	end

	return qcNPCGUID, qcNPCID, qcNPCName

end

function qcCompareComparisonToLiveDB()
if GetLocale() == "enUS" then

local qcLiveCopyCount = 0
local qcDynamicAlreadyExistedCount = 0
local qcNewQuestCount = 0

	wipe(qcStaticDB)

	--[[ Copy the entire LiveDB to the StaticDB for work to be done ]]--
	for qcLiveDBIndex, qcLiveDBEntry in pairs(qcQuestDatabases) do
		table.insert(qcStaticDB, qcLiveDBIndex, qcQuestDatabases[qcLiveDBIndex])
		qcLiveCopyCount = (qcLiveCopyCount + 1)
	end

	for qcComparisonDBIndex, qcComparisonDBEntry in pairs(qcComparisonDB) do
		if (qcStaticDB[qcComparisonDBIndex] ~= nil) then --[[ Entry already exists in the Static DB ]]--
			qcDynamicAlreadyExistedCount = (qcDynamicAlreadyExistedCount + 1)
			--[[ Compare Faction ]]--
			if (string.find(qcStaticDB[qcComparisonDBIndex][6], qcComparisonDB[qcComparisonDBIndex][6], 1, true) == nil) then
				--[[ The faction isn't flagged for this quest ]]--
				print("Difference in '" .. qcStaticDB[qcComparisonDBIndex][2] .. "'. StaticDB 'Faction [6]' is '" .. qcStaticDB[qcComparisonDBIndex][6] .. "' and DynamicDB states '" .. qcComparisonDB[qcComparisonDBIndex][6] .. "'. Fixing.")
				qcStaticDB[qcComparisonDBIndex][6] = (qcStaticDB[qcComparisonDBIndex][6] .. qcComparisonDB[qcComparisonDBIndex][6])
				print("The new result is: '" .. qcStaticDB[qcComparisonDBIndex][6] .. "'")
			end
			--[[ Compare Class ]]--
			if (string.find(qcStaticDB[qcComparisonDBIndex][8], qcComparisonDB[qcComparisonDBIndex][8], 1, true) == nil) then
				--[[ The class isn't flagged for this quest ]]--
				print("Difference in '" .. qcStaticDB[qcComparisonDBIndex][2] .. "'. StaticDB 'Class [8]' is '" .. qcStaticDB[qcComparisonDBIndex][8] .. "' and DynamicDB states '" .. qcComparisonDB[qcComparisonDBIndex][8] .. "'. Fixing.")
				qcStaticDB[qcComparisonDBIndex][8] = (qcStaticDB[qcComparisonDBIndex][8] .. qcComparisonDB[qcComparisonDBIndex][8])
				print("The new result is: '" .. qcStaticDB[qcComparisonDBIndex][8] .. "'")
			end
			--[[ Compare Race ]]--
			if (string.find(qcStaticDB[qcComparisonDBIndex][10], qcComparisonDB[qcComparisonDBIndex][10], 1, true) == nil) then
				--[[ The race isn't flagged for this quest ]]--
				print("Difference in '" .. qcStaticDB[qcComparisonDBIndex][2] .. "'. StaticDB 'Race [10]' is '" .. qcStaticDB[qcComparisonDBIndex][10] .. "' and DynamicDB states '" .. qcComparisonDB[qcComparisonDBIndex][10] .. "'. Fixing.")
				qcStaticDB[qcComparisonDBIndex][10] = (qcStaticDB[qcComparisonDBIndex][10] .. qcComparisonDB[qcComparisonDBIndex][10])
				print("The new result is: '" .. qcStaticDB[qcComparisonDBIndex][10] .. "'")
			end
		else --[[ The entry does not yet exist in the Static DB ]]--
			table.insert(qcStaticDB, qcComparisonDBIndex, qcComparisonDBEntry)
			qcNewQuestCount = (qcNewQuestCount + 1)
		end
	end

	print(qcLiveCopyCount .. " quests copied from the LiveDB. " .. qcDynamicAlreadyExistedCount .. " of the entries in the DynamicDB already existed in the LiveDB. " .. qcNewQuestCount .. " new quests have been added since last comparison.")

end
end

function qcBuildDynamicDB(qcAccept)
if GetLocale() == "enUS" then

local qcQuestID
local qcCategoryName
local qcCategoryID
local qcQuestType		--[[ 1:Normal, 2:Repeatable, 3:Daily, 4:Special 5:Weekly ]]--
local qcQuestLevel
local qcQuestTitle
local qcFaction 		--[[ A:Alliance, H:Horde ]]--
local qcIsClassBased	--[[ 1:Yes, 2:No ]]--
local qcClasses
local qcIsRaceBased		--[[ 1:Yes, 2:No ]]--
local qcRaces
local qcNPCID
local qcNPCName
local qcNPCZone
local qcNPCX
local qcNPCY
local qcComments = nil

	--[[ Get Quest ID, Category Name and Category ID ]]--
	qcQuestID = GetQuestID()
	qcCategoryName = qcGetQuestCategory(qcQuestID)
	for qcCategoryIndex, qcCategory in ipairs(qcCategories) do
		if (qcCategory[2] == qcCategoryName) then
			qcCategoryID = qcCategory[1]
			break
		else
			if (qcCategoryIndex == #qcCategories) then --[[ We have checked all known categories ]]--
				qcCategoryID = 99999
			end
		end
	end

	--[[ Get Quest Type ]]--
	if (QuestIsDaily() == 1) then
		qcQuestType = 3
	elseif (QuestIsWeekly() == 1) then
		qcQuestType = 5
	else
		local qcIsTrivial
		local qcIsDaily
		local qcIsRepeatable
		qcIsTrivial, qcIsDaily, qcIsRepeatable = GetAvailableQuestInfo(GetQuestLogIndexByID(qcQuestID))
		if (qcIsRepeatable == nil) then
			qcQuestType = 1
		elseif (qcIsRepeatable == 1) then
			qcQuestType = 2
		end
	end

	--[[ Get Quest Level and Quest Title ]]--
	do
		local _S
		local qcTitle
		local qcLevel
		local qcTag	--[[ Nil if no Tag ]]--
		qcTitle, qcLevel, qcTag, _S, _S, _S, _S, _S, _S = GetQuestLogTitle(GetQuestLogIndexByID(qcQuestID))
		qcQuestLevel = qcLevel
		if (qcTag == nil) then
			qcQuestTitle = qcTitle
		else
			qcQuestTitle = (qcTitle .. " [" .. qcTag .. "]")
		end
	end

	--[[ Get the players current Faction ]]--
	if (string.upper(qcPlayerEnglishFaction) == "ALLIANCE") then
		qcFaction = "A"
	elseif (string.upper(qcPlayerEnglishFaction) == "HORDE") then
		qcFaction = "H"
	end

	--[[ Get the players current Class ]]--
	qcClasses = string.upper(qcPlayerEnglishClass)

	--[[ Get the players current Race ]]--
	qcRaces = string.upper(qcPlayerEnglishRace)

	--[[ Get NPC ID, Name, Zone and NPXX\NPCY ]]--
	do
		local _S
		local qcX
		local qcY
		_S, qcNPCID, qcNPCName = qcGetQuestNPCData()
		qcX, qcY = GetPlayerMapPosition("player")
		qcNPCZone = GetRealZoneText()
		qcNPCX = qcRound(qcX*100, 1)
		qcNPCY = qcRound(qcY*100, 1)
	end

	--[[ Add Quest to the DynamicDB ]]--
	do
		if (qcDynamicDB[qcQuestID] == nil) then --[[ This quest is not in the DB ]]--
			qcDynamicDB[qcQuestID] = {} --[[ Create the entry ]]--
			qcDynamicDB[qcQuestID][1] = qcCategoryID
			qcDynamicDB[qcQuestID][2] = qcQuestID
			qcDynamicDB[qcQuestID][3] = qcQuestType
			qcDynamicDB[qcQuestID][4] = qcQuestLevel
			qcDynamicDB[qcQuestID][5] = qcQuestTitle
			qcDynamicDB[qcQuestID][6] = qcFaction
			qcDynamicDB[qcQuestID][7] = 2
			qcDynamicDB[qcQuestID][8] = qcClasses
			qcDynamicDB[qcQuestID][9] = 2
			qcDynamicDB[qcQuestID][10] = qcRaces
			qcDynamicDB[qcQuestID][11] = {} --[[ Create sub entry ]]--
			qcDynamicDB[qcQuestID][11][1] = qcNPCID
			qcDynamicDB[qcQuestID][11][2] = qcNPCName
			qcDynamicDB[qcQuestID][11][3] = qcNPCZone
			qcDynamicDB[qcQuestID][11][4] = qcNPCX
			qcDynamicDB[qcQuestID][11][5] = qcNPCY
			qcDynamicDB[qcQuestID][11][6] = qcComments
		else
			-- [[ Update Faction if required ]]--
			if (string.find(qcDynamicDB[qcQuestID][6], string.upper(qcFaction), 1, true) == nil) then
				qcDynamicDB[qcQuestID][6] = qcDynamicDB[qcQuestID][6] .. qcFaction
			end
			-- [[ Update Class if required ]]--
			if (string.find(qcDynamicDB[qcQuestID][8], string.upper(qcClasses), 1, true) == nil) then
				qcDynamicDB[qcQuestID][8] = qcDynamicDB[qcQuestID][8] .. qcClasses
			end
			-- [[ Update Race if required ]]--
			if (string.find(qcDynamicDB[qcQuestID][10], string.upper(qcRaces), 1, true) == nil) then
				qcDynamicDB[qcQuestID][10] = qcDynamicDB[qcQuestID][10] .. qcRaces
			end
		end
	end

end
end

function qcQuestDetail(qcAccept) -- Saves quest information to file for later use --

if (qcAccept == true) then

local qcQuestID
local qcQuestTitle
local qcPlayerXPos
local qcPlayerYPos
local qcNPCGUID
local qcNPCID
local qcNPCName
local qcQuestCategory
local qcIsTrivial
local qcIsDaily
local qcIsRepeatable

	qcQuestID = GetQuestID()
	qcNPCGUID, qcNPCID, qcNPCName = qcGetQuestNPCData()
	isTrivial, isDaily, isRepeatable = GetAvailableQuestInfo(GetQuestLogIndexByID(qcQuestID))
	qcQuestTitle = GetTitleText()
	qcQuestCategory = qcGetQuestCategory(qcQuestID)

	if (qcLoggerData[qcQuestID] == nil) then
		qcLoggerData[qcQuestID] = {}
	end
	if (qcLoggerData[qcQuestID]["A"] == nil) then
		qcLoggerData[qcQuestID]["A"] = {}
	end

	qcLoggerData[qcQuestID]["PC"] = qcPlayerEnglishClass
	qcLoggerData[qcQuestID]["PF"] = qcPlayerEnglishFaction
	qcLoggerData[qcQuestID]["PR"] = qcPlayerEnglishRace
	qcLoggerData[qcQuestID]["A"]["T"] = qcQuestTitle
	qcLoggerData[qcQuestID]["A"]["C"] = qcGetQuestCategory(qcQuestID)
	qcLoggerData[qcQuestID]["A"]["NPCGUID"] = qcNPCGUID
	qcLoggerData[qcQuestID]["A"]["NPCID"] = qcNPCID
	qcLoggerData[qcQuestID]["A"]["NPCN"] = qcNPCName
	qcLoggerData[qcQuestID]["A"]["Z"] = GetRealZoneText()
	qcLoggerData[qcQuestID]["A"]["iR"] = qcIsRepeatable
	qcLoggerData[qcQuestID]["A"]["iD"] = qcIsDaily
	qcLoggerData[qcQuestID]["A"]["V"] = QCADDON_VERSION

	qcPlayerXPos, qcPlayerYPos = GetPlayerMapPosition("player")
	qcLoggerData[qcQuestID]["A"]["PX"] = (qcPlayerXPos*100)
	qcLoggerData[qcQuestID]["A"]["PY"] = (qcPlayerYPos*100)

	for qcQuestDatabaseIndex, qcQuestDatabase in ipairs(qcQuestDatabases) do
		if (qcQuestDatabase[2] == qcQuestID) then
			-- This quest is already in our database --
			break
		else
			if (qcQuestDatabaseIndex == #qcQuestDatabases) then -- We have checked the entire database --
				--PlaySound("RaidWarning")
				qcLoggerData[qcQuestID]["NYI"] = QCADDON_VERSION
				print(QCADDON_CHAT_TITLE .. YELLOW_FONT_COLOR_CODE .. "Quest ID: " .. qcQuestID .. " does not exist in the database! Please send me your SavedVariables files next time you log out.")
				table.insert(qcUnknownQuests, qcQuestID)
			end
		end
	end

elseif (qcAccept == false) then -- Treat this as a quest being handed in or completed, not accepted --

local qcQuestID
local qcQuestTitle
local qcPlayerXPos
local qcPlayerYPos
local qcNPCGUID
local qcNPCID
local qcNPCName
local qcQuestCategory
local qcIsTrivial
local qcIsDaily
local qcIsRepeatable

	qcQuestID = GetQuestID()
	qcNPCGUID, qcNPCID, qcNPCName = qcGetQuestNPCData()
	isTrivial, isDaily, isRepeatable = GetAvailableQuestInfo(GetQuestLogIndexByID(qcQuestID))
	qcQuestTitle = GetTitleText()
	qcQuestCategory = qcGetQuestCategory(qcQuestID)

	if (qcLoggerData[qcQuestID] == nil) then
		qcLoggerData[qcQuestID] = {}
	end
	if (qcLoggerData[qcQuestID]["C"] == nil) then
		qcLoggerData[qcQuestID]["C"] = {}
	end

	qcLoggerData[qcQuestID]["PC"] = qcPlayerEnglishClass
	qcLoggerData[qcQuestID]["PF"] = playerEnglishFaction
	qcLoggerData[qcQuestID]["PR"] = qcPlayerEnglishRace
	qcLoggerData[qcQuestID]["C"]["T"] = qcQuestTitle
	qcLoggerData[qcQuestID]["C"]["C"] = qcGetQuestCategory(qcQuestID)
	qcLoggerData[qcQuestID]["C"]["NPCGUID"] = qcNPCGUID
	qcLoggerData[qcQuestID]["C"]["NPCID"] = qcNPCID
	qcLoggerData[qcQuestID]["C"]["NPCN"] = qcNPCName
	qcLoggerData[qcQuestID]["C"]["Z"] = GetRealZoneText()
	qcLoggerData[qcQuestID]["C"]["iR"] = qcIsRepeatable
	qcLoggerData[qcQuestID]["C"]["iD"] = qcIsDaily
	qcLoggerData[qcQuestID]["C"]["V"] = QCADDON_VERSION

	qcPlayerXPos, qcPlayerYPos = GetPlayerMapPosition("player")
	qcLoggerData[qcQuestID]["C"]["PX"] = (qcPlayerXPos*100)
	qcLoggerData[qcQuestID]["C"]["PY"] = (qcPlayerYPos*100)

	for qcQuestDatabaseIndex, qcQuestDatabase in ipairs(qcQuestDatabases) do
		if (qcQuestDatabase[2] == qcQuestID) then
			-- This quest is already in our database --
			break
		else
			if (qcQuestDatabaseIndex == #qcQuestDatabases) then -- We have checked the entire database --
				--PlaySound("RaidWarning")
				qcLoggerData[qcQuestID]["NYI"] = QCADDON_VERSION
				print(QCADDON_CHAT_TITLE .. YELLOW_FONT_COLOR_CODE .. "Quest ID: " .. qcQuestID .. " does not exist in the database!. Please send me your SavedVariables files next time you log out.")
				table.insert(qcUnknownQuests, qcQuestID)
			end
		end
	end

end

end

function qcGetQuestCategory(qcQuestID) -- Returns the category of a quest from the quest log --

local _S
local qcIsHeader
local qcHeader

local qcQuestIDIndex = GetQuestLogIndexByID(qcQuestID)

	if (qcQuestIDIndex == 0) then
		return nil
	end

	while (qcQuestIDIndex >= 1) do
		qcHeader, _S, _S, _S, qcIsHeader, _S, _S, _S, _S = GetQuestLogTitle(qcQuestIDIndex)
		if (qcIsHeader == 1) then return qcHeader end
		qcQuestIDIndex = qcQuestIDIndex - 1
	end

	return nil

end