--[[

	Quest Completist - qcDatabase.lua
	Written by: Alistair Maxwell

--]]

COLOUR_DEATHKNIGHT = "|cFFC41F3B"
COLOUR_DRUID = "|cFFFF7D0A"
COLOUR_HUNTER = "|cFFABD473"
COLOUR_MAGE = "|cFF69CCF0"
COLOUR_PALADIN = "|cFFF58CBA"
COLOUR_PRIEST = "|cFFFFFFFF"
COLOUR_ROGUE = "|cFFFFF569"
COLOUR_SHAMAN = "|cFF0070DE"
COLOUR_WARLOCK = "|cFF9482C9"
COLOUR_WARRIOR = "|cFFC79C6E"

qcContinents = {

	{1, "Kalimdor"},
	{2, "Eastern Kingdoms"},
	{3, "Outland"},
	{4, "Northrend"},
	{5, "Post-Cataclysm Zones"},
	{6, "Elsewhere in Azeroth"}, -- TODO: Need to check if Continent ID is correct --

}
qcDungeonCategories = {

	{10, "Classic"},
	{11, "The Burning Crusade"},
	{12, "Wrath of the Lich King"},
	{13, "Cataclysm"},
	{14, "Raids"},

}
qcMiscellaneousCategories = {

	{20, "Professions"},
	{21, "World Events"},
	{22, "Battlegrounds"},
	{23, "Specials"},

}
qcCategories = {
	{-1, "Epic"},
	{-1001, "Winter Veil"},
	{-1002, "Children's Week"},
	{-1003, "Hallow's End"},
	{-1004, "Love is in the Air"},
	{-1005, "Harvest Festival"},
	{-1006, "New Year's Eve"},
	{-1007, "Day of the Dead"},
	{-1008, "Pilgrim's Bounty"},
	{-101, "Fishing"},
	{-1010, "Dungeon Finder"},
	{-121, "Blacksmithing"},
	{-141, "Paladin"},
	{-161, "Mage"},
	{-162, "Rogue"},
	{-181, "Alchemy"},
	{-182, "Leatherworking"},
	{-201, "Engineering"},
	{-23, "Cataclysm"},
	{-24, "Herbalism"},
	{-241, "Tournament"},
	{-25, "Battlegrounds"},
	{-261, "Hunter"},
	{-262, "Priest"},
	{-263, "Druid"},
	{-264, "Tailoring"},
	{-304, "Cooking"},
	{-324, "First Aid"},
	{-344, "Legendary"},
	{-364, "Darkmoon Faire"},
	{-365, "Ahn'Qiraj War"},
	{-366, "Lunar Festival"},
	{-367, "Reputation"},
	{-368, "Invasion"},
	{-369, "Midsummer Fire Festival"},
	{-370, "Brewfest"},
	{-371, "Inscription"},
	{-372, "Death Knight"},
	{-373, "Jewelcrafting"},
	{-374, "Noblegarden"},
	{-377, "Archaeology"}, -- TODO: Need to check that Profession ID is correct --
	{-61, "Warlock"},
	{-81, "Warrior"},
	{-82, "Shaman"},
	{1, "Dun Morogh"},
	{10, "Duskwood"},
	{11, "Wetlands"},
	{1176, "Zul'Farrak"},
	{1196, "Utgarde Pinnacle"},
	{12, "Elwynn Forest"},
	{1216, "Blackmaw Hold"},
	{130, "Silverpine Forest"},
	{1337, "Uldaman"},
	{1377, "Silithus"},
	{139, "Eastern Plaguelands"},
	{14, "Durotar"},
	{141, "Teldrassil"},
	{1477, "Sunken Temple"},
	{148, "Darkshore"},
	{1497, "Undercity"},
	{15, "Dustwallow Marsh"},
	{1519, "Stormwind City"},
	{1537, "Ironforge"},
	{1581, "The Deadmines"},
	{1583, "Blackrock Spire"},
	{1584, "Blackrock Depths"},
	{16, "Azshara"},
	{1637, "Orgrimmar"},
	{1638, "Thunder Bluff"},
	{1657, "Darnassus"},
	{17, "Northern Barrens"},
	{1941, "Caverns of Time"},
	{1941, "Caverns of Time"},
	{1977, "Zul'Gurub"},
	{2017, "Stratholme"},
	{2057, "Scholomance"},
	{206, "Utgarde Keep"},
	{209, "Shadowfang Keep"},
	{210, "Icecrown"},
	{2100, "Maraudon"},
	{215, "Mulgore"},
	{2159, "Onyxia's Lair"},
	{2257, "Deeprun Tram"},
	{2366, "The Black Morass"},
	{2367, "Old Hillsbrad Foothills"},
	{2437, "Ragefire Chasm"},
	{25, "Blackrock Mountain"},
	{2557, "Dire Maul"},
	{2577, "Dire Maul"},
	{2597, "Alterac Valley"},
	{267, "Hillsbrad Foothills"},
	{2677, "Blackwing Lair"},
	{2717, "Molten Core"},
	{28, "Western Plaguelands"},
	{2817, "Crystalsong Forest"},
	{287, "Hillsbrad"},
	{3, "Badlands"},
	{3277, "Warsong Gulch"},
	{33, "Northern Stranglethorn"},
	{331, "Ashenvale"},
	{3358, "Arathi Basin"},
	{3428, "Temple of Ahn'Qiraj"},
	{3429, "Ruins of Ahn'Qiraj"},
	{3430, "Eversong Woods"},
	{3433, "Ghostlands"},
	{3456, "Naxxramas"},
	{3457, "Karazhan"},
	{3477, "Azjol-Nerub"},
	{3483, "Hellfire Peninsula"},
	{3487, "Silvermoon City"},
	{3518, "Nagrand"},
	{3519, "Terokkar Forest"},
	{3520, "Shadowmoon Valley"},
	{3521, "Zangarmarsh"},
	{3522, "Blade's Edge Mountains"},
	{3523, "Netherstorm"},
	{3524, "Azuremyst Isle"},
	{3525, "Bloodmyst Isle"},
	{3537, "Borean Tundra"},
	{3557, "The Exodar"},
	{3562, "Hellfire Ramparts"},
	{357, "Feralas"},
	{36, "Alterac Mountains"},
	{3606, "Hyjal Summit"},
	{361, "Felwood"},
	{368, "Echo Isles"},
	{3703, "Shattrath City"},
	{3711, "Sholazar Basin"},
	{3713, "The Blood Furnace"},
	{3714, "The Shattered Halls"},
	{3715, "The Steamvault"},
	{3716, "The Underbog"},
	{3717, "The Slave Pens"},
	{3789, "Shadow Labyrinth"},
	{3790, "Auchenai Crypts"},
	{3791, "Sethekk Halls"},
	{3792, "Mana-Tombs"},
	{38, "Loch Modan"},
	{3805, "Zul'Aman"},
	{3820, "Eye of the Storm"},
	{3836, "Magtheridon's Lair"},
	{3842, "Tempest Keep"},
	{3845, "Tempest Keep"},
	{3846, "The Arcatraz"},
	{3847, "The Botanica"},
	{3849, "The Mechanar"},
	{3905, "Coilfang Reservoir"},
	{393, "Darkspear Strand"},
	{394, "Grizzly Hills"},
	{3959, "Black Temple"},
	{4, "Blasted Lands"},
	{40, "Westfall"},
	{400, "Thousand Needles"},
	{405, "Desolace"},
	{406, "Stonetalon Mountains"},
	{4075, "Sunwell Plateau"},
	{4080, "Isle of Quel'Danas"},
	{4095, "Magisters' Terrace"},
	{41, "Deadwind Pass"},
	{4100, "The Culling of Stratholme"},
	{4120, "The Nexus"},
	{4196, "Drak'Tharon Keep"},
	{4197, "Wintergrasp"},
	{4228, "The Oculus"},
	{4264, "Halls of Stone"},
	{4272, "Halls of Lightning"},
	{4273, "Ulduar"},
	{4375, "Gundrak"},
	{4384, "Strand of the Ancients"},
	{4395, "Dalaran"},
	{44, "Redridge Mountains"},
	{440, "Tanaris"},
	{4411, "Stormwind Harbor"},
	{4415, "The Violet Hold"},
	{4493, "The Obsidian Sanctum"},
	{4494, "Ahn'kahet: The Old Kingdom"},
	{45, "Arathi Highlands"},
	{4500, "The Eye of Eternity"},
	{46, "Burning Steppes"},
	{47, "The Hinterlands"},
	{4706, "Ruins of Gilneas"},
	{4707, "The Lost Isles"},
	{4709, "Southern Barrens"},
	{4710, "Isle of Conquest"},
	{4714, "Gilneas"},
	{4720, "The Lost Isles"},
	{4722, "Trial of the Crusader"},
	{4723, "Trial of the Champion"},
	{4742, "Hrothgar's Landing"},
	{4755, "Gilneas City"},
	{4809, "The Forge of Souls"},
	{4812, "Icecrown Citadel"},
	{4813, "Pit of Saron"},
	{4815, "Kelp'thar Forest"},
	{4820, "Halls of Reflection"},
	{490, "Un'Goro Crater"},
	{491, "Razorfen Kraul"},
	{4922, "Twilight Highlands"},
	{4926, "Blackrock Caverns"},
	{493, "Moonglade"},
	{4945, "Halls of Origination"},
	{495, "Howling Fjord"},
	{4950, "Grim Batol"},
	{4953, "Kelp'thar Forest"},
	{4987, "The Ruby Sanctum"},
	{5004, "Throne of the Tides"},
	{5034, "Uldum"},
	{5035, "The Vortex Pinnacle"},
	{5042, "Deepholm"},
	{5088, "The Stonecore"},
	{5095, "Tol Barad"},
	{51, "Searing Gorge"},
	{5144, "Shimmering Expanse"},
	{5145, "Abyssal Depths"},
	{5146, "Vashj'ir"},
	{5287, "The Cape of Stranglethorn"},
	{5396, "Lost City of the Tol'vir"},
	{5416, "The Maelstrom"},
	{5630, "The Maelstrom"},
	{616, "Mount Hyjal"},
	{618, "Winterspring"},
	{65, "Dragonblight"},
	{66, "Zul'Drak"},
	{67, "The Storm Peaks"},
	{717, "The Stockade"},
	{718, "Wailing Caverns"},
	{719, "Blackfathom Deeps"},
	{721, "Gnomeregan"},
	{722, "Razorfen Downs"},
	{796, "Scarlet Monastery"},
	{8, "Swamp of Sorrows"},
	{85, "Tirisfal Glades"},
	{95, "Redridge Canyons"},
	{989, "Ruins of Uldum"},
	{-1000, "Coldridge Valley"},

}
qcZones = {

	-- Kalimdor --
	--{1, 5695, "Ahn'Qiraj: The Fallen Kingdom"}, -- Not showing on Wowhead --
	{1, 331, "Ashenvale"},
	{1, 16, "Azshara"},
	{1, 3524, "Azuremyst Isle"},
	{1, 1216, "Blackmaw Hold"},
	{1, 3525, "Bloodmyst Isle"},
	{1, 148, "Darkshore"},
	{1, 393, "Darkspear Strand"},
	{1, 1657, "Darnassus"},
	{1, 405, "Desolace"},
	{1, 2577, "Dire Maul"},
	{1, 14, "Durotar"},
	{1, 15, "Dustwallow Marsh"},
	{1, 368, "Echo Isles"},
	{1, 361, "Felwood"},
	{1, 357, "Feralas"},
	{1, 493, "Moonglade"},
	{1, 616, "Mount Hyjal"},
	{1, 215, "Mulgore"},
	{1, 17, "Northern Barrens"},
	{1, 1637, "Orgrimmar"},
	{1, 989, "Ruins of Uldum"},
	{1, 1377, "Silithus"},
	{1, 4709, "Southern Barrens"},
	{1, 406, "Stonetalon Mountains"},
	{1, 440, "Tanaris"},
	{1, 141, "Teldrassil"},
	{1, 3557, "The Exodar"},
	{1, 4707, "The Lost Isles"},
	--{1, 5706, "The Steam Pools"}, -- Not showing on Wowhead --
	{1, 400, "Thousand Needles"},
	{1, 1638, "Thunder Bluff"},
	{1, 5034, "Uldum"},
	--{1, 1216, "Timbermaw Hold"}, -- Not showing on Wowhead --
	{1, 490, "Un'Goro Crater"},
	{1, 618, "Winterspring"},

	--[[ Eastern Kingdoms ]]--
	{2, 36, "Alterac Mountains"},
	{2, 45, "Arathi Highlands"},
	{2, 3, "Badlands"},
	{2, 25, "Blackrock Mountain"},
	{2, 4, "Blasted Lands"},
	{2, 46, "Burning Steppes"},
	--{2, 279, "Dalaran Crater"}, -- Not Showing on Wowhead --
	{2, 41, "Deadwind Pass"},
	{2, 2257, "Deeprun Tram"},
	{2, 1, "Dun Morogh"},
	{2, 10, "Duskwood"},
	{2, 139, "Eastern Plaguelands"},
	{2, 12, "Elwynn Forest"},
	{2, 3430, "Eversong Woods"},
	{2, 3433, "Ghostlands"},
	{2, 287, "Hillsbrad"},
	{2, 267, "Hillsbrad Foothills"},
	{2, 1537, "Ironforge"},
	{2, 4080, "Isle of Quel'Danas"},
	{2, 38, "Loch Modan"},
	{2, 33, "Northern Stranglethorn"},
	--{2, 4298, "Plaguelands: The Scarlet Enclave"}, -- Not Showing on Wowhead --
	{2, 95, "Redridge Canyons"},
	{2, 44, "Redridge Mountains"},
	{2, 51, "Searing Gorge"},
	{2, 3487, "Silvermoon City"},
	{2, 130, "Silverpine Forest"},
	{2, 1519, "Stormwind City"},
	{2, 4411, "Stormwind Harbor"},
	{2, 8, "Swamp of Sorrows"},
	{2, 5287, "The Cape of Stranglethorn"},
	{2, 47, "The Hinterlands"},
	{2, 85, "Tirisfal Glades"},
	{2, 1497, "Undercity"},
	{2, 28, "Western Plaguelands"},
	{2, 40, "Westfall"},
	{2, 11, "Wetlands"},

	-- Outland --
	{3, 3522, "Blade's Edge Mountains"},
	{3, 3483, "Hellfire Peninsula"},
	{3, 3518, "Nagrand"},
	{3, 3523, "Netherstorm"},
	{3, 3520, "Shadowmoon Valley"},
	{3, 3703, "Shattrath City"},
	{3, 3679, "Skettis"}, -- Not showing on Wowhead --
	{3, 3519, "Terokkar Forest"},
	{3, 3521, "Zangarmarsh"},

	-- Northrend --
	{4, 3537, "Borean Tundra"},
	{4, 4024, "Coldarra"}, -- Not showing on Wowhead --
	{4, 2817, "Crystalsong Forest"},
	{4, 4395, "Dalaran"},
	{4, 65, "Dragonblight"},
	{4, 394, "Grizzly Hills"},
	{4, 495, "Howling Fjord"},
	{4, 4742, "Hrothgar's Landing"},
	{4, 210, "Icecrown"},
	{4, 3711, "Sholazar Basin"},
	{4, 67, "The Storm Peaks"},
	{4, 4197, "Wintergrasp"},
	{4, 66, "Zul'Drak"},

	-- Post Cata Zones --
	{5, 5145, "Abyssal Depths"},
	{5, 4714, "Gilneas"},
	{5, 4755, "Gilneas City"},
	{5, 4815, "Kelp'thar Forest"},
	{5, 4953, "Kelp'thar Forest"},
	{5, 4706, "Ruins of Gilneas"},
	{5, 5144, "Shimmering Expanse"},
	{5, 4922, "Twilight Highlands"},
	{5, 5146, "Vashj'ir"},

	-- Elsewhere in Azeroth --
	{6, 5042, "Deepholm"},
	{6, 4737, "Kezan"}, -- Not showing on Wowhead --
	{6, 4720, "The Lost Isles"},
	{6, 5416, "The Maelstrom"},
	{6, 5630, "The Maelstrom"},
	{6, 5095, "Tol Barad"},

}
qcDungeons = {

	-- Classic --
	{10, 719, "Blackfathom Deeps"},
	{10, 1584, "Blackrock Depths"},
	{10, 1583, "Blackrock Spire"},
	{10, 2557, "Dire Maul"},
	{10, 721, "Gnomeregan"},
	{10, 2100, "Maraudon"},
	{10, 2437, "Ragefire Chasm"},
	{10, 722, "Razorfen Downs"},
	{10, 491, "Razorfen Kraul"},
	{10, 796, "Scarlet Monastery"},
	{10, 2057, "Scholomance"},
	{10, 209, "Shadowfang Keep"},
	{10, 2017, "Stratholme"},
	{10, 1477, "Sunken Temple"},
	{10, 1581, "The Deadmines"},
	{10, 717, "The Stockade"},
	{10, 1337, "Uldaman"},
	{10, 718, "Wailing Caverns"},
	{10, 1176, "Zul'Farrak"},

	-- The Burning Crusade --
	{11, 3790, "Auchenai Crypts"},
	{11, 1941, "Caverns of Time"},
	{11, 3905, "Coilfang Reservoir"},
	{11, 3562, "Hellfire Ramparts"},
	{11, 4095, "Magisters' Terrace"},
	{11, 3792, "Mana-Tombs"},
	{11, 2367, "Old Hillsbrad Foothills"},
	{11, 3791, "Sethekk Halls"},
	{11, 3789, "Shadow Labyrinth"},
	{11, 3845, "Tempest Keep"},
	{11, 3846, "The Arcatraz"},
	{11, 2366, "The Black Morass"},
	{11, 3713, "The Blood Furnace"},
	{11, 3847, "The Botanica"},
	{11, 3849, "The Mechanar"},
	{11, 3714, "The Shattered Halls"},
	{11, 3717, "The Slave Pens"},
	{11, 3715, "The Steamvault"},
	{11, 3716, "The Underbog"},

	-- Wrath of the Lich King --
	{12, 4494, "Ahn'kahet: The Old Kingdom"},
	{12, 3477, "Azjol-Nerub"},
	{12, 1941, "Caverns of Time"},
	{12, 4196, "Drak'Tharon Keep"},
	{12, 4375, "Gundrak"},
	{12, 4272, "Halls of Lightning"},
	{12, 4820, "Halls of Reflection"},
	{12, 4264, "Halls of Stone"},
	{12, 4813, "Pit of Saron"},
	{12, 4100, "The Culling of Stratholme"},
	{12, 4809, "The Forge of Souls"},
	{12, 4120, "The Nexus"},
	{12, 4228, "The Oculus"},
	{12, 4415, "The Violet Hold"},
	{12, 4723, "Trial of the Champion"},
	{12, 206, "Utgarde Keep"},
	{12, 1196, "Utgarde Pinnacle"},

	--[[ Cataclysm ]]--
	{13, 4926, "Blackrock Caverns"},
	{13, 4950, "Grim Batol"},
	{13, 4945, "Halls of Origination"},
	{13, 5396, "Lost City of the Tol'vir"},
	{13, 5088, "The Stonecore"},
	{13, 5035, "The Vortex Pinnacle"},
	{13, 5004, "Throne of the Tides"},

	-- Raids --
	{14, 3959, "Black Temple"},
	{14, 2677, "Blackwing Lair"},
	{14, 3606, "Hyjal Summit"},
	{14, 4812, "Icecrown Citadel"},
	{14, 3457, "Karazhan"},
	{14, 3836, "Magtheridon's Lair"},
	{14, 2717, "Molten Core"},
	{14, 3456, "Naxxramas"},
	{14, 2159, "Onyxia's Lair"},
	{14, 3429, "Ruins of Ahn'Qiraj"},
	{14, 4075, "Sunwell Plateau"},
	{14, 3842, "Tempest Keep"},
	{14, 3428, "Temple of Ahn'Qiraj"},
	{14, 4500, "The Eye of Eternity"},
	{14, 4493, "The Obsidian Sanctum"},
	{14, 4987, "The Ruby Sanctum"},
	{14, 4722, "Trial of the Crusader"},
	{14, 4273, "Ulduar"},
	{14, 3805, "Zul'Aman"},
	{14, 1977, "Zul'Gurub"},

}
qcProfessions = {

	{20, -181, "Alchemy"},
	{20, -377, "Archaeology"}, -- TODO: Need to check that Profession ID is correct --
	{20, -121, "Blacksmithing"},
	{20, -304, "Cooking"},
	{20, -201, "Engineering"},
	{20, -324, "First Aid"},
	{20, -101, "Fishing"},
	{20, -24, "Herbalism"},
	{20, -371, "Inscription"},
	{20, -373, "Jewelcrafting"},
	{20, -182, "Leatherworking"},
	{20, -264, "Tailoring"},

}
qcWorldEvents = {

	{21, -370, "Brewfest"},
	{21, -1002, "Children's Week"},
	{21, -364, "Darkmoon Faire"},
	{21, -1007, "Day of the Dead"},
	{21, -1003, "Hallow's End"},
	{21, -1005, "Harvest Festival"},
	{21, -1004, "Love is in the Air"},
	{21, -366, "Lunar Festival"},
	{21, -369, "Midsummer Fire Festival"},
	{21, -1006, "New Year's Eve"},
	{21, -374, "Noblegarden"},
	{21, -1008, "Pilgrim's Bounty"},
	{21, -1001, "Winter Veil"},

}
qcBattlegrounds = {

	{22, 3358, "Arathi Basin"},
	{22, 2597, "Alterac Valley"},
	{22, -25, "Battlegrounds"},
	{22, 3820, "Eye of the Storm"},
	{22, 4710, "Isle of Conquest"},
	{22, 4384, "Strand of the Ancients"},
	{22, 3277, "Warsong Gulch"},

}
qcSpecials = {

	{23, -365, "Ahn'Qiraj War"},
	{23, -23, "Cataclysm"},
	{23, -1010, "Dungeon Finder"},
	{23, -1, "Epic"},
	{23, -344, "Legendary"},
	{23, -367, "Reputation"},
	{23, -368, "Invasion"},
	{23, -241, "Tournament"},
	{23, 99999, "FLAG Quests"},

}
qcClasses = {

	{30, -372, "Death Knight", COLOUR_DEATHKNIGHT},
	{30, -263, "Druid", COLOUR_DRUID},
	{30, -261, "Hunter", COLOUR_HUNTER},
	{30, -161, "Mage", COLOUR_MAGE},
	{30, -141, "Paladin", COLOUR_PALADIN},
	{30, -262, "Priest", COLOUR_PRIEST},
	{30, -162, "Rogue", COLOUR_ROGUE},
	{30, -82, "Shaman", COLOUR_SHAMAN},
	{30, -61, "Warlock", COLOUR_WARLOCK},
	{30, -81, "Warrior", COLOUR_WARRIOR},

}
qcQuestDatabases = { -- [[Zone ID, Quest ID, Quest Type (1:Normal, 2:Repeatable, 3:Daily, 4:Special 5:Weekly), Recommended Level, Quest Title, Faction, ClassBased (1:Yes 2:No), ClassType, RaceBased (1:Yes, 2:No), RaceType ]]--

	[26511] = {
		44,
		26511,
		1,
		16,
		"Lake Everstill Clean Up",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			900,
			"Bailiff Conacher",
			"Redridge Mountains",
			28.7,
			40.9,
		},
	},
	[26543] = {
		-101,
		26543,
		3,
		11,
		"Clammy Hands",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			43239,
			"Razgar",
			"Orgrimmar",
			65.90000000000001,
			40.9,
		},
	},
	[26607] = {
		44,
		26607,
		1,
		18,
		"They Drew First Blood",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			43221,
			"Colonel Troteman",
			"Redridge Mountains",
			28.6,
			40.8,
		},
	},
	[26639] = {
		44,
		26639,
		1,
		18,
		"Point of Contact: Brubaker",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			43458,
			"John J. Keeshan",
			"Redridge Mountains",
			52.5,
			55.4,
		},
	},
	[26671] = {
		10,
		26671,
		1,
		23,
		"The Fate of Stalvan Mistmantle",
		"A",
		2,
		"WARLOCKSHAMAN",
		2,
		"HUMANDWARF",
		{
			267,
			"Clerk Daltry",
			"Duskwood",
			72.5,
			46.9,
		},
	},
	[26703] = {
		5287,
		26703,
		1,
		35,
		"Bloodsail's End",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2496,
			"Baron Revilgaz",
			"The Cape of Stranglethorn",
			41,
			73.3,
		},
	},
	[26735] = {
		33,
		26735,
		1,
		25,
		"The Fate of Kurzen",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			469,
			"Lieutenant Doren",
			"Northern Stranglethorn",
			47.6,
			10.3,
		},
	},
	[24720] = {
		490,
		24720,
		1,
		52,
		"Crystals of Power",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			9117,
			"J.D. Collie",
			"Un'Goro Crater",
			54.2,
			62.4,
		},
	},
	[3105] = {
		-61,
		3105,
		1,
		3,
		"Tainted Letter",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			197,
			"Marshal McBride",
			"Elwynn Forest",
			48.2,
			42.1,
		},
	},
	[24944] = {
		4709,
		24944,
		1,
		30,
		"Back in the Fight",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38804,
			"Tolliver Houndstooth",
			"Southern Barrens",
			67,
			46.8,
		},
	},
	[25008] = {
		4709,
		25008,
		1,
		31,
		"Filthy Animals",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38873,
			"Goucho",
			"Southern Barrens",
			56,
			42.5,
		},
	},
	[25072] = {
		440,
		25072,
		1,
		47,
		"A Few Good Goblins",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38706,
			"Zeke Bootscuff",
			"Tanaris",
			55.7,
			60.8,
		},
	},
	[25104] = {
		4709,
		25104,
		1,
		34,
		"Digsite Status",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			39118,
			"General Twinbraid",
			"Southern Barrens",
			43.6,
			78.3,
		},
	},
	[27183] = {
		15,
		27183,
		1,
		36,
		"Marsh Frog Legs",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			4792,
			"\"Swamp Eye\" Jarl",
			"Dustwallow Marsh",
			55.5,
			26.4,
		},
	},
	[27215] = {
		15,
		27215,
		1,
		36,
		"The Hermit of Swamplight Manor",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23835,
			"Sergeant Amelyn",
			"Dustwallow Marsh",
			68.3,
			51.8,
		},
	},
	[25264] = {
		14,
		25264,
		1,
		13,
		"Ak'Zeloth",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			3216,
			"Neeru Fireblade",
			"Orgrimmar",
			50,
			59,
		},
	},
	[27407] = {
		15,
		27407,
		1,
		39,
		"[39] [39] Bloodfen Feathers",
		"A",
		2,
		"PALADINDRUID",
		2,
		"DRAENEINIGHTELF",
		{
			23579,
			"Brogg",
			"Dustwallow Marsh",
			41.8,
			73.90000000000001,
		},
	},
	[27471] = {
		1583,
		27471,
		1,
		58,
		"Blackrock Anomaly",
		"A",
		2,
		"MAGEPALADIN",
		2,
		"DRAENEIHUMAN",
		{
			9562,
			"Helendis Riverhorn",
			"Burning Steppes",
			73.3,
			66.40000000000001,
		},
	},
	[27535] = {
		139,
		27535,
		1,
		44,
		"Just a Little Touched",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			45828,
			"Argent Apothecary Judkins",
			"Eastern Plaguelands",
			17.8,
			27.9,
		},
	},
	[25616] = {
		406,
		25616,
		1,
		26,
		"Hellscream's Legacy",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			34354,
			"Huntress Jalin",
			"Ashenvale",
			35.1,
			71.59999999999999,
		},
	},
	[25648] = {
		14,
		25648,
		1,
		10,
		"Beyond Durotar",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			39379,
			"Gor the Enforcer",
			"Durotar",
			45,
			14.7,
		},
	},
	[25680] = {
		4,
		25680,
		1,
		55,
		"That's Not Us",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			41134,
			"Tak'arili",
			"Blasted Lands",
			62.2,
			1.5,
		},
	},
	[25712] = {
		4,
		25712,
		1,
		55,
		"Nethergarde Reigns",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			42262,
			"Leyan Steelson",
			"Blasted Lands",
			60.2,
			13.4,
		},
	},
	[25744] = {
		400,
		25744,
		1,
		41,
		"[41] [41] Negotiations",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			40027,
			"Fizzle Brassbolts",
			"Thousand Needles",
			75.90000000000001,
			74.59999999999999,
		},
	},
	[25808] = {
		406,
		25808,
		1,
		28,
		"Is This Thing On?",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			[3] = "Stonetalon Mountains",
			[4] = 69.7,
			[5] = 72,
		},
	},
	[27983] = {
		51,
		27983,
		1,
		48,
		"Lunk's Adventure: Cranky Little Dwarfs",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			47332,
			"Lunk",
			"Searing Gorge",
			42.4,
			40.6,
		},
	},
	[28047] = {
		400,
		28047,
		1,
		41,
		"[41] [41] Freezing the Pipes",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			47383,
			"Brivelthwerp",
			"Thousand Needles",
			69.90000000000001,
			85.09999999999999,
		},
	},
	[26064] = {
		406,
		26064,
		1,
		28,
		"Fight On Their Stomachs",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			3411,
			"Denni'ka",
			"Stonetalon Mountains",
			72,
			91.2,
		},
	},
	[26160] = {
		4,
		26160,
		1,
		55,
		"Blood Ritual",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			42298,
			"Kasim Sharim",
			"Blasted Lands",
			62.6,
			26.1,
		},
	},
	[28239] = {
		46,
		28239,
		1,
		50,
		"Into the Black Tooth Hovel",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			48109,
			"John J. Keeshan",
			"Burning Steppes",
			46.4,
			45.9,
		},
	},
	[26288] = {
		40,
		26288,
		1,
		14,
		"Jango Spothide",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			821,
			"Captain Danuvin",
			"Westfall",
			56.4,
			47.6,
		},
	},
	[26320] = {
		40,
		26320,
		1,
		15,
		"A Vision of the Past",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			42651,
			"Thoralius the Wise",
			"Westfall",
			42.9,
			65,
		},
	},
	[28431] = {
		46,
		28431,
		1,
		50,
		"A Perfect Costume",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48001,
			"Thelaron Direneedle",
			"Burning Steppes",
			0,
			0,
		},
	},
	[26416] = {
		33,
		26416,
		1,
		25,
		"Well, Come to the Jungle",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			43063,
			"Cromula",
			"Ashenvale",
			49.6,
			67.09999999999999,
		},
	},
	[26448] = {
		331,
		26448,
		1,
		21,
		"Destroy the Legion",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			17355,
			"Valusha",
			"Ashenvale",
			73.2,
			60,
		},
	},
	[26512] = {
		44,
		26512,
		1,
		16,
		"Tuning the Gnomecorder",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			344,
			"Magistrate Solomon",
			"Redridge Mountains",
			28.9,
			41,
		},
	},
	[26544] = {
		44,
		26544,
		1,
		16,
		"They've Wised Up...",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			[3] = "Redridge Mountains",
			[4] = 33.1,
			[5] = 26.2,
		},
	},
	[24529] = {
		4709,
		24529,
		1,
		32,
		"Bad to Worse",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			11857,
			"Makaba Flathoof",
			"Southern Barrens",
			44.2,
			33.7,
		},
	},
	[9214] = {
		3433,
		9214,
		1,
		18,
		"Shadowpine Weaponry",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			16220,
			"Captain Helios",
			"Ghostlands",
			72.40000000000001,
			29.7,
		},
	},
	[26640] = {
		44,
		26640,
		1,
		18,
		"Unspeakable Atrocities",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			43508,
			"Brubaker",
			"Redridge Mountains",
			53.1,
			67.8,
		},
	},
	[28719] = {
		618,
		28719,
		1,
		53,
		"A Little Gamy",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			[3] = "Winterspring",
			[4] = 57.2,
			[5] = 33.4,
		},
	},
	[26736] = {
		33,
		26736,
		1,
		25,
		"Spared from Madness",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			469,
			"Lieutenant Doren",
			"Northern Stranglethorn",
			47.6,
			10.3,
		},
	},
	[24721] = {
		490,
		24721,
		1,
		53,
		"The Eastern Pylon",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38263,
			"Ithis Moonwarden",
			"Un'Goro Crater",
			76.90000000000001,
			49.2,
		},
	},
	[28847] = {
		618,
		28847,
		1,
		54,
		"The Pursuit of Umbranse",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			50366,
			"Nymn",
			"Winterspring",
			59.7,
			50.5,
		},
	},
	[9374] = {
		3483,
		9374,
		1,
		62,
		"Arelion's Journal",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16793,
			"Magistrix Carinda",
			"Hellfire Peninsula",
			26.4,
			60.3,
		},
	},
	[9406] = {
		3483,
		9406,
		1,
		62,
		"The Mag'har",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16845,
			"Gorkan Bloodfist",
			"Hellfire Peninsula",
			32,
			27.9,
		},
	},
	[25041] = {
		4709,
		25041,
		1,
		32,
		"Lion's Pride",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			39003,
			"Sam Trawley",
			"Southern Barrens",
			49.8,
			50.5,
		},
	},
	[13564] = {
		148,
		13564,
		1,
		11,
		"A Lost Companion",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			32960,
			"Volcor",
			"Darkshore",
			50.9,
			18.1,
		},
	},
	[13580] = {
		148,
		13580,
		1,
		17,
		"Soothing the Elements",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			33117,
			"Elder Brownpaw",
			"Darkshore",
			40.9,
			56.5,
		},
	},
	[27184] = {
		15,
		27184,
		1,
		36,
		"Jarl Needs Eyes",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			4792,
			"\"Swamp Eye\" Jarl",
			"Dustwallow Marsh",
			55.4,
			26.3,
		},
	},
	[27216] = {
		15,
		27216,
		1,
		36,
		"This Old Lighthouse",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23835,
			"Sergeant Amelyn",
			"Dustwallow Marsh",
			68.3,
			51.7,
		},
	},
	[27248] = {
		15,
		27248,
		1,
		39,
		"Mission to Mudsprocket",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23951,
			"Lieutenant Aden",
			"Dustwallow Marsh",
			65,
			47.1,
		},
	},
	[27408] = {
		15,
		27408,
		1,
		39,
		"Banner of the Stonemaul",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23579,
			"Brogg",
			"Dustwallow Marsh",
			41.9,
			73.8,
		},
	},
	[25521] = {
		440,
		25521,
		1,
		46,
		"I'm With Scorpid",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			40580,
			"Gus Rustflutter",
			"Tanaris",
			42.5,
			24.3,
		},
	},
	[25585] = {
		400,
		25585,
		1,
		41,
		"[41] [41] Quiet the Cannons",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			40475,
			"Jinky Twizzlefixxit",
			"Thousand Needles",
			76.5,
			73.7,
		},
	},
	[25649] = {
		406,
		25649,
		1,
		26,
		"Minx'll Fix It",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			40879,
			"Boog the \"Gear Whisperer\"",
			"Stonetalon Mountains",
			72.5,
			61.5,
		},
	},
	[9774] = {
		3521,
		9774,
		1,
		62,
		"Thick Hydra Scales",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			18011,
			"Zurai",
			"Zangarmarsh",
			85.3,
			54.7,
		},
	},
	[25713] = {
		4,
		25713,
		1,
		55,
		"Remove Their Arms",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			42264,
			"Buttonwillow McKittrick",
			"Blasted Lands",
			60.4,
			13.8,
		},
	},
	[13900] = {
		148,
		13900,
		1,
		20,
		"The Offering to Azshara",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			34423,
			"Warlord Wrathspine",
			"Darkshore",
			32.3,
			85.5,
		},
	},
	[25809] = {
		406,
		25809,
		1,
		28,
		"Leave No Man Behind! ",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			41282,
			"Corporal Wocard",
			"Stonetalon Mountains",
			72,
			75.90000000000001,
		},
	},
	[13948] = {
		148,
		13948,
		1,
		19,
		"Stepping Up Surveillance",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			[3] = "Darkshore",
			[4] = 40.6,
			[5] = 84.5,
		},
	},
	[13980] = {
		331,
		13980,
		1,
		25,
		"They're Out There!",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			34596,
			"Foreman Jinx",
			"Ashenvale",
			46.1,
			63.3,
		},
	},
	[27984] = {
		51,
		27984,
		1,
		48,
		"Lunthistle's Tale",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			8436,
			"Zamael Lunthistle",
			"Searing Gorge",
			29.7,
			26.3,
		},
	},
	[28048] = {
		400,
		28048,
		1,
		42,
		"[42] [42] That Smart One's Gotta Go",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			47383,
			"Brivelthwerp",
			"Thousand Needles",
			69.90000000000001,
			85.09999999999999,
		},
	},
	[26097] = {
		406,
		26097,
		1,
		30,
		"Proof of Lies",
		"H",
		2,
		"WARLOCKPALADIN",
		2,
		"SCOURGEBLOODELF",
		{
			42039,
			"High Chieftain Cliffwalker",
			"Stonetalon Mountains",
			45.1,
			32.8,
		},
	},
	[26161] = {
		4,
		26161,
		1,
		56,
		"Not Just Any Body",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			42298,
			"Kasim Sharim",
			"Blasted Lands",
			62.3,
			26.3,
		},
	},
	[26257] = {
		40,
		26257,
		1,
		13,
		"It's Alive!",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			233,
			"Farmer Saldean",
			"Westfall",
			56,
			31.3,
		},
	},
	[26289] = {
		40,
		26289,
		1,
		14,
		"Find Agent Kearnen",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			234,
			"Marshal Gryan Stoutmantle",
			"Westfall",
			56.3,
			47.5,
		},
	},
	[28368] = {
		361,
		28368,
		1,
		49,
		"Fire in the Hole!",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			[3] = "Felwood",
			[4] = 60.4,
			[5] = 22.3,
		},
	},
	[26353] = {
		40,
		26353,
		1,
		13,
		"Captain Sanders' Hidden Treasure",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Westfall",
			[4] = 56.3,
			[5] = 10.5,
		},
	},
	[28432] = {
		46,
		28432,
		1,
		50,
		"Into the Black Tooth Hovel",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48568,
			"Eitrigg",
			"Burning Steppes",
			44.6,
			44.5,
		},
	},
	[26449] = {
		331,
		26449,
		1,
		22,
		"Never Again!",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			17355,
			"Valusha",
			"Ashenvale",
			73.2,
			60.1,
		},
	},
	[26481] = {
		331,
		26481,
		1,
		26,
		"A New Adornment",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			3897,
			"Krolg",
			"Ashenvale",
			50.9,
			75.09999999999999,
		},
	},
	[26513] = {
		44,
		26513,
		1,
		16,
		"Like a Fart in the Wind",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			382,
			"Marshal Marris",
			"Redridge Mountains",
			31.8,
			44.9,
		},
	},
	[26545] = {
		44,
		26545,
		1,
		16,
		"Yowler Must Die!",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			[3] = "Redridge Mountains",
			[4] = 17.5,
			[5] = 18.2,
		},
	},
	[28624] = {
		618,
		28624,
		1,
		52,
		"Kilram's Boast",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			11192,
			"Kilram",
			"Winterspring",
			59.8,
			49.2,
		},
	},
	[28656] = {
		618,
		28656,
		1,
		51,
		"Strange Life Forces",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			[3] = "Winterspring",
			[4] = 35.1,
			[5] = 56.3,
		},
	},
	[14364] = {
		405,
		14364,
		1,
		31,
		"Putting Their Heads Together",
		"A",
		2,
		"WARLOCK",
		2,
		"GNOME",
		{
			[3] = "Desolace",
			[4] = 52.8,
			[5] = 29.4,
		},
	},
	[10286] = {
		3483,
		10286,
		1,
		62,
		"Arelion's Secret",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16793,
			"Magistrix Carinda",
			"Hellfire Peninsula",
			26.4,
			60.3,
		},
	},
	[26737] = {
		33,
		26737,
		1,
		25,
		"Stopping Kurzen's Legacy",
		"A",
		2,
		"DRUIDWARLOCK",
		2,
		"NIGHTELFHUMAN",
		{
			469,
			"Lieutenant Doren",
			"Northern Stranglethorn",
			47.5,
			10.4,
		},
	},
	[24722] = {
		490,
		24722,
		1,
		53,
		"The Northern Pylon",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38275,
			"Gremix",
			"Un'Goro Crater",
			43.1,
			41.5,
		},
	},
	[28848] = {
		618,
		28848,
		1,
		51,
		"Trailing the Spiritspeaker",
		"HA",
		2,
		"PRIESTPALADINDRUID",
		2,
		"SCOURGEHUMANTROLL",
		{
			10920,
			"Kelek Skykeeper",
			"Winterspring",
			46.9,
			53.9,
		},
	},
	[26865] = {
		2437,
		26865,
		1,
		13,
		"Enemies Below",
		"H",
		2,
		"DRUIDPRIEST",
		2,
		"TROLLSCOURGE",
		{
			39605,
			"Garrosh Hellscream",
			"Orgrimmar",
			48.2,
			70.59999999999999,
		},
	},
	[5201] = {
		618,
		5201,
		1,
		60,
		"Winterfall Intrusion",
		"A",
		2,
		"HUNTER",
		2,
		"DRAENEI",
		{
			10618,
			"Rivern Frostwind",
			"Winterspring",
			46.7,
			17.7,
		},
	},
	[27057] = {
		28,
		27057,
		1,
		38,
		"Return to the Stead",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			[3] = "Western Plaguelands",
			[4] = 62.5,
			[5] = 58.7,
		},
	},
	[25042] = {
		4709,
		25042,
		1,
		32,
		"Marching On Our Stomachs",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			39003,
			"Sam Trawley",
			"Southern Barrens",
			49.8,
			50.5,
		},
	},
	[25074] = {
		4709,
		25074,
		1,
		33,
		"Meet Me at Triumph",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38323,
			"General Hawthorne",
			"Southern Barrens",
			49.9,
			49.6,
		},
	},
	[25106] = {
		4709,
		25106,
		1,
		34,
		"Hands Off Me Dig!",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			39155,
			"Marley Twinbraid",
			"Southern Barrens",
			47.2,
			88.5,
		},
	},
	[27217] = {
		15,
		27217,
		1,
		36,
		"Thresher Oil",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23892,
			"Babs Fizzletorque",
			"Dustwallow Marsh",
			72.09999999999999,
			47.1,
		},
	},
	[27249] = {
		15,
		27249,
		1,
		37,
		"Inspecting the Ruins",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			4944,
			"Captain Garran Vimes",
			"Dustwallow Marsh",
			68.2,
			48.5,
		},
	},
	[12637] = {
		66,
		12637,
		1,
		75,
		"Near Miss",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			28518,
			"Stefan Vadu",
			"Zul'Drak",
			14.1,
			73.7,
		},
	},
	[27409] = {
		15,
		27409,
		1,
		39,
		"The Essence of Enmity",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23579,
			"Brogg",
			"Dustwallow Marsh",
			41.9,
			73.8,
		},
	},
	[25522] = {
		440,
		25522,
		1,
		46,
		"Gargantapid",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			40580,
			"Gus Rustflutter",
			"Tanaris",
			42.4,
			24.3,
		},
	},
	[25650] = {
		406,
		25650,
		1,
		26,
		"Orders from High Command",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			40881,
			"Minx",
			"Stonetalon Mountains",
			70.8,
			62.9,
		},
	},
	[25682] = {
		4,
		25682,
		1,
		55,
		"Mission Complete",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			41134,
			"Tak'arili",
			"Blasted Lands",
			62.2,
			1.5,
		},
	},
	[25714] = {
		4,
		25714,
		1,
		55,
		"Watcher Mahar Ba",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			9540,
			"Enohar Thunderbrew",
			"Blasted Lands",
			61.5,
			18.6,
		},
	},
	[25778] = {
		400,
		25778,
		1,
		41,
		"[41] [41] Fake Gold for Black Gold",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			41190,
			"Crazzle Sprysprocket",
			"Thousand Needles",
			91.3,
			57.7,
		},
	},
	[27985] = {
		51,
		27985,
		1,
		48,
		"Prayer to Elune",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			8436,
			"Zamael Lunthistle",
			"Searing Gorge",
			0,
			0,
		},
	},
	[28049] = {
		361,
		28049,
		1,
		46,
		"See the Invisible",
		"H",
		2,
		"DRUIDWARRIOR",
		2,
		"TROLLTAUREN",
		{
			[3] = "Felwood",
			[4] = 41.9,
			[5] = 72,
		},
	},
	[28113] = {
		361,
		28113,
		1,
		46,
		"Break the Unbreakable",
		"H",
		2,
		"DRUIDWARRIOR",
		2,
		"TROLLTAUREN",
		{
			47341,
			"Arcanist Delaris",
			"Felwood",
			41.9,
			72,
		},
	},
	[26098] = {
		406,
		26098,
		1,
		30,
		"Betrayal at the Grove",
		"H",
		2,
		"WARLOCKPALADIN",
		2,
		"SCOURGEBLOODELF",
		{
			42091,
			"Orthus Cliffwalker",
			"Stonetalon Mountains",
			39.7,
			46.4,
		},
	},
	[28177] = {
		46,
		28177,
		1,
		50,
		"Stocking Up",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			47811,
			"John J. Keeshan",
			"Burning Steppes",
			17.3,
			52.2,
		},
	},
	[26162] = {
		4,
		26162,
		1,
		56,
		"The Altar of Storms",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			42298,
			"Kasim Sharim",
			"Blasted Lands",
			62.6,
			26.3,
		},
	},
	[5545] = {
		12,
		5545,
		1,
		10,
		"A Bundle of Trouble",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			10616,
			"Supervisor Raelen",
			"Elwynn Forest",
			81.3,
			66.2,
		},
	},
	[26290] = {
		40,
		26290,
		1,
		14,
		"Secrets of the Tower",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			7024,
			"Agent Kearnen",
			"Westfall",
			68.3,
			70.40000000000001,
		},
	},
	[26322] = {
		40,
		26322,
		1,
		15,
		"Rise of the Brotherhood",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Westfall",
			[4] = 56.3,
			[5] = 47.5,
		},
	},
	[26354] = {
		40,
		26354,
		1,
		13,
		"Captain Sanders' Hidden Treasure",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Westfall",
			[4] = 25.9,
			[5] = 47.8,
		},
	},
	[28529] = {
		148,
		28529,
		1,
		12,
		"Writings of the Void",
		"A",
		2,
		"HUNTER",
		2,
		"DRAENEI",
		{
			[3] = "Darkshore",
			[4] = 52.3,
			[5] = 31,
		},
	},
	[26514] = {
		44,
		26514,
		1,
		16,
		"Canyon Romp",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			[3] = "Redridge Mountains",
			[4] = 32.3,
			[5] = 39.5,
		},
	},
	[28625] = {
		618,
		28625,
		1,
		52,
		"Chop Chop",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			48965,
			"Deez Rocksnitch",
			"Winterspring",
			59.8,
			49.6,
		},
	},
	[26610] = {
		5287,
		26610,
		1,
		32,
		"Bloodsail Treachery",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			[3] = "The Cape of Stranglethorn",
			[4] = 41.4,
			[5] = 61.2,
		},
	},
	[26642] = {
		17,
		26642,
		1,
		12,
		"Preserving the Barrens",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			35068,
			"Gotura Fourwinds",
			"Orgrimmar",
			47.7,
			71.3,
		},
	},
	[26674] = {
		10,
		26674,
		1,
		23,
		"Mistmantle's Revenge",
		"A",
		2,
		"WARLOCKSHAMAN",
		2,
		"HUMANDWARF",
		{
			265,
			"Madame Eva",
			"Duskwood",
			75.7,
			45.3,
		},
	},
	[26738] = {
		33,
		26738,
		1,
		25,
		"Just Hatched",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Northern Stranglethorn",
			[4] = 57.6,
			[5] = 23.4,
		},
	},
	[3861] = {
		40,
		3861,
		1,
		1,
		"CLUCK!",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			620,
			"Chicken",
			"Westfall",
			56.3,
			31.8,
		},
	},
	[9375] = {
		3483,
		9375,
		1,
		63,
		"The Road to Falcon Watch [Group]",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16993,
			"Wounded Blood Elf Pilgrim",
			"Hellfire Peninsula",
			24.6,
			76.09999999999999,
		},
	},
	[9391] = {
		3483,
		9391,
		1,
		62,
		"Marking the Path",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16789,
			"Ranger Captain Venn'ren",
			"Hellfire Peninsula",
			28.5,
			60.3,
		},
	},
	[24947] = {
		440,
		24947,
		1,
		46,
		"Momentum",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38534,
			"Megs Dreadshredder",
			"Tanaris",
			51.2,
			29.9,
		},
	},
	[25043] = {
		4709,
		25043,
		1,
		32,
		"Fields of Blood",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38323,
			"General Hawthorne",
			"Southern Barrens",
			49.9,
			49.7,
		},
	},
	[25075] = {
		4709,
		25075,
		1,
		33,
		"[33] [33] Pick-a-Part",
		"A",
		2,
		"PALADINDRUIDMAGE",
		2,
		"DRAENEINIGHTELFGNOME",
		{
			39084,
			"Mizzy Pistonhammer",
			"Southern Barrens",
			49.4,
			67.5,
		},
	},
	[13581] = {
		148,
		13581,
		1,
		15,
		"The Blackwood Pledge",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			33117,
			"Elder Brownpaw",
			"Darkshore",
			40.9,
			56.5,
		},
	},
	[27218] = {
		15,
		27218,
		1,
		36,
		"Dastardly Denizens of the Deep",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23892,
			"Babs Fizzletorque",
			"Dustwallow Marsh",
			72.2,
			47,
		},
	},
	[25235] = {
		10,
		25235,
		1,
		22,
		"Vulgar Vul'Gol",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			888,
			"Watcher Dodds",
			"Duskwood",
			45.2,
			66.90000000000001,
		},
	},
	[27346] = {
		15,
		27346,
		1,
		38,
		"The Zeppelin Crash",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23600,
			"Apprentice Morlann",
			"Dustwallow Marsh",
			46.1,
			57.5,
		},
	},
	[13805] = {
		331,
		13805,
		1,
		22,
		"Pierce Their Heart!",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			33760,
			"Durak",
			"Ashenvale",
			72.2,
			57.6,
		},
	},
	[9775] = {
		3521,
		9775,
		1,
		62,
		"Report to Shadow Hunter Denjai",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			18011,
			"Zurai",
			"Zangarmarsh",
			85.3,
			54.7,
		},
	},
	[25715] = {
		4,
		25715,
		1,
		55,
		"A Closer Look",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			9540,
			"Enohar Thunderbrew",
			"Blasted Lands",
			61.5,
			18.6,
		},
	},
	[13901] = {
		331,
		13901,
		1,
		22,
		"Deep Despair",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			12719,
			"Marukai",
			"Ashenvale",
			12.6,
			35.3,
		},
	},
	[27826] = {
		3,
		27826,
		1,
		47,
		"Into the Dragon's Mouth",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			46664,
			"Dr. Hieronymus Blam",
			"Badlands",
			47,
			56.5,
		},
	},
	[25811] = {
		406,
		25811,
		1,
		28,
		"Shuttin Her Down",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			41276,
			"Steeltoe McGee",
			"Stonetalon Mountains",
			72,
			75.90000000000001,
		},
	},
	[13949] = {
		17,
		13949,
		1,
		12,
		"Crossroads Caravan Pickup",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			34258,
			"Halga Bloodeye",
			"Northern Barrens",
			67.5,
			38.8,
		},
	},
	[25875] = {
		406,
		25875,
		1,
		28,
		"[28] [28] Gnome on the Inside",
		"A",
		2,
		"PALADINDRUIDMAGE",
		2,
		"DRAENEINIGHTELFGNOME",
		{
			41233,
			"Scout Commander Barus",
			"Stonetalon Mountains",
			48.4,
			51.8,
		},
	},
	[27986] = {
		51,
		27986,
		1,
		49,
		"In the Hall of the Mountain-Lord",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			14627,
			"Hansel Heavyhands",
			"Searing Gorge",
			38.5,
			27.8,
		},
	},
	[26003] = {
		406,
		26003,
		1,
		26,
		"Lessons from the Lost Isles",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			40926,
			"Kilag Gorefang",
			"Stonetalon Mountains",
			74.40000000000001,
			47.6,
		},
	},
	[14045] = {
		17,
		14045,
		1,
		16,
		"Find Baron Longshore",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			3391,
			"Gazlowe",
			"Northern Barrens",
			0,
			0,
		},
	},
	[26067] = {
		406,
		26067,
		1,
		30,
		"Jin'Zil's Blessing",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			3995,
			"Witch Doctor Jin'Zil",
			"Stonetalon Mountains",
			71.09999999999999,
			91.3,
		},
	},
	[26099] = {
		406,
		26099,
		1,
		30,
		"Is This Justice?",
		"H",
		2,
		"WARLOCKPALADIN",
		2,
		"SCOURGEBLOODELF",
		{
			42039,
			"High Chieftain Cliffwalker",
			"Stonetalon Mountains",
			45.1,
			32.8,
		},
	},
	[28178] = {
		46,
		28178,
		1,
		50,
		"A Future Project",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			47811,
			"John J. Keeshan",
			"Burning Steppes",
			17.3,
			52.2,
		},
	},
	[26163] = {
		4,
		26163,
		1,
		56,
		"Time is Short",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			42298,
			"Kasim Sharim",
			"Blasted Lands",
			62.9,
			26,
		},
	},
	[26227] = {
		-304,
		26227,
		3,
		80,
		"Careful, This Fruit Bites Back",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			42506,
			"Marogg",
			"Orgrimmar",
			56.5,
			62.7,
		},
	},
	[28306] = {
		361,
		28306,
		1,
		47,
		"Whisperwind Grove",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			47696,
			"Kelnir Leafsong",
			"Felwood",
			41.3,
			50,
		},
	},
	[26291] = {
		40,
		26291,
		1,
		14,
		"Big Trouble in Moonbrook",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			7024,
			"Agent Kearnen",
			"Westfall",
			68.3,
			70.40000000000001,
		},
	},
	[28370] = {
		361,
		28370,
		1,
		49,
		"Wisp-napping",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			48127,
			"Darla Drilldozer",
			"Felwood",
			56.3,
			8.300000000000001,
		},
	},
	[26355] = {
		40,
		26355,
		1,
		13,
		"Captain Sanders' Hidden Treasure",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Westfall",
			[4] = 40.5,
			[5] = 47.8,
		},
	},
	[28434] = {
		46,
		28434,
		1,
		0,
		"Strategic Cuts",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48085,
			"Quartermaster Kaoshin",
			"Burning Steppes",
			45.3,
			51.6,
		},
	},
	[10159] = {
		3483,
		10159,
		1,
		63,
		"Keep Thornfang Hill Clear!",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16888,
			"Mahuram Stouthoof",
			"Hellfire Peninsula",
			15.7,
			52.2,
		},
	},
	[24436] = {
		16,
		24436,
		1,
		16,
		"Halo Drops",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36921,
			"Sergeant Hort",
			"Azshara",
			41.4,
			53.9,
		},
	},
	[14301] = {
		405,
		14301,
		1,
		32,
		"Return and Report",
		"HA",
		2,
		"PALADINWARLOCK",
		2,
		"BLOODELFGNOME",
		{
			35902,
			"Lord Hydronis",
			"Desolace",
			29,
			8,
		},
	},
	[28626] = {
		618,
		28626,
		1,
		52,
		"Tree Delivery",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			48965,
			"Deez Rocksnitch",
			"Winterspring",
			59.8,
			49.7,
		},
	},
	[26611] = {
		5287,
		26611,
		1,
		32,
		"The Baron Must Be Told",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2490,
			"First Mate Crazz",
			"The Cape of Stranglethorn",
			42.5,
			72,
		},
	},
	[10255] = {
		3483,
		10255,
		1,
		63,
		"Testing the Antidote",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16991,
			"Thiah Redmane",
			"Hellfire Peninsula",
			15.7,
			52.1,
		},
	},
	[28722] = {
		618,
		28722,
		1,
		52,
		"Yetiphobia",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			10305,
			"Umi Rumplesnicker",
			"Winterspring",
			59.3,
			49.8,
		},
	},
	[26707] = {
		10,
		26707,
		1,
		24,
		"A Deadly Vine",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			43738,
			"Apprentice Fess",
			"Duskwood",
			44.8,
			67.3,
		},
	},
	[26739] = {
		33,
		26739,
		1,
		25,
		"I Think She's Hungry",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			1422,
			"Corporal Sethman",
			"Northern Stranglethorn",
			47,
			10.9,
		},
	},
	[14413] = {
		16,
		14413,
		1,
		18,
		"The Pinnacle of Learning",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35187,
			"Image of Archmage Xylem",
			"Azshara",
			47.3,
			20.9,
		},
	},
	[14429] = {
		16,
		14429,
		1,
		18,
		"Arcane De-Construction",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			[3] = "Azshara",
			[4] = 49.6,
			[5] = 28.8,
		},
	},
	[10367] = {
		3483,
		10367,
		1,
		62,
		"A Traitor Among Us",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			19361,
			"Naladu",
			"Hellfire Peninsula",
			16.2,
			65,
		},
	},
	[26899] = {
		719,
		26899,
		1,
		28,
		"The Enemy of My Enemy [Dungeon]",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			44387,
			"Flaming Eradicator",
			"Blackfathom Deeps",
			31.5,
			66.59999999999999,
		},
	},
	[24948] = {
		4709,
		24948,
		1,
		30,
		"Lifting the Siege",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38620,
			"Thomas Paxton",
			"Southern Barrens",
			67,
			46.6,
		},
	},
	[25044] = {
		4709,
		25044,
		1,
		32,
		"Diplomacy By Another Means",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38986,
			"Ambassador Gaines",
			"Southern Barrens",
			50,
			49.6,
		},
	},
	[25108] = {
		4709,
		25108,
		1,
		34,
		"Feegly the Exiled",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			39155,
			"Marley Twinbraid",
			"Southern Barrens",
			47.2,
			88.5,
		},
	},
	[27219] = {
		15,
		27219,
		1,
		36,
		"Is it Real?",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23896,
			"\"Dirty\" Michael Crowe",
			"Dustwallow Marsh",
			69.2,
			51.9,
		},
	},
	[27251] = {
		15,
		27251,
		1,
		37,
		"They Call Him Smiling Jim",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			4921,
			"Guard Byron",
			"Dustwallow Marsh",
			66.09999999999999,
			46.1,
		},
	},
	[25236] = {
		14,
		25236,
		1,
		10,
		"Thunder Down Under",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			39379,
			"Gor the Enforcer",
			"Durotar",
			44.9,
			14.8,
		},
	},
	[2158] = {
		12,
		2158,
		1,
		5,
		"Rest and Relaxation",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			6774,
			"Falkhaan Isenstrider",
			"Elwynn Forest",
			45.6,
			47.8,
		},
	},
	[27539] = {
		139,
		27539,
		1,
		44,
		"Add 'em to the Pile",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			45831,
			"Crusader Kevin Frost",
			"Eastern Plaguelands",
			27.6,
			21,
		},
	},
	[25524] = {
		400,
		25524,
		1,
		40,
		"[40] [40] In the Outhouse",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			[3] = "Thousand Needles",
			[4] = 79.5,
			[5] = 75,
		},
	},
	[25556] = {
		1176,
		25556,
		1,
		47,
		"Into Zul'Farrak",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			7804,
			"Trenton Lighthammer",
			"Tanaris",
			42.4,
			24.1,
		},
	},
	[25588] = {
		400,
		25588,
		1,
		41,
		"[41] [41] A Little Payback",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			40591,
			"Drag Master Miglen",
			"Thousand Needles",
			78.09999999999999,
			73.2,
		},
	},
	[25652] = {
		406,
		25652,
		1,
		26,
		"Commandeer That Balloon!",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			40879,
			"Boog the \"Gear Whisperer\"",
			"Stonetalon Mountains",
			72.40000000000001,
			61.5,
		},
	},
	[25684] = {
		4,
		25684,
		1,
		55,
		"Attune the Bloodstone",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			7506,
			"Bloodmage Lynnore",
			"Blasted Lands",
			39.2,
			36.2,
		},
	},
	[25716] = {
		4,
		25716,
		1,
		55,
		"Cultists at our Doorstep",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			5385,
			"Watcher Mahar Ba",
			"Blasted Lands",
			63.2,
			16.8,
		},
	},
	[12894] = {
		66,
		12894,
		1,
		75,
		"Crusader Forward Camp",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			29687,
			"Crusader Lord Lantinga",
			"Zul'Drak",
			32.2,
			75.7,
		},
	},
	[25844] = {
		406,
		25844,
		1,
		29,
		"Sating the Savage Beast",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			41278,
			"\"Cookie\" McWeaksauce",
			"Stonetalon Mountains",
			70.90000000000001,
			79.8,
		},
	},
	[25876] = {
		406,
		25876,
		1,
		28,
		"[28] [28] It's Up There!",
		"A",
		2,
		"PALADINDRUIDMAGE",
		2,
		"DRAENEINIGHTELFGNOME",
		{
			41434,
			"\"Goblin\" Pump Controller",
			"Stonetalon Mountains",
			53.6,
			42.4,
		},
	},
	[28051] = {
		400,
		28051,
		1,
		41,
		"[41] [41] We All Scream for Ice Cream... and then Die!",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			47383,
			"Brivelthwerp",
			"Thousand Needles",
			69.90000000000001,
			85.09999999999999,
		},
	},
	[35] = {
		12,
		35,
		1,
		10,
		"Further Concerns",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			240,
			"Marshal Dughan",
			"Elwynn Forest",
			42.1,
			65.90000000000001,
		},
	},
	[26068] = {
		406,
		26068,
		1,
		30,
		"Kobold Fury!",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			42023,
			"Subjugator Devo",
			"Stonetalon Mountains",
			71.2,
			91.2,
		},
	},
	[26100] = {
		406,
		26100,
		1,
		30,
		"The General is Dead",
		"H",
		2,
		"WARLOCKPALADIN",
		2,
		"SCOURGEBLOODELF",
		{
			42047,
			"Masha Cliffwalker",
			"Stonetalon Mountains",
			45.1,
			32.8,
		},
	},
	[28179] = {
		46,
		28179,
		1,
		50,
		"Mud Hunter",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			47811,
			"John J. Keeshan",
			"Burning Steppes",
			17.3,
			52.2,
		},
	},
	[26164] = {
		4,
		26164,
		1,
		56,
		"The Charred Granite of the Dark Portal",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			42299,
			"Watcher Grimeo",
			"Blasted Lands",
			55.1,
			49.6,
		},
	},
	[26228] = {
		40,
		26228,
		1,
		11,
		"Livin' the Life",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			42405,
			"Two-Shoed Lou",
			"Westfall",
			49.7,
			19.4,
		},
	},
	[26292] = {
		40,
		26292,
		1,
		14,
		"To Moonbrook!",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			234,
			"Marshal Gryan Stoutmantle",
			"Westfall",
			56.3,
			47.5,
		},
	},
	[26356] = {
		40,
		26356,
		1,
		13,
		"Captain Sanders' Hidden Treasure",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Westfall",
			[4] = 40.7,
			[5] = 17.1,
		},
	},
	[28435] = {
		46,
		28435,
		1,
		50,
		"The Kodocaller's Horn",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48085,
			"Quartermaster Kaoshin",
			"Burning Steppes",
			0,
			0,
		},
	},
	[28467] = {
		618,
		28467,
		1,
		50,
		"Mystery Goo",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			[3] = "Winterspring",
			[4] = 24.5,
			[5] = 47.6,
		},
	},
	[26452] = {
		5287,
		26452,
		3,
		80,
		"Gurubashi Challenge [PvP]",
		"A",
		2,
		"HUNTER",
		2,
		"DRAENEI",
		{
			43099,
			"Stone Guard Towhide",
			"The Cape of Stranglethorn",
			46.3,
			28.1,
		},
	},
	[24437] = {
		16,
		24437,
		1,
		16,
		"First Come, First Served",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36795,
			"Ruckus",
			"Azshara",
			39.1,
			51.7,
		},
	},
	[28627] = {
		618,
		28627,
		1,
		52,
		"Seril's Boast",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			11193,
			"Seril Scourgebane",
			"Winterspring",
			59.8,
			49.3,
		},
	},
	[26612] = {
		5287,
		26612,
		1,
		33,
		"Details of the Attack",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2496,
			"Baron Revilgaz",
			"The Cape of Stranglethorn",
			41.2,
			73.09999999999999,
		},
	},
	[26644] = {
		5287,
		26644,
		1,
		34,
		"Attracting Attention",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2548,
			"Captain Keelhaul",
			"The Cape of Stranglethorn",
			44.4,
			91.59999999999999,
		},
	},
	[26676] = {
		10,
		26676,
		1,
		22,
		"Juice Delivery",
		"A",
		2,
		"WARLOCKSHAMAN",
		2,
		"HUMANDWARF",
		{
			273,
			"Tavernkeep Smitts",
			"Duskwood",
			74,
			44.8,
		},
	},
	[28755] = {
		2017,
		28755,
		1,
		46,
		"Annals of the Silver Hand",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			49856,
			"Lord Raymond George",
			"Eastern Plaguelands",
			76.09999999999999,
			51,
		},
	},
	[26740] = {
		33,
		26740,
		1,
		28,
		"Krazek's Cookery",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			770,
			"Corporal Kaleb",
			"Northern Stranglethorn",
			47.2,
			10.7,
		},
	},
	[26772] = {
		33,
		26772,
		1,
		27,
		"Mind Vision",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			44017,
			"Priestess Thaalia",
			"Northern Stranglethorn",
			53.4,
			66.7,
		},
	},
	[583] = {
		33,
		583,
		1,
		25,
		"Welcome to the Jungle",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			716,
			"Barnil Stonepot",
			"Northern Stranglethorn",
			44.2,
			22.2,
		},
	},
	[9376] = {
		3483,
		9376,
		1,
		63,
		"A Pilgrim's Plight",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			17015,
			"Taleris Dawngazer",
			"Hellfire Peninsula",
			27.1,
			62,
		},
	},
	[24949] = {
		440,
		24949,
		1,
		46,
		"Booty Duty",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38703,
			"Megs Dreadshredder",
			"Tanaris",
			71.8,
			45.4,
		},
	},
	[13518] = {
		148,
		13518,
		1,
		10,
		"The Last Wave of Survivors",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			32973,
			"Dentaria Silverglade",
			"Darkshore",
			51.7,
			18,
		},
	},
	[4722] = {
		148,
		4722,
		1,
		13,
		"Beached Sea Turtle",
		"A",
		2,
		"HUNTER",
		2,
		"DRAENEI",
		{
			[3] = "Darkshore",
			[4] = 38.5,
			[5] = 60.6,
		},
	},
	[25045] = {
		4709,
		25045,
		1,
		32,
		"A Line in the Dirt",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38323,
			"General Hawthorne",
			"Southern Barrens",
			49.9,
			49.7,
		},
	},
	[9472] = {
		3483,
		9472,
		1,
		62,
		"Arelion's Mistress",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16793,
			"Magistrix Carinda",
			"Hellfire Peninsula",
			26.4,
			60.4,
		},
	},
	[13582] = {
		148,
		13582,
		1,
		15,
		"Elune's Fire",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			33119,
			"Aroom",
			"Darkshore",
			45.5,
			48.5,
		},
	},
	[27188] = {
		15,
		27188,
		1,
		36,
		"What's Haunting Witch Hill?",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23843,
			"Mordant Grimsby",
			"Dustwallow Marsh",
			55.5,
			26.4,
		},
	},
	[25205] = {
		14,
		25205,
		1,
		10,
		"The Wolf and The Kodo",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			39380,
			"Shin Stonepillar",
			"Durotar",
			44.9,
			14.8,
		},
	},
	[27412] = {
		15,
		27412,
		1,
		39,
		"WANTED: Goreclaw the Ravenous",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23572,
			"Drazzit Dripvalve",
			"Dustwallow Marsh",
			41.8,
			73,
		},
	},
	[13806] = {
		331,
		13806,
		1,
		22,
		"Demon Duty",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			11820,
			"Locke Okarr",
			"Ashenvale",
			73.8,
			61.7,
		},
	},
	[9728] = {
		3521,
		9728,
		1,
		64,
		"A Warm Welcome",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			17858,
			"Warden Hamoot",
			"Zangarmarsh",
			79.2,
			65.09999999999999,
		},
	},
	[25621] = {
		406,
		25621,
		1,
		26,
		"Field Test: Gnomecorder",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			40895,
			"Professor Xakxak Gyromate",
			"Ashenvale",
			35.3,
			71.2,
		},
	},
	[25685] = {
		4,
		25685,
		1,
		55,
		"The First Step",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			7506,
			"Bloodmage Lynnore",
			"Blasted Lands",
			39.2,
			36.2,
		},
	},
	[25717] = {
		4,
		25717,
		1,
		58,
		"The Demons and the Druid",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			42344,
			"Rohan Sunveil",
			"Blasted Lands",
			49.7,
			71.5,
		},
	},
	[13902] = {
		148,
		13902,
		1,
		18,
		"Mounting the Offensive",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			33091,
			"Malfurion Stormrage",
			"Darkshore",
			43.7,
			53.5,
		},
	},
	[13918] = {
		148,
		13918,
		1,
		18,
		"The Titans' Terminal",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			34342,
			"Jr. Archaeologist Ferd",
			"Darkshore",
			37.7,
			82.90000000000001,
		},
	},
	[25813] = {
		400,
		25813,
		1,
		42,
		"[42] [42] Go Blow that Horn",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			41190,
			"Crazzle Sprysprocket",
			"Thousand Needles",
			91.40000000000001,
			57.7,
		},
	},
	[25845] = {
		406,
		25845,
		1,
		29,
		"Terms of Service",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			41350,
			"Ton Windbow",
			"Stonetalon Mountains",
			72.8,
			81,
		},
	},
	[25877] = {
		406,
		25877,
		1,
		28,
		"[28] [28] No Time for Goodbyes!",
		"A",
		2,
		"PALADINDRUIDMAGE",
		2,
		"DRAENEINIGHTELFGNOME",
		{
			41434,
			"\"Goblin\" Pump Controller",
			"Stonetalon Mountains",
			53.6,
			42.4,
		},
	},
	[27956] = {
		51,
		27956,
		1,
		47,
		"Lunk's Task",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			47269,
			"Lunk",
			"Searing Gorge",
			68.7,
			53.2,
		},
	},
	[13998] = {
		17,
		13998,
		1,
		14,
		"In Fungus We Trust",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			[3] = "Northern Barrens",
			[4] = 48.6,
			[5] = 58.3,
		},
	},
	[28052] = {
		51,
		28052,
		1,
		49,
		"Operation: Stir the Cauldron",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			14625,
			"Overseer Oilfist",
			"Searing Gorge",
			38.1,
			26.8,
		},
	},
	[28116] = {
		361,
		28116,
		1,
		46,
		"Crying Violet",
		"H",
		2,
		"DRUIDWARRIOR",
		2,
		"TROLLTAUREN",
		{
			10922,
			"Greta Mosshoof",
			"Felwood",
			44,
			61.9,
		},
	},
	[28148] = {
		361,
		28148,
		1,
		45,
		"Culling the Corrupted",
		"H",
		2,
		"DRUIDWARRIOR",
		2,
		"TROLLTAUREN",
		{
			10921,
			"Taronn Redfeather",
			"Felwood",
			51,
			80.2,
		},
	},
	[28180] = {
		46,
		28180,
		1,
		50,
		"The Sand, the Cider, and the Orb",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			47811,
			"John J. Keeshan",
			"Burning Steppes",
			17.3,
			51.9,
		},
	},
	[26165] = {
		4,
		26165,
		1,
		56,
		"The Vile Blood of Demons",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			42299,
			"Watcher Grimeo",
			"Blasted Lands",
			55.1,
			49.6,
		},
	},
	[26229] = {
		40,
		26229,
		1,
		11,
		"\"I TAKE Candle!\"",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			42498,
			"Jimb \"Candles\" McHannigan",
			"Westfall",
			49.6,
			19.6,
		},
	},
	[28340] = {
		361,
		28340,
		1,
		49,
		"A Bomb Deal",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			48333,
			"Foreman Pikwik",
			"Felwood",
			54.7,
			18.4,
		},
	},
	[14190] = {
		16,
		14190,
		1,
		11,
		"The Perfect Prism",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35091,
			"Horzak Zignibble",
			"Azshara",
			29.1,
			66.3,
		},
	},
	[26389] = {
		12,
		26389,
		1,
		4,
		"Blackrock Invasion",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			197,
			"Marshal McBride",
			"Elwynn Forest",
			48.1,
			42.1,
		},
	},
	[14270] = {
		16,
		14270,
		1,
		13,
		"The Keystone Shard",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			[3] = "Azshara",
			[4] = 59,
			[5] = 71.90000000000001,
		},
	},
	[40] = {
		12,
		40,
		1,
		10,
		"A Fishy Peril",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			241,
			"Remy \"Two Times\"",
			"Elwynn Forest",
			42.2,
			67.09999999999999,
		},
	},
	[28628] = {
		618,
		28628,
		1,
		52,
		"Ice Delivery",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			48965,
			"Deez Rocksnitch",
			"Winterspring",
			59.7,
			49.8,
		},
	},
	[26613] = {
		5287,
		26613,
		1,
		33,
		"Up to Snuff",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2488,
			"Deeg",
			"The Cape of Stranglethorn",
			40.8,
			73.7,
		},
	},
	[26645] = {
		10,
		26645,
		1,
		21,
		"The Night Watch",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			264,
			"Commander Althea Ebonlocke",
			"Duskwood",
			73.59999999999999,
			46.9,
		},
	},
	[26677] = {
		10,
		26677,
		1,
		22,
		"Ghoulish Effigy",
		"A",
		2,
		"WARLOCKSHAMAN",
		2,
		"HUMANDWARF",
		{
			289,
			"Abercrombie",
			"Duskwood",
			87.40000000000001,
			35.4,
		},
	},
	[28756] = {
		2057,
		28756,
		1,
		42,
		"Aberrations of Bone",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			49856,
			"Lord Raymond George",
			"Eastern Plaguelands",
			76.09999999999999,
			51,
		},
	},
	[28788] = {
		12,
		28788,
		1,
		3,
		"Join the Battle!",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			459,
			"Drusilla La Salle",
			"Elwynn Forest",
			49.8,
			42.7,
		},
	},
	[26773] = {
		33,
		26773,
		1,
		27,
		"See Raptor",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			44017,
			"Priestess Thaalia",
			"Northern Stranglethorn",
			53.4,
			66.8,
		},
	},
	[26805] = {
		5287,
		26805,
		1,
		30,
		"To the Cape!",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			44018,
			"Wulfred Harrys",
			"Northern Stranglethorn",
			53.3,
			66.3,
		},
	},
	[10368] = {
		3483,
		10368,
		1,
		62,
		"The Dreghood Elders",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			19361,
			"Naladu",
			"Hellfire Peninsula",
			16.2,
			65,
		},
	},
	[14478] = {
		16,
		14478,
		1,
		16,
		"Operation Fishgut",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			[3] = "Azshara",
			[4] = 57,
			[5] = 50.1,
		},
	},
	[24950] = {
		440,
		24950,
		1,
		46,
		"Captain Dreadbeard",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38703,
			"Megs Dreadshredder",
			"Tanaris",
			71.90000000000001,
			45.4,
		},
	},
	[25014] = {
		440,
		25014,
		1,
		48,
		"Sandscraper's Treasure",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			[3] = "Tanaris",
			[4] = 41.9,
			[5] = 57.5,
		},
	},
	[27157] = {
		28,
		27157,
		1,
		37,
		"Drudges... <Sigh>",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			45157,
			"Lieutenant Myner",
			"Western Plaguelands",
			43.2,
			16,
		},
	},
	[27189] = {
		15,
		27189,
		1,
		36,
		"The Witch's Bane",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23843,
			"Mordant Grimsby",
			"Dustwallow Marsh",
			55.6,
			26.2,
		},
	},
	[25174] = {
		4709,
		25174,
		1,
		34,
		"Twinbraid Needs to Know",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38152,
			"Weezil Slipshadow",
			"Southern Barrens",
			50.3,
			87.09999999999999,
		},
	},
	[25206] = {
		14,
		25206,
		1,
		10,
		"Ignoring the Warnings",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			39379,
			"Gor the Enforcer",
			"Durotar",
			45,
			14.7,
		},
	},
	[27381] = {
		139,
		27381,
		1,
		41,
		"Traveling Companions",
		"A",
		2,
		"ROGUEMAGE",
		2,
		"NIGHTELFGNOME",
		{
			45429,
			"Tarenar Sunstrike",
			"Eastern Plaguelands",
			35.2,
			68.8,
		},
	},
	[27413] = {
		15,
		27413,
		1,
		39,
		"Catch a Dragon by the Tail",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23570,
			"Gizzix Grimegurgle",
			"Dustwallow Marsh",
			41.6,
			72.90000000000001,
		},
	},
	[27477] = {
		139,
		27477,
		1,
		43,
		"The Corpulent One",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			45735,
			"Gamella Cracklefizz",
			"Eastern Plaguelands",
			61.5,
			43.1,
		},
	},
	[25590] = {
		400,
		25590,
		1,
		41,
		"[41] [41] Where's Wizzle?",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			40554,
			"Rizzle Brassbolts",
			"Thousand Needles",
			78,
			73.40000000000001,
		},
	},
	[25622] = {
		406,
		25622,
		1,
		26,
		"Burn, Baby, Burn!",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			34353,
			"Krom'gar Incinerator",
			"Stonetalon Mountains",
			73.2,
			46.7,
		},
	},
	[25686] = {
		4,
		25686,
		1,
		55,
		"Blood Ritual",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			7506,
			"Bloodmage Lynnore",
			"Blasted Lands",
			39.2,
			36.3,
		},
	},
	[25718] = {
		4,
		25718,
		1,
		58,
		"How Best to Proceed",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			42344,
			"Rohan Sunveil",
			"Blasted Lands",
			49.8,
			71.5,
		},
	},
	[27829] = {
		3,
		27829,
		1,
		47,
		"The Wrath of a Dragonflight",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			46857,
			"Olaf",
			"Badlands",
			17.9,
			54,
		},
	},
	[10864] = {
		3483,
		10864,
		1,
		61,
		"A Burden of Souls",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16588,
			"Apothecary Antonivich",
			"Hellfire Peninsula",
			52.3,
			36.4,
		},
	},
	[25846] = {
		406,
		25846,
		1,
		29,
		"Grundig Darkcloud, Chieftain of the Grimtotem",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			41229,
			"Force Commander Valen",
			"Stonetalon Mountains",
			71.09999999999999,
			79.7,
		},
	},
	[25878] = {
		406,
		25878,
		1,
		28,
		"[28] [28] Schemin' That Sabotage",
		"A",
		2,
		"PALADINDRUIDMAGE",
		2,
		"DRAENEINIGHTELFGNOME",
		{
			41441,
			"Scout Mistress Yvonia",
			"Stonetalon Mountains",
			48.5,
			52,
		},
	},
	[27989] = {
		361,
		27989,
		1,
		45,
		"Ruumbo Demands Honey",
		"H",
		2,
		"DRUIDWARRIOR",
		2,
		"TROLLTAUREN",
		{
			[3] = "Felwood",
			[4] = 51.6,
			[5] = 83.7,
		},
	},
	[28181] = {
		46,
		28181,
		1,
		50,
		"Warlocks Have the Neatest Stuff",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			14437,
			"Gorzeeki Wildeyes",
			"Burning Steppes",
			8.300000000000001,
			35.7,
		},
	},
	[26166] = {
		4,
		26166,
		1,
		56,
		"Enhancing the Stone",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			42299,
			"Watcher Grimeo",
			"Blasted Lands",
			55.1,
			49.6,
		},
	},
	[26230] = {
		40,
		26230,
		1,
		12,
		"Feast or Famine",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			42497,
			"Mama Celeste",
			"Westfall",
			49.5,
			19.2,
		},
	},
	[28341] = {
		361,
		28341,
		1,
		48,
		"Collecting Corruption",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			48339,
			"Elessa Starbreeze",
			"Felwood",
			43.9,
			28,
		},
	},
	[28373] = {
		361,
		28373,
		1,
		49,
		"Timbermaw Hold",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			48127,
			"Darla Drilldozer",
			"Felwood",
			56.3,
			8.199999999999999,
		},
	},
	[28437] = {
		46,
		28437,
		1,
		51,
		"General Thorg'izog",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48568,
			"Eitrigg",
			"Burning Steppes",
			44.6,
			44.5,
		},
	},
	[28469] = {
		618,
		28469,
		1,
		50,
		"Winterfall Runners",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			9298,
			"Donova Snowden",
			"Winterspring",
			25.1,
			58.4,
		},
	},
	[26550] = {
		5287,
		26550,
		1,
		31,
		"Backdoor Dealings",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			43098,
			"Chabal",
			"The Cape of Stranglethorn",
			34.6,
			27.9,
		},
	},
	[28629] = {
		618,
		28629,
		1,
		52,
		"Are We There, Yeti?",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			10305,
			"Umi Rumplesnicker",
			"Winterspring",
			59.4,
			49.8,
		},
	},
	[26614] = {
		5287,
		26614,
		1,
		33,
		"Keep An Eye Out",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2493,
			"Dizzy One-Eye",
			"The Cape of Stranglethorn",
			43.4,
			71.3,
		},
	},
	[26646] = {
		44,
		26646,
		1,
		18,
		"Prisoners of War",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			43458,
			"John J. Keeshan",
			"Redridge Mountains",
			52.5,
			55.4,
		},
	},
	[26678] = {
		5287,
		26678,
		1,
		35,
		"Doublerum",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2496,
			"Baron Revilgaz",
			"The Cape of Stranglethorn",
			41.1,
			73.09999999999999,
		},
	},
	[26742] = {
		33,
		26742,
		1,
		26,
		"Bloodscalp Insight",
		"A",
		2,
		"DRUIDWARLOCK",
		2,
		"NIGHTELFHUMAN",
		{
			43886,
			"Berrin Burnquill",
			"Northern Stranglethorn",
			47.9,
			12,
		},
	},
	[26774] = {
		33,
		26774,
		1,
		29,
		"Mind Control",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			44017,
			"Priestess Thaalia",
			"Northern Stranglethorn",
			53.4,
			66.8,
		},
	},
	[26838] = {
		33,
		26838,
		1,
		25,
		"Rebels Without a Clue",
		"A",
		2,
		"WARLOCKSHAMAN",
		2,
		"HUMANDWARF",
		{
			43731,
			"Sister Elsington",
			"Duskwood",
			19.9,
			58,
		},
	},
	[9361] = {
		3483,
		9361,
		1,
		61,
		"Helboar, the Other White Meat",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			19344,
			"Legassi",
			"Hellfire Peninsula",
			49.2,
			74.7,
		},
	},
	[24951] = {
		440,
		24951,
		1,
		47,
		"A Great Idea",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38706,
			"Zeke Bootscuff",
			"Tanaris",
			55.7,
			60.8,
		},
	},
	[13519] = {
		148,
		13519,
		1,
		13,
		"The Twilight's Hammer",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			32912,
			"Sentinel Lendra",
			"Darkshore",
			50.3,
			20.3,
		},
	},
	[25015] = {
		4709,
		25015,
		1,
		31,
		"Make 'em Squeal",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38871,
			"Corporal Teegan",
			"Southern Barrens",
			56.2,
			42.7,
		},
	},
	[25079] = {
		4709,
		25079,
		1,
		33,
		"[33] [33] Powder Play",
		"A",
		2,
		"PALADINDRUIDMAGE",
		2,
		"DRAENEINIGHTELFGNOME",
		{
			39084,
			"Mizzy Pistonhammer",
			"Southern Barrens",
			49.4,
			67.5,
		},
	},
	[13583] = {
		148,
		13583,
		1,
		16,
		"The Wildkin's Oath",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			33119,
			"Aroom",
			"Darkshore",
			45.7,
			48.5,
		},
	},
	[27190] = {
		15,
		27190,
		1,
		36,
		"Cleansing Witch Hill",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23843,
			"Mordant Grimsby",
			"Dustwallow Marsh",
			55.5,
			26.2,
		},
	},
	[25175] = {
		4709,
		25175,
		1,
		34,
		"The Bad News",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			39188,
			"Marley Twinbraid",
			"Southern Barrens",
			49.3,
			86.7,
		},
	},
	[27382] = {
		139,
		27382,
		1,
		41,
		"Rough Roads",
		"A",
		2,
		"ROGUEMAGE",
		2,
		"NIGHTELFGNOME",
		{
			45451,
			"Argus Highbeacon",
			"Eastern Plaguelands",
			35.8,
			68.7,
		},
	},
	[27446] = {
		440,
		27446,
		1,
		43,
		"[43] [43] Tanaris is Calling",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			40027,
			"Fizzle Brassbolts",
			"Thousand Needles",
			75.90000000000001,
			74.59999999999999,
		},
	},
	[46] = {
		12,
		46,
		1,
		10,
		"Bounty on Murlocs",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			261,
			"Guard Thomas",
			"Elwynn Forest",
			74,
			72.2,
		},
	},
	[25591] = {
		440,
		25591,
		1,
		49,
		"Thunderdrome: Grudge Match! [Group]",
		"H",
		2,
		"DRUIDWARRIOR",
		2,
		"TROLLTAUREN",
		{
			39034,
			"Dr. Dealwell",
			"Tanaris",
			51.8,
			28,
		},
	},
	[25687] = {
		4,
		25687,
		1,
		55,
		"Not Just Any Body",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			7506,
			"Bloodmage Lynnore",
			"Blasted Lands",
			39.2,
			36.2,
		},
	},
	[25719] = {
		4,
		25719,
		1,
		58,
		"Demoniac Vessel",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			42348,
			"Elijah Dawnflight",
			"Blasted Lands",
			47.2,
			69,
		},
	},
	[27830] = {
		3,
		27830,
		1,
		47,
		"Their Hunt Continues",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			[3] = "Badlands",
			[4] = 30.7,
			[5] = 42,
		},
	},
	[25815] = {
		11,
		25815,
		1,
		22,
		"The Third Fleet",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			1239,
			"First Mate Fitzsimmons",
			"Wetlands",
			10.9,
			59.7,
		},
	},
	[25847] = {
		406,
		25847,
		1,
		30,
		"Grimtotem Supremacy",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			11858,
			"Grundig Darkcloud",
			"Stonetalon Mountains",
			72.3,
			83.90000000000001,
		},
	},
	[25879] = {
		406,
		25879,
		1,
		28,
		"[28] [28] The Lumbering Oaf Problem",
		"A",
		2,
		"PALADINDRUIDMAGE",
		2,
		"DRAENEINIGHTELFGNOME",
		{
			41441,
			"Scout Mistress Yvonia",
			"Stonetalon Mountains",
			48.5,
			52,
		},
	},
	[27958] = {
		51,
		27958,
		1,
		47,
		"A Proper Antivenom",
		"HA",
		2,
		"DEATHKNIGHTMAGE",
		2,
		"BLOODELFDRAENEI",
		{
			47268,
			"Prisanne Dustcropper",
			"Searing Gorge",
			68.7,
			53.4,
		},
	},
	[28054] = {
		51,
		28054,
		1,
		49,
		"Slavery is Bad",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			47393,
			"Mountain-Lord Rendan",
			"Searing Gorge",
			40.8,
			51.6,
		},
	},
	[47] = {
		12,
		47,
		1,
		7,
		"Gold Dust Exchange",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			241,
			"Remy \"Two Times\"",
			"Elwynn Forest",
			42.2,
			67.2,
		},
	},
	[28150] = {
		361,
		28150,
		1,
		46,
		"An Arcane Ally",
		"H",
		2,
		"DRUIDWARRIOR",
		2,
		"TROLLTAUREN",
		{
			10923,
			"Tenell Leafrunner",
			"Felwood",
			51.2,
			80.5,
		},
	},
	[28182] = {
		46,
		28182,
		1,
		50,
		"Shadow Boxing",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			14437,
			"Gorzeeki Wildeyes",
			"Burning Steppes",
			8.300000000000001,
			35.7,
		},
	},
	[26167] = {
		4,
		26167,
		1,
		55,
		"The Amulet of Allistarj",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			42298,
			"Kasim Sharim",
			"Blasted Lands",
			62.6,
			26.1,
		},
	},
	[28246] = {
		46,
		28246,
		1,
		0,
		"Strategic Cuts",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			48085,
			"Quartermaster Kaoshin",
			"Burning Steppes",
			45.3,
			51.6,
		},
	},
	[26295] = {
		40,
		26295,
		1,
		14,
		"Propaganda",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			42425,
			"Captain Alpert",
			"Westfall",
			42.1,
			64.09999999999999,
		},
	},
	[28374] = {
		361,
		28374,
		1,
		48,
		"Weeding the Lawn",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			48459,
			"Tender Puregrove",
			"Felwood",
			43.3,
			30.4,
		},
	},
	[28438] = {
		46,
		28438,
		1,
		51,
		"Trial by Magma",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48133,
			"General Thorg'izog",
			"Burning Steppes",
			30.7,
			33.7,
		},
	},
	[28470] = {
		618,
		28470,
		1,
		50,
		"High Chief Winterfall",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			9298,
			"Donova Snowden",
			"Winterspring",
			25.2,
			58.5,
		},
	},
	[10161] = {
		3483,
		10161,
		1,
		61,
		"In Case of Emergency...",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			19367,
			"\"Screaming\" Screed Luckheed",
			"Hellfire Peninsula",
			49.2,
			74.8,
		},
	},
	[14271] = {
		16,
		14271,
		1,
		13,
		"Report to Twocrush",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			[3] = "Azshara",
			[4] = 59,
			[5] = 72,
		},
	},
	[26519] = {
		44,
		26519,
		1,
		16,
		"He Who Controls the Ettins",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			[3] = "Redridge Mountains",
			[4] = 35.9,
			[5] = 33.6,
		},
	},
	[26551] = {
		5287,
		26551,
		1,
		32,
		"Eliminate the Outcast",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			43098,
			"Chabal",
			"The Cape of Stranglethorn",
			34.6,
			27.9,
		},
	},
	[28630] = {
		618,
		28630,
		1,
		52,
		"Echo Three",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			10305,
			"Umi Rumplesnicker",
			"Winterspring",
			59.4,
			49.8,
		},
	},
	[14335] = {
		405,
		14335,
		1,
		35,
		"Chipping In",
		"H",
		2,
		"MAGE",
		2,
		"TROLL",
		{
			11624,
			"Taiga Wisemane",
			"Desolace",
			25.8,
			68.09999999999999,
		},
	},
	[26647] = {
		5287,
		26647,
		1,
		34,
		"Ol' Blasty",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2547,
			"Ironpatch",
			"The Cape of Stranglethorn",
			46.7,
			94.90000000000001,
		},
	},
	[26679] = {
		5287,
		26679,
		1,
		35,
		"Return to Revilgaz",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			[3] = "The Cape of Stranglethorn",
			[4] = 40.7,
			[5] = 73.3,
		},
	},
	[14383] = {
		16,
		14383,
		1,
		14,
		"The Terrible Tinkers of the Ruined Reaches",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36379,
			"Hobart Grapplehammer",
			"Azshara",
			50.4,
			74.5,
		},
	},
	[26743] = {
		33,
		26743,
		1,
		26,
		"Sacred to the Bloodscalp",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			43886,
			"Berrin Burnquill",
			"Northern Stranglethorn",
			47.9,
			12,
		},
	},
	[28822] = {
		12,
		28822,
		1,
		4,
		"The Rear is Clear",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			823,
			"Sergeant Willem",
			"Elwynn Forest",
			48.8,
			38.3,
		},
	},
	[14431] = {
		16,
		14431,
		1,
		17,
		"The Blackmaw Scar",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			8586,
			"Haggrum Bloodfist",
			"Azshara",
			42.4,
			23.7,
		},
	},
	[10369] = {
		3483,
		10369,
		1,
		62,
		"Arzeth's Demise",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			19361,
			"Naladu",
			"Hellfire Peninsula",
			16.3,
			65,
		},
	},
	[14479] = {
		16,
		14479,
		1,
		16,
		"There Are Many Like It",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36956,
			"Captain Desoto",
			"Azshara",
			58.2,
			52.3,
		},
	},
	[26935] = {
		28,
		26935,
		1,
		37,
		"Northridge Lumber Mill",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			44454,
			"Field Agent Kaartish",
			"Western Plaguelands",
			49.3,
			54.9,
		},
	},
	[26999] = {
		28,
		26999,
		1,
		37,
		"A New Era for the Plaguelands",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			44454,
			"Field Agent Kaartish",
			"Western Plaguelands",
			49.3,
			54.9,
		},
	},
	[25080] = {
		4709,
		25080,
		1,
		33,
		"[33] [33] Batteries Not Yet Included",
		"A",
		2,
		"PALADINDRUIDMAGE",
		2,
		"DRAENEINIGHTELFGNOME",
		{
			39084,
			"Mizzy Pistonhammer",
			"Southern Barrens",
			49.5,
			67.5,
		},
	},
	[27159] = {
		28,
		27159,
		1,
		35,
		"Scourge First... Horde Later",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			44453,
			"Thassarian",
			"Western Plaguelands",
			41,
			70.40000000000001,
		},
	},
	[27383] = {
		139,
		27383,
		1,
		41,
		"Little Pamela",
		"A",
		2,
		"ROGUEMAGE",
		2,
		"NIGHTELFGNOME",
		{
			11063,
			"Carlin Redpath",
			"Eastern Plaguelands",
			35.6,
			68.90000000000001,
		},
	},
	[27479] = {
		139,
		27479,
		1,
		43,
		"Righteous Indignation",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			45736,
			"Deacon Andaal",
			"Eastern Plaguelands",
			61.2,
			43,
		},
	},
	[25688] = {
		4,
		25688,
		1,
		55,
		"The Altar of Storms",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			7506,
			"Bloodmage Lynnore",
			"Blasted Lands",
			39.3,
			36.2,
		},
	},
	[25720] = {
		4,
		25720,
		1,
		59,
		"The Downfall of Marl Wormthorn",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			42344,
			"Rohan Sunveil",
			"Blasted Lands",
			49.7,
			71.59999999999999,
		},
	},
	[27831] = {
		3,
		27831,
		1,
		47,
		"The Sorrow and the Fury",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			[3] = "Badlands",
			[4] = 15.5,
			[5] = 42.9,
		},
	},
	[12912] = {
		66,
		12912,
		1,
		76,
		"A Great Storm Approaches",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			29647,
			"Gymer",
			"Zul'Drak",
			19.7,
			56.4,
		},
	},
	[25848] = {
		406,
		25848,
		1,
		30,
		"Downfall",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			11858,
			"Grundig Darkcloud",
			"Stonetalon Mountains",
			72.2,
			83.7,
		},
	},
	[25880] = {
		406,
		25880,
		1,
		29,
		"[29] [29] Warn Master Thal'darah",
		"A",
		2,
		"PALADINDRUIDMAGE",
		2,
		"DRAENEINIGHTELFGNOME",
		{
			41233,
			"Scout Commander Barus",
			"Stonetalon Mountains",
			48.3,
			51.8,
		},
	},
	[25912] = {
		406,
		25912,
		1,
		29,
		"[29] [29] Seen Better Days",
		"A",
		2,
		"PALADINDRUIDMAGE",
		2,
		"DRAENEINIGHTELFGNOME",
		{
			41486,
			"Elder Sareth'na",
			"Stonetalon Mountains",
			39.6,
			30.8,
		},
	},
	[28055] = {
		51,
		28055,
		1,
		49,
		"Sweet, Horrible Freedom",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			47393,
			"Mountain-Lord Rendan",
			"Searing Gorge",
			0,
			0,
		},
	},
	[28119] = {
		361,
		28119,
		1,
		46,
		"Purity From Corruption",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			10922,
			"Greta Mosshoof",
			"Felwood",
			44,
			61.8,
		},
	},
	[28183] = {
		46,
		28183,
		1,
		50,
		"Return to Keeshan",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			14437,
			"Gorzeeki Wildeyes",
			"Burning Steppes",
			8.4,
			35.5,
		},
	},
	[26168] = {
		4,
		26168,
		1,
		55,
		"The Amulet of Sevine",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			42298,
			"Kasim Sharim",
			"Blasted Lands",
			62.5,
			26.1,
		},
	},
	[26232] = {
		40,
		26232,
		1,
		12,
		"Lou's Parting Thoughts",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			42405,
			"Two-Shoed Lou",
			"Westfall",
			49.6,
			19.4,
		},
	},
	[26296] = {
		40,
		26296,
		1,
		14,
		"Evidence Collection",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Westfall",
			[4] = 41.8,
			[5] = 67.59999999999999,
		},
	},
	[28471] = {
		618,
		28471,
		1,
		50,
		"The Final Piece",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			[3] = "Winterspring",
			[4] = 37.2,
			[5] = 55.8,
		},
	},
	[28535] = {
		618,
		28535,
		1,
		51,
		"Descendants of the High Elves",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			48659,
			"Quel'dorei Spirit",
			"Winterspring",
			50.8,
			54.9,
		},
	},
	[26520] = {
		44,
		26520,
		1,
		16,
		"Saving Foreman Oslow",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			[3] = "Redridge Mountains",
			[4] = 17.9,
			[5] = 18.6,
		},
	},
	[52] = {
		12,
		52,
		1,
		10,
		"Protect the Frontier",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			261,
			"Guard Thomas",
			"Elwynn Forest",
			73.90000000000001,
			72.2,
		},
	},
	[28631] = {
		618,
		28631,
		1,
		52,
		"The Perfect Horns",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			10305,
			"Umi Rumplesnicker",
			"Winterspring",
			59.4,
			49.8,
		},
	},
	[26616] = {
		44,
		26616,
		1,
		18,
		"It's Never Over",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			[3] = "Redridge Mountains",
			[4] = 26.3,
			[5] = 40,
		},
	},
	[26648] = {
		5287,
		26648,
		1,
		34,
		"Our Mortal Enemies",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			43556,
			"\"Dead-Eye\" Drederick McGumm",
			"The Cape of Stranglethorn",
			46.5,
			94.3,
		},
	},
	[26680] = {
		10,
		26680,
		1,
		22,
		"Ogre Thieves",
		"A",
		2,
		"WARLOCKSHAMAN",
		2,
		"HUMANDWARF",
		{
			289,
			"Abercrombie",
			"Duskwood",
			87.5,
			35.4,
		},
	},
	[26744] = {
		33,
		26744,
		1,
		26,
		"Deep Roots",
		"A",
		2,
		"DRUIDWARLOCK",
		2,
		"NIGHTELFHUMAN",
		{
			1422,
			"Corporal Sethman",
			"Northern Stranglethorn",
			47,
			10.9,
		},
	},
	[26776] = {
		33,
		26776,
		1,
		29,
		"Ghaliri",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			44017,
			"Priestess Thaalia",
			"Northern Stranglethorn",
			53.4,
			66.8,
		},
	},
	[840] = {
		14,
		840,
		1,
		10,
		"Conscript of the Horde",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			3336,
			"Takrin Pathseeker",
			"Durotar",
			50.9,
			43.5,
		},
	},
	[844] = {
		17,
		844,
		1,
		12,
		"Plainstrider Menace",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			34258,
			"Halga Bloodeye",
			"Northern Barrens",
			67.59999999999999,
			38.8,
		},
	},
	[9410] = {
		3483,
		9410,
		1,
		62,
		"A Spirit Guide",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16574,
			"Far Seer Regulkut",
			"Hellfire Peninsula",
			54.3,
			37.9,
		},
	},
	[13520] = {
		148,
		13520,
		1,
		10,
		"The Boon of the Seas",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			32972,
			"Serendia Oakwhisper",
			"Darkshore",
			51.8,
			18,
		},
	},
	[25017] = {
		440,
		25017,
		1,
		49,
		"Ancient Obstacles",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38922,
			"Examiner Andoren Dawnrise",
			"Tanaris",
			33.3,
			77,
		},
	},
	[848] = {
		17,
		848,
		1,
		15,
		"Fungal Spores",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			3390,
			"Apothecary Helbrim",
			"Northern Barrens",
			48.6,
			58.3,
		},
	},
	[25081] = {
		4709,
		25081,
		1,
		34,
		"Claim the Battlescar",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			39083,
			"Commander Roberts",
			"Southern Barrens",
			49.1,
			67,
		},
	},
	[13584] = {
		148,
		13584,
		1,
		16,
		"Calming the Earth",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			33112,
			"Selenn",
			"Darkshore",
			44.4,
			56.7,
		},
	},
	[27384] = {
		139,
		27384,
		1,
		41,
		"Pamela's Doll",
		"A",
		2,
		"ROGUEMAGE",
		2,
		"NIGHTELFGNOME",
		{
			10926,
			"Pamela Redpath",
			"Eastern Plaguelands",
			32.4,
			83.7,
		},
	},
	[13712] = {
		331,
		13712,
		1,
		21,
		"To the Rescue!",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			8582,
			"Kadrak",
			"Northern Barrens",
			42.7,
			15.1,
		},
	},
	[27448] = {
		139,
		27448,
		1,
		42,
		"The Trek Continues",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			45417,
			"Fiona",
			"Eastern Plaguelands",
			34.9,
			69.3,
		},
	},
	[27544] = {
		139,
		27544,
		1,
		41,
		"Cenarion Tenacity",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			45500,
			"Urk Gagbaz",
			"Eastern Plaguelands",
			35,
			68.09999999999999,
		},
	},
	[54] = {
		12,
		54,
		1,
		5,
		"Report to Goldshire",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			197,
			"Marshal McBride",
			"Elwynn Forest",
			48.1,
			42.1,
		},
	},
	[13808] = {
		331,
		13808,
		1,
		22,
		"Mission Improbable",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			33837,
			"Kadrak",
			"Ashenvale",
			73.59999999999999,
			62.1,
		},
	},
	[865] = {
		17,
		865,
		1,
		18,
		"It's Gotta be the Horn",
		"HA",
		2,
		"DRUIDHUNTERMAGE",
		2,
		"TROLLDRAENEIGNOME",
		{
			3446,
			"Mebok Mizzyrix",
			"Northern Barrens",
			0,
			0,
		},
	},
	[866] = {
		-24,
		866,
		1,
		16,
		"Root Samples",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			3446,
			"Mebok Mizzyrix",
			"Northern Barrens",
			0,
			0,
		},
	},
	[25689] = {
		4,
		25689,
		1,
		56,
		"Time is Short",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			7783,
			"Loramus Thalipedes",
			"Blasted Lands",
			39.3,
			35.8,
		},
	},
	[13888] = {
		331,
		13888,
		1,
		24,
		"Vortex",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			34289,
			"The Vortex",
			"Ashenvale",
			52.3,
			56.7,
		},
	},
	[870] = {
		17,
		870,
		1,
		13,
		"The Forgotten Pools",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			3448,
			"Tonga Runetotem",
			"Northern Barrens",
			49.5,
			58.7,
		},
	},
	[871] = {
		17,
		871,
		1,
		12,
		"In Defense of Far Watch",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			3337,
			"Kargal Battlescar",
			"Northern Barrens",
			67.7,
			39.3,
		},
	},
	[872] = {
		17,
		872,
		1,
		12,
		"The Far Watch Offensive",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			3337,
			"Kargal Battlescar",
			"Northern Barrens",
			0,
			0,
		},
	},
	[25849] = {
		11,
		25849,
		1,
		23,
		"When Archaeology Attacks",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			41411,
			"Prospector Whelgar",
			"Wetlands",
			38.9,
			39.4,
		},
	},
	[13968] = {
		17,
		13968,
		1,
		12,
		"The Tortusk Takedown",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			34513,
			"Togrik",
			"Northern Barrens",
			0,
			0,
		},
	},
	[25913] = {
		406,
		25913,
		1,
		29,
		"[29] [29] Putting Them to Rest",
		"A",
		2,
		"PALADINDRUIDMAGE",
		2,
		"DRAENEINIGHTELFGNOME",
		{
			41488,
			"Sentinel Mistress Geleneth",
			"Stonetalon Mountains",
			39.6,
			30.8,
		},
	},
	[25945] = {
		406,
		25945,
		1,
		26,
		"We're Here to Do One Thing, Maybe Two...",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			41678,
			"Blood Guard Aldo Rockrain",
			"Ashenvale",
			49.9,
			65.90000000000001,
		},
	},
	[877] = {
		17,
		877,
		1,
		16,
		"The Stagnant Oasis",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			34626,
			"Jerrik Highmountain",
			"Northern Barrens",
			0,
			0,
		},
	},
	[28056] = {
		51,
		28056,
		1,
		49,
		"Rise, Obsidion",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			47393,
			"Mountain-Lord Rendan",
			"Searing Gorge",
			0,
			0,
		},
	},
	[880] = {
		17,
		880,
		1,
		14,
		"Altered Beings",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			34626,
			"Jerrik Highmountain",
			"Northern Barrens",
			0,
			0,
		},
	},
	[881] = {
		17,
		881,
		1,
		13,
		"Echeyakee",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			3338,
			"Sergra Darkthorn",
			"Northern Barrens",
			0,
			0,
		},
	},
	[28184] = {
		46,
		28184,
		1,
		50,
		"Chiselgrip, the Heart of the Steppes",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			47811,
			"John J. Keeshan",
			"Burning Steppes",
			17.3,
			52,
		},
	},
	[26169] = {
		4,
		26169,
		1,
		55,
		"The Amulet of Grol",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			42298,
			"Kasim Sharim",
			"Blasted Lands",
			62.5,
			26.1,
		},
	},
	[14128] = {
		16,
		14128,
		1,
		10,
		"Return of the Highborne?",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			8576,
			"Ag'tor Bloodfist",
			"Azshara",
			26.9,
			76.90000000000001,
		},
	},
	[887] = {
		17,
		887,
		1,
		16,
		"Southsea Freebooters",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			3453,
			"Wharfmaster Dizzywig",
			"Northern Barrens",
			0,
			0,
		},
	},
	[14192] = {
		16,
		14192,
		1,
		11,
		"Prismbreak",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			[3] = "Azshara",
			[4] = 20.3,
			[5] = 70.3,
		},
	},
	[28440] = {
		46,
		28440,
		1,
		0,
		"Abuse of Power",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48133,
			"General Thorg'izog",
			"Burning Steppes",
			30.8,
			33.8,
		},
	},
	[891] = {
		17,
		891,
		1,
		15,
		"A Captain's Vengeance",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			3339,
			"Captain Thalo'thas Brightsun",
			"Northern Barrens",
			0,
			0,
		},
	},
	[14256] = {
		405,
		14256,
		1,
		32,
		"The Emerging Threat",
		"HA",
		2,
		"PALADINWARLOCK",
		2,
		"BLOODELFGNOME",
		{
			35773,
			"Cenarion Researcher Korrah",
			"Desolace",
			38.8,
			27,
		},
	},
	[28536] = {
		618,
		28536,
		1,
		51,
		"The Curse of Zin-Malor",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			48660,
			"Sin'dorei Spirit",
			"Winterspring",
			50.6,
			55.1,
		},
	},
	[26553] = {
		5287,
		26553,
		1,
		32,
		"High Priestess Jeklik",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			[3] = "Northern Stranglethorn",
			[4] = 78.5,
			[5] = 36.1,
		},
	},
	[28632] = {
		618,
		28632,
		1,
		52,
		"Fresh From The Hills",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			48965,
			"Deez Rocksnitch",
			"Winterspring",
			59.8,
			49.7,
		},
	},
	[24570] = {
		4709,
		24570,
		1,
		31,
		"Adder Subtraction",
		"AH",
		2,
		"DRUIDMAGEWARLOCK",
		2,
		"NIGHTELFGNOMESCOURGE",
		{
			38314,
			"Muyoh",
			"Southern Barrens",
			50.3,
			40.5,
		},
	},
	[10258] = {
		3483,
		10258,
		1,
		61,
		"Honor the Fallen",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			19736,
			"Althen the Historian",
			"Hellfire Peninsula",
			61.7,
			81.8,
		},
	},
	[899] = {
		17,
		899,
		1,
		12,
		"Consumed by Hatred",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			3432,
			"Mankrik",
			"Northern Barrens",
			0,
			0,
		},
	},
	[14384] = {
		405,
		14384,
		1,
		30,
		"[30] [30] Rerouted!",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			36410,
			"Officer Jankie",
			"Desolace",
			54.2,
			9.1,
		},
	},
	[26745] = {
		33,
		26745,
		1,
		26,
		"Favored Skull",
		"A",
		2,
		"DRUIDWARLOCK",
		2,
		"NIGHTELFHUMAN",
		{
			42736,
			"Lashtail Hatchling",
			"Northern Stranglethorn",
			33.7,
			37,
		},
	},
	[26777] = {
		10,
		26777,
		1,
		24,
		"Soothing Spirits",
		"A",
		2,
		"WARLOCKSHAMAN",
		2,
		"HUMANDWARF",
		{
			43731,
			"Sister Elsington",
			"Duskwood",
			19.9,
			58,
		},
	},
	[14432] = {
		16,
		14432,
		1,
		17,
		"A Pale Brew",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			8586,
			"Haggrum Bloodfist",
			"Azshara",
			42.4,
			23.7,
		},
	},
	[24794] = {
		490,
		24794,
		1,
		53,
		"Speak With Spraggle",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			10302,
			"Krakle",
			"Un'Goro Crater",
			55.2,
			62.4,
		},
	},
	[905] = {
		17,
		905,
		1,
		14,
		"Into the Raptor's Den",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			[3] = "Northern Barrens",
			[4] = 0,
			[5] = 0,
		},
	},
	[14480] = {
		16,
		14480,
		1,
		17,
		"Extermination",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36895,
			"Sergeant Zelks",
			"Azshara",
			34.4,
			44.8,
		},
	},
	[27001] = {
		28,
		27001,
		1,
		37,
		"This Means WAR (Wild Arachnid Roundup)",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			11616,
			"Nathaniel Dumah",
			"Western Plaguelands",
			48.1,
			32.5,
		},
	},
	[25018] = {
		440,
		25018,
		1,
		48,
		"Andoren Will Know",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38849,
			"Megs Dreadshredder",
			"Tanaris",
			44.5,
			52.7,
		},
	},
	[25082] = {
		4709,
		25082,
		1,
		34,
		"Working the Bugs Out",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			39085,
			"Logan Talonstrike",
			"Southern Barrens",
			49.3,
			67.8,
		},
	},
	[27161] = {
		28,
		27161,
		1,
		35,
		"The Endless Flow",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			44467,
			"Lang Loosegrip",
			"Western Plaguelands",
			41.2,
			70.2,
		},
	},
	[27385] = {
		139,
		27385,
		1,
		41,
		"Uncle Carlin",
		"A",
		2,
		"ROGUEMAGE",
		2,
		"NIGHTELFGNOME",
		{
			[3] = "Eastern Plaguelands",
			[4] = 32.5,
			[5] = 83.8,
		},
	},
	[27449] = {
		139,
		27449,
		1,
		42,
		"Honor and Strength",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			45574,
			"Vex'tul",
			"Eastern Plaguelands",
			52.8,
			51.5,
		},
	},
	[27481] = {
		139,
		27481,
		1,
		43,
		"Out of the Ziggurat",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			45574,
			"Vex'tul",
			"Eastern Plaguelands",
			61.6,
			41.5,
		},
	},
	[25690] = {
		4,
		25690,
		1,
		55,
		"A Bloodmage's Gotta Eat Too",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			7505,
			"Bloodmage Drazial",
			"Blasted Lands",
			39.2,
			36.2,
		},
	},
	[10834] = {
		3483,
		10834,
		1,
		62,
		"Grillok \"Darkeye\" [Group]",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			22231,
			"Zezzak",
			"Hellfire Peninsula",
			61.6,
			81.8,
		},
	},
	[25818] = {
		11,
		25818,
		1,
		23,
		"Lifting the Curse",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			41307,
			"First Mate Snellig",
			"Wetlands",
			15.3,
			29.3,
		},
	},
	[25850] = {
		11,
		25850,
		1,
		23,
		"Strike the Earth!",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			41412,
			"Ormer Ironbraid",
			"Wetlands",
			38.7,
			39.5,
		},
	},
	[25914] = {
		406,
		25914,
		1,
		29,
		"[29] [29] Back to the Depths!",
		"A",
		2,
		"PALADINDRUIDMAGE",
		2,
		"DRAENEINIGHTELFGNOME",
		{
			41488,
			"Sentinel Mistress Geleneth",
			"Stonetalon Mountains",
			39.6,
			30.8,
		},
	},
	[28057] = {
		51,
		28057,
		1,
		50,
		"Kill 'em With Sleep Deprivation",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			14628,
			"Evonice Sootsmoker",
			"Searing Gorge",
			43.8,
			28.6,
		},
	},
	[59] = {
		12,
		59,
		1,
		10,
		"Cloth and Leather Armor",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			261,
			"Guard Thomas",
			"Elwynn Forest",
			74,
			72.2,
		},
	},
	[28121] = {
		361,
		28121,
		1,
		46,
		"Forces of Jaedenar",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			11019,
			"Jessir Moonbow",
			"Felwood",
			44.1,
			62,
		},
	},
	[28153] = {
		361,
		28153,
		1,
		46,
		"Shadow Lord Fel'dan",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			[3] = "Felwood",
			[4] = 38.9,
			[5] = 50.4,
		},
	},
	[26170] = {
		4,
		26170,
		1,
		56,
		"The Final Ritual",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			42298,
			"Kasim Sharim",
			"Blasted Lands",
			62.5,
			26.3,
		},
	},
	[26266] = {
		40,
		26266,
		1,
		13,
		"Hope for the People",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			235,
			"Salma Saldean",
			"Westfall",
			56.5,
			30.4,
		},
	},
	[28441] = {
		46,
		28441,
		1,
		51,
		"Enough Damage For One Day",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			7025,
			"Blackrock Soldier",
			"Burning Steppes",
			34.2,
			35.2,
		},
	},
	[28537] = {
		618,
		28537,
		1,
		51,
		"In Pursuit of Shades",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			10920,
			"Kelek Skykeeper",
			"Winterspring",
			46.8,
			53.9,
		},
	},
	[28569] = {
		8,
		28569,
		1,
		52,
		"The Bogpaddle Bullet",
		"A",
		2,
		"MAGEPALADIN",
		2,
		"DRAENEIHUMAN",
		{
			9177,
			"Oralius",
			"Burning Steppes",
			71.90000000000001,
			68,
		},
	},
	[60] = {
		12,
		60,
		1,
		7,
		"Kobold Candles",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			253,
			"William Pestle",
			"Elwynn Forest",
			43.3,
			65.8,
		},
	},
	[26586] = {
		44,
		26586,
		1,
		17,
		"In Search of Bravo Company",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			43221,
			"Colonel Troteman",
			"Redridge Mountains",
			28.6,
			40.8,
		},
	},
	[26618] = {
		10,
		26618,
		1,
		21,
		"Wolves at Our Heels",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			264,
			"Commander Althea Ebonlocke",
			"Duskwood",
			73.5,
			47,
		},
	},
	[26650] = {
		5287,
		26650,
		1,
		35,
		"The Damsel's Luck",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2546,
			"Fleet Master Firallon",
			"The Cape of Stranglethorn",
			46.7,
			95.3,
		},
	},
	[26714] = {
		44,
		26714,
		1,
		20,
		"Darkblaze, Brood of the Worldbreaker",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Redridge Mountains",
			[4] = 59.5,
			[5] = 54.8,
		},
	},
	[26746] = {
		33,
		26746,
		1,
		26,
		"A Nose for This Sort of Thing",
		"A",
		2,
		"DRUIDWARLOCK",
		2,
		"NIGHTELFHUMAN",
		{
			43884,
			"Osborn Obnoticus",
			"Northern Stranglethorn",
			47.2,
			10.7,
		},
	},
	[26778] = {
		10,
		26778,
		1,
		24,
		"The Cries of the Dead",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Duskwood",
			[4] = 19.9,
			[5] = 57.9,
		},
	},
	[24955] = {
		440,
		24955,
		1,
		48,
		"Un-Chartered",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38849,
			"Megs Dreadshredder",
			"Tanaris",
			44.6,
			52.7,
		},
	},
	[13521] = {
		148,
		13521,
		1,
		10,
		"Buzzbox 413",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			32977,
			"Wizbang Cranktoggle",
			"Darkshore",
			51.2,
			19.6,
		},
	},
	[13537] = {
		148,
		13537,
		1,
		11,
		"A Taste for Grouper",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			33175,
			"Johnathan Staats",
			"Darkshore",
			52.3,
			18,
		},
	},
	[13569] = {
		148,
		13569,
		1,
		12,
		"The Ritual Bond",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			33048,
			"Keeper Karithus",
			"Darkshore",
			43,
			38.9,
		},
	},
	[13585] = {
		148,
		13585,
		1,
		17,
		"Sworn to Protect",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			33112,
			"Selenn",
			"Darkshore",
			44.5,
			56.7,
		},
	},
	[13601] = {
		148,
		13601,
		1,
		15,
		"In Aid of the Refugees",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			32912,
			"Sentinel Lendra",
			"Darkshore",
			50.3,
			20.3,
		},
	},
	[27386] = {
		139,
		27386,
		1,
		41,
		"A Strange Historian",
		"A",
		2,
		"ROGUEMAGE",
		2,
		"NIGHTELFGNOME",
		{
			11063,
			"Carlin Redpath",
			"Eastern Plaguelands",
			35.6,
			68.8,
		},
	},
	[27450] = {
		139,
		27450,
		1,
		42,
		"Frederick's Fish Fancy",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			45575,
			"Frederick Calston",
			"Eastern Plaguelands",
			53.8,
			53.9,
		},
	},
	[27482] = {
		139,
		27482,
		1,
		43,
		"Into the Flames",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			[3] = "Eastern Plaguelands",
			[4] = 67,
			[5] = 9.6,
		},
	},
	[62] = {
		12,
		62,
		1,
		7,
		"The Fargodeep Mine",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			240,
			"Marshal Dughan",
			"Elwynn Forest",
			42.2,
			65.90000000000001,
		},
	},
	[9731] = {
		3521,
		9731,
		1,
		63,
		"Drain Schematics",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			[3] = "Zangarmarsh",
			[4] = 61.9,
			[5] = 40.7,
		},
	},
	[25627] = {
		400,
		25627,
		1,
		42,
		"[42] [42] Two-Tusk Takedown",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			40885,
			"Wizzle Brassbolts",
			"Thousand Needles",
			91.59999999999999,
			78.7,
		},
	},
	[25691] = {
		4,
		25691,
		1,
		56,
		"The Charred Granite of the Dark Portal",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			41159,
			"Watcher Wazzik",
			"Blasted Lands",
			54.3,
			49.9,
		},
	},
	[27834] = {
		3,
		27834,
		1,
		47,
		"Baelog, the Glass Cannon",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			46853,
			"Baelog",
			"Badlands",
			20.6,
			56,
		},
	},
	[25819] = {
		11,
		25819,
		1,
		23,
		"The Eye of Paleth",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			[3] = "Wetlands",
			[4] = 14.4,
			[5] = 24.1,
		},
	},
	[25851] = {
		406,
		25851,
		1,
		30,
		"Dances with Grimtotem",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			11858,
			"Grundig Darkcloud",
			"Stonetalon Mountains",
			72.40000000000001,
			83.7,
		},
	},
	[13969] = {
		17,
		13969,
		1,
		12,
		"Grol'dom's Missing Kodo",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			5907,
			"Kranal Fiss",
			"Northern Barrens",
			0,
			0,
		},
	},
	[27962] = {
		51,
		27962,
		1,
		47,
		"A Lumbering Relic",
		"HA",
		2,
		"DEATHKNIGHTMAGE",
		2,
		"BLOODELFDRAENEI",
		{
			47267,
			"Burrian Coalpart",
			"Searing Gorge",
			0,
			0,
		},
	},
	[27994] = {
		361,
		27994,
		1,
		45,
		"Ruumbo Demands Justice",
		"H",
		2,
		"DRUIDWARRIOR",
		2,
		"TROLLTAUREN",
		{
			[3] = "Felwood",
			[4] = 51.6,
			[5] = 83.7,
		},
	},
	[26011] = {
		406,
		26011,
		1,
		27,
		"Enemy of the Horde: Marshal Paltrow",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			40903,
			"Spy-Mistress Anara",
			"Stonetalon Mountains",
			65.7,
			63.3,
		},
	},
	[26043] = {
		406,
		26043,
		1,
		27,
		"BEWARE OF CRAGJAW! [Group]",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			[3] = "Stonetalon Mountains",
			[4] = 65,
			[5] = 49.4,
		},
	},
	[26075] = {
		406,
		26075,
		1,
		30,
		"The Turd Problem",
		"H",
		2,
		"WARLOCKPALADIN",
		2,
		"SCOURGEBLOODELF",
		{
			42033,
			"Jibbly Rakit",
			"Stonetalon Mountains",
			52.9,
			39.2,
		},
	},
	[26171] = {
		4,
		26171,
		1,
		57,
		"You Are Rakh'likh, Demon",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			7783,
			"Loramus Thalipedes",
			"Blasted Lands",
			62.3,
			26.1,
		},
	},
	[14129] = {
		16,
		14129,
		1,
		11,
		"Runaway Shredder!",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35086,
			"Labor Captain Grabbit",
			"Azshara",
			26.9,
			77,
		},
	},
	[26235] = {
		-304,
		26235,
		3,
		11,
		"Even Thieves Get Hungry",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			42506,
			"Marogg",
			"Orgrimmar",
			56.4,
			62.7,
		},
	},
	[14161] = {
		16,
		14161,
		1,
		11,
		"Basilisk Bashin'",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35091,
			"Horzak Zignibble",
			"Azshara",
			29.1,
			66.3,
		},
	},
	[14193] = {
		405,
		14193,
		1,
		30,
		"Nothing a Couple of Melons Won't Fix",
		"A",
		2,
		"WARLOCK",
		2,
		"GNOME",
		{
			4675,
			"Hatefury Hellcaller",
			"Desolace",
			77,
			18.2,
		},
	},
	[14209] = {
		16,
		14209,
		1,
		12,
		"Gunk in the Trunk",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35088,
			"Custer Clubnik",
			"Azshara",
			29.7,
			66.90000000000001,
		},
	},
	[26395] = {
		12,
		26395,
		1,
		7,
		"Dungar Longdrink",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			1323,
			"Osric Strang",
			"Stormwind City",
			76.90000000000001,
			61.5,
		},
	},
	[14257] = {
		405,
		14257,
		1,
		32,
		"Slitherblade Slaughter",
		"HA",
		2,
		"PALADINWARLOCK",
		2,
		"BLOODELFGNOME",
		{
			35773,
			"Cenarion Researcher Korrah",
			"Desolace",
			38.8,
			27,
		},
	},
	[26555] = {
		5287,
		26555,
		1,
		32,
		"High Priest Venoxis",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			[3] = "Northern Stranglethorn",
			[4] = 82.3,
			[5] = 35.5,
		},
	},
	[26587] = {
		44,
		26587,
		1,
		17,
		"Breaking Out is Hard to Do",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			43270,
			"Messner",
			"Redridge Mountains",
			47.6,
			41.9,
		},
	},
	[24572] = {
		4709,
		24572,
		1,
		33,
		"Taking Back Taurajo",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			37679,
			"Warlord Bloodhilt",
			"Southern Barrens",
			41.5,
			46.9,
		},
	},
	[26651] = {
		44,
		26651,
		1,
		18,
		"To Win a War, You Gotta Become War",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			[3] = "Redridge Mountains",
			[4] = 69.40000000000001,
			[5] = 60.5,
		},
	},
	[26683] = {
		10,
		26683,
		1,
		21,
		"Look To The Stars",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			276,
			"Viktori Prism'Antras",
			"Duskwood",
			79.59999999999999,
			47.3,
		},
	},
	[14385] = {
		16,
		14385,
		1,
		14,
		"Azsharite Experiment Number One",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36077,
			"Assistant Greely",
			"Azshara",
			50.3,
			74.3,
		},
	},
	[26747] = {
		33,
		26747,
		1,
		26,
		"A Physical Specimen",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			43884,
			"Osborn Obnoticus",
			"Northern Stranglethorn",
			47.2,
			10.6,
		},
	},
	[26779] = {
		33,
		26779,
		1,
		29,
		"Zul'Mamwe Mambo",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			44021,
			"Ghaliri",
			"Northern Stranglethorn",
			52.7,
			66.7,
		},
	},
	[14433] = {
		16,
		14433,
		1,
		17,
		"Diplomacy by Another Means",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			8586,
			"Haggrum Bloodfist",
			"Azshara",
			42.5,
			23.7,
		},
	},
	[10403] = {
		3483,
		10403,
		1,
		62,
		"Naladu",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			20678,
			"Akoru the Firecaller",
			"Hellfire Peninsula",
			15.6,
			58.7,
		},
	},
	[24956] = {
		4709,
		24956,
		1,
		31,
		"Silencing Rageroar",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38804,
			"Tolliver Houndstooth",
			"Southern Barrens",
			66.90000000000001,
			46.7,
		},
	},
	[25020] = {
		440,
		25020,
		1,
		49,
		"Fragments of Language",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38922,
			"Examiner Andoren Dawnrise",
			"Tanaris",
			33.3,
			77,
		},
	},
	[25084] = {
		4709,
		25084,
		1,
		34,
		"A Growing Threat",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			37835,
			"Dorn Redearth",
			"Southern Barrens",
			45.1,
			85.3,
		},
	},
	[27163] = {
		28,
		27163,
		1,
		35,
		"Brute Strength",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			44453,
			"Thassarian",
			"Western Plaguelands",
			41.1,
			70.40000000000001,
		},
	},
	[27387] = {
		139,
		27387,
		1,
		41,
		"Villains of Darrowshire",
		"A",
		2,
		"ROGUEMAGE",
		2,
		"NIGHTELFGNOME",
		{
			10667,
			"Chromie",
			"Eastern Plaguelands",
			35.2,
			68.09999999999999,
		},
	},
	[27451] = {
		139,
		27451,
		1,
		42,
		"To Kill With Purpose",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			11035,
			"Betina Bigglezink",
			"Eastern Plaguelands",
			53.2,
			54.5,
		},
	},
	[12770] = {
		394,
		12770,
		1,
		75,
		"Reallocating Resources",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			26212,
			"Captain Gryan Stoutmantle",
			"Grizzly Hills",
			59.4,
			26.1,
		},
	},
	[25660] = {
		400,
		25660,
		1,
		41,
		"[41] [41] Haunted",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			41058,
			"Spirit of Tony Two-Tusk",
			"Thousand Needles",
			91.7,
			78.59999999999999,
		},
	},
	[25692] = {
		4,
		25692,
		1,
		56,
		"The Vile Blood of Demons",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			41159,
			"Watcher Wazzik",
			"Blasted Lands",
			54.3,
			49.9,
		},
	},
	[10835] = {
		3483,
		10835,
		1,
		61,
		"Apothecary Antonivich",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			21279,
			"Apothecary Albreck",
			"Hellfire Peninsula",
			61.1,
			81.7,
		},
	},
	[27835] = {
		3,
		27835,
		1,
		47,
		"Olaf, the Big Fella'",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			[3] = "Badlands",
			[4] = 20.6,
			[5] = 56,
		},
	},
	[12914] = {
		66,
		12914,
		1,
		76,
		"Gymer's Salvation",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			29688,
			"Engineer Reed",
			"Zul'Drak",
			25.2,
			63.9,
		},
	},
	[25852] = {
		406,
		25852,
		1,
		30,
		"All's Clear",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			41229,
			"Force Commander Valen",
			"Stonetalon Mountains",
			71.2,
			79.7,
		},
	},
	[27963] = {
		51,
		27963,
		1,
		47,
		"A New Master... But Who?",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			47266,
			"Jack Rockleg",
			"Searing Gorge",
			68.5,
			53.5,
		},
	},
	[27995] = {
		361,
		27995,
		1,
		46,
		"Dance for Ruumbo!",
		"H",
		2,
		"DRUIDWARRIOR",
		2,
		"TROLLTAUREN",
		{
			[3] = "Felwood",
			[4] = 51.5,
			[5] = 83.59999999999999,
		},
	},
	[26044] = {
		406,
		26044,
		1,
		27,
		"Where Are the Parts?",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			40902,
			"Chief Blastgineer Bombgutz",
			"Stonetalon Mountains",
			66.2,
			63,
		},
	},
	[26076] = {
		406,
		26076,
		1,
		30,
		"Spy Infestation",
		"H",
		2,
		"WARLOCKPALADIN",
		2,
		"SCOURGEBLOODELF",
		{
			42033,
			"Jibbly Rakit",
			"Stonetalon Mountains",
			52.9,
			39.2,
		},
	},
	[28155] = {
		361,
		28155,
		1,
		46,
		"Lord Banehollow",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			[3] = "Felwood",
			[4] = 39.7,
			[5] = 47,
		},
	},
	[26172] = {
		4,
		26172,
		1,
		55,
		"A Bloodmage's Gotta Eat Too",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			42298,
			"Kasim Sharim",
			"Blasted Lands",
			62.5,
			26.3,
		},
	},
	[26236] = {
		40,
		26236,
		1,
		12,
		"Shakedown at the Saldean's",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			42558,
			"Lieutenant Horatio Laine",
			"Westfall",
			49.7,
			19.5,
		},
	},
	[28315] = {
		46,
		28315,
		1,
		51,
		"Draconic Vanguard",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			48346,
			"John J. Keeshan",
			"Burning Steppes",
			73.59999999999999,
			67.09999999999999,
		},
	},
	[71] = {
		12,
		71,
		1,
		10,
		"Report to Thomas",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Elwynn Forest",
			[4] = 79.8,
			[5] = 55.7,
		},
	},
	[26396] = {
		12,
		26396,
		1,
		7,
		"Return to Argus",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			352,
			"Dungar Longdrink",
			"Stormwind City",
			70.90000000000001,
			72.7,
		},
	},
	[26556] = {
		-101,
		26556,
		3,
		80,
		"No Dumping Allowed",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			43239,
			"Razgar",
			"Orgrimmar",
			65.90000000000001,
			40.9,
		},
	},
	[26620] = {
		10,
		26620,
		1,
		21,
		"Seasoned Wolf Kabobs",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			272,
			"Chef Grual",
			"Duskwood",
			73.8,
			43.5,
		},
	},
	[26652] = {
		10,
		26652,
		1,
		21,
		"Ghost Hair Thread",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			265,
			"Madame Eva",
			"Duskwood",
			75.7,
			45.4,
		},
	},
	[26684] = {
		10,
		26684,
		1,
		21,
		"The Insane Ghoul",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			302,
			"Blind Mary",
			"Duskwood",
			81.90000000000001,
			59.1,
		},
	},
	[26748] = {
		33,
		26748,
		1,
		26,
		"Bloodlord Mandokir",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			42790,
			"Bloodlord Mandokir",
			"Northern Stranglethorn",
			47.2,
			10.6,
		},
	},
	[26780] = {
		33,
		26780,
		1,
		29,
		"Nighttime in the Jungle",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			44043,
			"Kinnel",
			"Northern Stranglethorn",
			53,
			66.2,
		},
	},
	[26908] = {
		491,
		26908,
		1,
		33,
		"Feeling Thorny",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			37812,
			"Mahka",
			"Southern Barrens",
			45.1,
			85.40000000000001,
		},
	},
	[9396] = {
		3483,
		9396,
		1,
		62,
		"Magic of the Arakkoa",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16792,
			"Arcanist Calesthris Dawnstar",
			"Hellfire Peninsula",
			27,
			59.7,
		},
	},
	[24957] = {
		440,
		24957,
		1,
		48,
		"Get The Centipaarty Started",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38849,
			"Megs Dreadshredder",
			"Tanaris",
			44.5,
			52.7,
		},
	},
	[13522] = {
		148,
		13522,
		1,
		10,
		"Threat from the Water",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			32971,
			"Ranger Glynda Nal'Shea",
			"Darkshore",
			50.2,
			19.8,
		},
	},
	[25021] = {
		440,
		25021,
		1,
		45,
		"Blood to Thrive",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38927,
			"Mazoga",
			"Tanaris",
			42.3,
			23.9,
		},
	},
	[13554] = {
		148,
		13554,
		1,
		11,
		"A Cure In The Dark",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			[3] = "Darkshore",
			[4] = 54.2,
			[5] = 29.3,
		},
	},
	[25085] = {
		4709,
		25085,
		1,
		34,
		"Mangletooth",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			37835,
			"Dorn Redearth",
			"Southern Barrens",
			45.1,
			85.3,
		},
	},
	[13586] = {
		148,
		13586,
		1,
		17,
		"The Emerald Dream",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			33091,
			"Malfurion Stormrage",
			"Darkshore",
			43.7,
			53.4,
		},
	},
	[13618] = {
		331,
		13618,
		1,
		21,
		"Find Gorat!",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			8582,
			"Kadrak",
			"Northern Barrens",
			42.3,
			15.3,
		},
	},
	[27388] = {
		139,
		27388,
		1,
		41,
		"Heroes of Darrowshire",
		"A",
		2,
		"ROGUEMAGE",
		2,
		"NIGHTELFGNOME",
		{
			10667,
			"Chromie",
			"Eastern Plaguelands",
			35.2,
			68.09999999999999,
		},
	},
	[27420] = {
		139,
		27420,
		1,
		41,
		"Postponing the Inevitable",
		"A",
		2,
		"ROGUEMAGE",
		2,
		"NIGHTELFGNOME",
		{
			16135,
			"Rayne",
			"Eastern Plaguelands",
			30.2,
			56.9,
		},
	},
	[27452] = {
		139,
		27452,
		1,
		42,
		"Dark Garb",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			11035,
			"Betina Bigglezink",
			"Eastern Plaguelands",
			53.1,
			54.5,
		},
	},
	[76] = {
		12,
		76,
		1,
		10,
		"The Jasperlode Mine",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			240,
			"Marshal Dughan",
			"Elwynn Forest",
			42.2,
			66,
		},
	},
	[9716] = {
		3521,
		9716,
		1,
		63,
		"Disturbance at Umbrafen Lake",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			17841,
			"Ysiel Windsinger",
			"Zangarmarsh",
			78.40000000000001,
			62.1,
		},
	},
	[13842] = {
		331,
		13842,
		1,
		23,
		"Dread Head Redemption",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			39605,
			"Garrosh Hellscream",
			"Orgrimmar",
			48.1,
			70.59999999999999,
		},
	},
	[25661] = {
		400,
		25661,
		1,
		42,
		"[42] [42] With a Little Help...",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			41060,
			"Ajamon Ghostcaller",
			"Thousand Needles",
			96.8,
			72.40000000000001,
		},
	},
	[25693] = {
		4,
		25693,
		1,
		56,
		"Enhancing the Stone",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			41159,
			"Watcher Wazzik",
			"Blasted Lands",
			54.3,
			50.2,
		},
	},
	[9796] = {
		3521,
		9796,
		1,
		62,
		"News from Zangarmarsh",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			18011,
			"Zurai",
			"Zangarmarsh",
			85.3,
			54.7,
		},
	},
	[9828] = {
		3521,
		9828,
		1,
		62,
		"Withered Basidium",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			18124,
			"Withered Giant",
			"Zangarmarsh",
			81.59999999999999,
			44.7,
		},
	},
	[25821] = {
		406,
		25821,
		1,
		28,
		"A Special Kind of Job",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			41277,
			"Lieutenant Paulson",
			"Stonetalon Mountains",
			72,
			76,
		},
	},
	[9860] = {
		99999,
		9860,
		1,
		70,
		"The New Directive",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			17613,
			"Archmage Alturus",
			"Deadwind Pass",
			47,
			75.5,
		},
	},
	[13970] = {
		17,
		13970,
		1,
		12,
		"Animal Services",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			34547,
			"Grol'dom Kodo",
			"Northern Barrens",
			58.1,
			49.3,
		},
	},
	[27964] = {
		51,
		27964,
		1,
		47,
		"Dig-Boss Dinwhisker",
		"HA",
		2,
		"DEATHKNIGHTMAGE",
		2,
		"BLOODELFDRAENEI",
		{
			47266,
			"Jack Rockleg",
			"Searing Gorge",
			0,
			0,
		},
	},
	[28028] = {
		51,
		28028,
		1,
		49,
		"Siege!",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			47393,
			"Mountain-Lord Rendan",
			"Searing Gorge",
			39.3,
			67.90000000000001,
		},
	},
	[28060] = {
		51,
		28060,
		1,
		50,
		"Twisted Twilight Ties",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			14626,
			"Taskmaster Scrange",
			"Searing Gorge",
			42.3,
			34.5,
		},
	},
	[26045] = {
		406,
		26045,
		1,
		27,
		"I Got Your Parts Right Here...",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			41991,
			"Sergeant Dontrag",
			"Stonetalon Mountains",
			67.09999999999999,
			64.40000000000001,
		},
	},
	[14066] = {
		17,
		14066,
		5,
		15,
		"Investigate the Wreckage",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			3464,
			"Gazrog",
			"Northern Barrens",
			0,
			0,
		},
	},
	[26173] = {
		4,
		26173,
		1,
		56,
		"Protecting Our Rear",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			[3] = "Blasted Lands",
			[4] = 54.7,
			[5] = 50.4,
		},
	},
	[14130] = {
		16,
		14130,
		1,
		17,
		"Friends Come In All Colors",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35867,
			"Kalec",
			"Azshara",
			55.4,
			52.1,
		},
	},
	[14146] = {
		16,
		14146,
		1,
		11,
		"Defend the Gates!",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			[3] = "Azshara",
			[4] = 30.5,
			[5] = 77.2,
		},
	},
	[26269] = {
		33,
		26269,
		1,
		25,
		"The Green Hills of Stranglethorn",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			716,
			"Barnil Stonepot",
			"Northern Stranglethorn",
			44.2,
			22.2,
		},
	},
	[14194] = {
		16,
		14194,
		1,
		11,
		"Refleshification",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			[3] = "Azshara",
			[4] = 20.1,
			[5] = 70.09999999999999,
		},
	},
	[26365] = {
		44,
		26365,
		1,
		15,
		"Hero's Call: Redridge Mountains!",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			29611,
			"King Varian Wrynn",
			"Stormwind City",
			85.7,
			31.8,
		},
	},
	[28444] = {
		46,
		28444,
		1,
		51,
		"Latent Demons of the Land",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48569,
			"Eitrigg",
			"Burning Steppes",
			0,
			0,
		},
	},
	[14258] = {
		16,
		14258,
		1,
		12,
		"Mortar the Point",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35817,
			"Bombardier Captain Smooks",
			"Azshara",
			52.2,
			74.2,
		},
	},
	[28540] = {
		618,
		28540,
		1,
		51,
		"Doin' De E'ko Magic [Group]",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			10307,
			"Witch Doctor Mau'ari",
			"Winterspring",
			25.2,
			58.5,
		},
	},
	[24478] = {
		16,
		24478,
		1,
		18,
		"The Trial of Frost",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36361,
			"Image of Archmage Xylem",
			"Azshara",
			56,
			12.2,
		},
	},
	[26557] = {
		-101,
		26557,
		3,
		80,
		"A Staggering Effort",
		"H",
		2,
		"DRUIDWARLOCK",
		2,
		"TROLLSCOURGE",
		{
			43239,
			"Razgar",
			"Orgrimmar",
			65.7,
			40.8,
		},
	},
	[14322] = {
		16,
		14322,
		1,
		13,
		"Bad Science! Bad!",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36146,
			"Twistex Happytongs",
			"Azshara",
			45,
			75.5,
		},
	},
	[24574] = {
		4709,
		24574,
		1,
		32,
		"To Harvest Chaos",
		"AH",
		2,
		"DRUIDMAGEWARLOCK",
		2,
		"NIGHTELFGNOMESCOURGE",
		{
			37570,
			"Naralex",
			"Southern Barrens",
			50.4,
			40.7,
		},
	},
	[26653] = {
		10,
		26653,
		1,
		21,
		"Supplies from Darkshire",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			289,
			"Abercrombie",
			"Duskwood",
			87.40000000000001,
			35.3,
		},
	},
	[26685] = {
		10,
		26685,
		1,
		22,
		"Classy Glass",
		"A",
		2,
		"WARLOCKSHAMANPALADIN",
		2,
		"HUMANDWARF",
		{
			276,
			"Viktori Prism'Antras",
			"Duskwood",
			79.5,
			47.3,
		},
	},
	[26717] = {
		10,
		26717,
		1,
		24,
		"The Yorgen Worgen",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			43738,
			"Apprentice Fess",
			"Duskwood",
			44.8,
			67.3,
		},
	},
	[28796] = {
		12,
		28796,
		1,
		3,
		"They Sent Assassins",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			823,
			"Sergeant Willem",
			"Elwynn Forest",
			48.8,
			38.4,
		},
	},
	[28828] = {
		618,
		28828,
		1,
		53,
		"You Gotta Have Eggs",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			49396,
			"Jez Goodgrub",
			"Winterspring",
			56,
			28.2,
		},
	},
	[24862] = {
		4709,
		24862,
		1,
		30,
		"Running the Gauntlet",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38378,
			"Commander Walpole",
			"Southern Barrens",
			29.8,
			9,
		},
	},
	[24926] = {
		490,
		24926,
		1,
		52,
		"Serving A-Me 01",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			9623,
			"A-Me 01",
			"Un'Goro Crater",
			63.8,
			19.8,
		},
	},
	[25022] = {
		4709,
		25022,
		1,
		31,
		"A Failure to Communicate",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38871,
			"Corporal Teegan",
			"Southern Barrens",
			56.2,
			42.7,
		},
	},
	[25086] = {
		4709,
		25086,
		1,
		34,
		"Firestone Point",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			39085,
			"Logan Talonstrike",
			"Southern Barrens",
			49.2,
			67.90000000000001,
		},
	},
	[27165] = {
		28,
		27165,
		1,
		35,
		"Victory, For Now",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			44453,
			"Thassarian",
			"Western Plaguelands",
			41.1,
			70.40000000000001,
		},
	},
	[25182] = {
		4709,
		25182,
		1,
		35,
		"Kill 'em All!",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			39118,
			"General Twinbraid",
			"Southern Barrens",
			43.6,
			78.3,
		},
	},
	[83] = {
		12,
		83,
		1,
		10,
		"Fine Linen Goods",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			278,
			"Sara Timberlain",
			"Elwynn Forest",
			79.5,
			68.59999999999999,
		},
	},
	[27389] = {
		139,
		27389,
		1,
		41,
		"Marauders of Darrowshire",
		"A",
		2,
		"ROGUEMAGE",
		2,
		"NIGHTELFGNOME",
		{
			10667,
			"Chromie",
			"Eastern Plaguelands",
			35.2,
			68.09999999999999,
		},
	},
	[27421] = {
		139,
		27421,
		1,
		41,
		"Amidst Death, Life",
		"A",
		2,
		"ROGUEMAGE",
		2,
		"NIGHTELFGNOME",
		{
			16135,
			"Rayne",
			"Eastern Plaguelands",
			30.2,
			56.9,
		},
	},
	[27453] = {
		139,
		27453,
		1,
		42,
		"Catalysm",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			[3] = "Eastern Plaguelands",
			[4] = 55.5,
			[5] = 64.40000000000001,
		},
	},
	[84] = {
		12,
		84,
		1,
		6,
		"Back to Billy",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			246,
			"\"Auntie\" Bernice Stonefield",
			"Elwynn Forest",
			34.5,
			84.3,
		},
	},
	[27613] = {
		139,
		27613,
		1,
		42,
		"The Assassin",
		"A",
		2,
		"ROGUEPALADIN",
		2,
		"NIGHTELFHUMAN",
		{
			16115,
			"Crusade Commander Eligor Dawnbringer",
			"Eastern Plaguelands",
			76.7,
			73.2,
		},
	},
	[25662] = {
		406,
		25662,
		1,
		26,
		"Free Our Sisters",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			40896,
			"Lord Fallowmere",
			"Stonetalon Mountains",
			59.5,
			56.9,
		},
	},
	[25694] = {
		4,
		25694,
		1,
		56,
		"Protecting Our Rear",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			19254,
			"Warlord Dar'toon",
			"Blasted Lands",
			54.4,
			50.4,
		},
	},
	[12883] = {
		66,
		12883,
		1,
		75,
		"Orders From Drakuru",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			[3] = "Zul'Drak",
			[4] = 34.9,
			[5] = 83.90000000000001,
		},
	},
	[25790] = {
		400,
		25790,
		1,
		41,
		"[41] [41] Back to Crazzle",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			41204,
			"Khan Ablinh",
			"Thousand Needles",
			91.3,
			53.7,
		},
	},
	[25822] = {
		406,
		25822,
		1,
		28,
		"Armaments for War",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			41229,
			"Force Commander Valen",
			"Stonetalon Mountains",
			71.09999999999999,
			79.7,
		},
	},
	[25854] = {
		11,
		25854,
		1,
		23,
		"I'll Call Him Bitey",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			41435,
			"Fradd Swiftgear",
			"Wetlands",
			26.7,
			25.9,
		},
	},
	[27965] = {
		51,
		27965,
		1,
		48,
		"Thorium Point: The Seat of the Brotherhood",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			47266,
			"Jack Rockleg",
			"Searing Gorge",
			68.5,
			53.4,
		},
	},
	[27997] = {
		361,
		27997,
		1,
		45,
		"The Corruption of the Jadefire",
		"H",
		2,
		"DRUIDWARRIOR",
		2,
		"TROLLTAUREN",
		{
			10923,
			"Tenell Leafrunner",
			"Felwood",
			51.2,
			80.5,
		},
	},
	[28029] = {
		51,
		28029,
		1,
		49,
		"Set Them Ablaze!",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			47393,
			"Mountain-Lord Rendan",
			"Searing Gorge",
			0,
			0,
		},
	},
	[28061] = {
		51,
		28061,
		1,
		50,
		"Minions of Calcinder",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			14625,
			"Overseer Oilfist",
			"Searing Gorge",
			0,
			0,
		},
	},
	[86] = {
		12,
		86,
		1,
		6,
		"Pie for Billy",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			247,
			"Billy Maclure",
			"Elwynn Forest",
			43.1,
			85.7,
		},
	},
	[26174] = {
		4,
		26174,
		1,
		56,
		"Watching Our Back",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			16841,
			"Watch Commander Relthorn Netherwane",
			"Blasted Lands",
			54.6,
			50.4,
		},
	},
	[26270] = {
		40,
		26270,
		1,
		13,
		"You Have Our Thanks",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			233,
			"Farmer Saldean",
			"Westfall",
			56.1,
			31.2,
		},
	},
	[87] = {
		12,
		87,
		1,
		8,
		"Goldtooth",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			247,
			"Billy Maclure",
			"Elwynn Forest",
			43.1,
			85.8,
		},
	},
	[28445] = {
		46,
		28445,
		1,
		51,
		"A Heap of Delicious Worg",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48569,
			"Eitrigg",
			"Burning Steppes",
			0,
			0,
		},
	},
	[26494] = {
		5287,
		26494,
		1,
		31,
		"Mixmaster Jasper",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			43095,
			"Sassy Hardwrench",
			"The Cape of Stranglethorn",
			34.7,
			29.5,
		},
	},
	[24479] = {
		16,
		24479,
		1,
		18,
		"The Trial of Shadow",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36361,
			"Image of Archmage Xylem",
			"Azshara",
			56,
			12.1,
		},
	},
	[88] = {
		12,
		88,
		1,
		9,
		"Princess Must Die!",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			244,
			"Ma Stonefield",
			"Elwynn Forest",
			34.7,
			84.40000000000001,
		},
	},
	[28637] = {
		618,
		28637,
		1,
		53,
		"A Taste for Bear",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			49436,
			"Francis Morcott",
			"Winterspring",
			55.9,
			28.2,
		},
	},
	[28701] = {
		618,
		28701,
		1,
		53,
		"Out of Harm's Way",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			11079,
			"Wynd Nightchaser",
			"Winterspring",
			48.7,
			41,
		},
	},
	[26686] = {
		10,
		26686,
		1,
		26,
		"Bones That Walk",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			264,
			"Commander Althea Ebonlocke",
			"Duskwood",
			73.59999999999999,
			47,
		},
	},
	[28765] = {
		12,
		28765,
		1,
		3,
		"Beating them Back!",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			197,
			"Marshal McBride",
			"Elwynn Forest",
			48.2,
			42.1,
		},
	},
	[24703] = {
		490,
		24703,
		1,
		54,
		"An Important Lesson",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38237,
			"Maximillian of Northshire",
			"Un'Goro Crater",
			30.7,
			51.1,
		},
	},
	[28829] = {
		618,
		28829,
		1,
		54,
		"Razor Beak and Antlers Pointy",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			50263,
			"Jadrag the Slicer",
			"Winterspring",
			61.9,
			74.59999999999999,
		},
	},
	[9349] = {
		3483,
		9349,
		1,
		61,
		"Ravager Egg Roundup",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			19344,
			"Legassi",
			"Hellfire Peninsula",
			49.2,
			74.8,
		},
	},
	[24863] = {
		4709,
		24863,
		1,
		30,
		"Breaking the Siege",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38378,
			"Commander Walpole",
			"Southern Barrens",
			29.8,
			9,
		},
	},
	[9381] = {
		3483,
		9381,
		1,
		63,
		"Trueflight Arrows",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16790,
			"Falconer Drenna Riverwind",
			"Hellfire Peninsula",
			27.7,
			60.4,
		},
	},
	[9397] = {
		3483,
		9397,
		1,
		62,
		"Birds of a Feather",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16790,
			"Falconer Drenna Riverwind",
			"Hellfire Peninsula",
			27.7,
			60.4,
		},
	},
	[13507] = {
		148,
		13507,
		1,
		13,
		"Denying Manpower",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			32965,
			"Sentinel Tysha Moonblade",
			"Darkshore",
			58.9,
			19.4,
		},
	},
	[13523] = {
		148,
		13523,
		1,
		13,
		"Power Over the Tides",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			32932,
			"Moon Priestess Tharill",
			"Darkshore",
			44.6,
			30.8,
		},
	},
	[25087] = {
		4709,
		25087,
		1,
		34,
		"Report to Twinbraid",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			39083,
			"Commander Roberts",
			"Southern Barrens",
			49.1,
			66.90000000000001,
		},
	},
	[13587] = {
		148,
		13587,
		1,
		17,
		"The Waking Nightmare",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			33166,
			"Thessera",
			"Darkshore",
			49.2,
			56.8,
		},
	},
	[25151] = {
		4709,
		25151,
		1,
		34,
		"He Needs Ale!",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			39188,
			"Marley Twinbraid",
			"Southern Barrens",
			49.2,
			86.7,
		},
	},
	[25183] = {
		4709,
		25183,
		1,
		35,
		"...And Bury the Rest",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			39118,
			"General Twinbraid",
			"Southern Barrens",
			43.6,
			78.3,
		},
	},
	[27262] = {
		15,
		27262,
		1,
		37,
		"Suspicious Hoofprints",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23567,
			"Inspector Tarem",
			"Dustwallow Marsh",
			29.7,
			47.8,
		},
	},
	[13651] = {
		331,
		13651,
		1,
		21,
		"Needs a Little Lubrication",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			33421,
			"Gorka",
			"Ashenvale",
			72.90000000000001,
			80.40000000000001,
		},
	},
	[27390] = {
		139,
		27390,
		1,
		41,
		"The Battle of Darrowshire",
		"HA",
		2,
		"DEATHKNIGHTROGUEMAGE",
		2,
		"BLOODELFNIGHTELFGNOME",
		{
			10667,
			"Chromie",
			"Eastern Plaguelands",
			35.2,
			68.09999999999999,
		},
	},
	[27422] = {
		2017,
		27422,
		1,
		45,
		"A City Under Siege",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			[3] = "Eastern Plaguelands",
			[4] = 51.6,
			[5] = 21.4,
		},
	},
	[27454] = {
		139,
		27454,
		1,
		42,
		"Just a Drop in the Bucket",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			[3] = "Eastern Plaguelands",
			[4] = 60.3,
			[5] = 72.5,
		},
	},
	[27614] = {
		139,
		27614,
		1,
		42,
		"Scarlet Salvage",
		"A",
		2,
		"ROGUEPALADIN",
		2,
		"NIGHTELFHUMAN",
		{
			16112,
			"Crusade Commander Korfax",
			"Eastern Plaguelands",
			75.5,
			76.2,
		},
	},
	[25695] = {
		4,
		25695,
		1,
		56,
		"Watching Our Back",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			19254,
			"Warlord Dar'toon",
			"Blasted Lands",
			54.4,
			50.4,
		},
	},
	[13891] = {
		148,
		13891,
		1,
		18,
		"The Devourer of Darkshore",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			34301,
			"Kathrena Winterwisp",
			"Darkshore",
			45.2,
			74.59999999999999,
		},
	},
	[13907] = {
		148,
		13907,
		1,
		18,
		"Sweeping Clean the Ruins",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			34340,
			"Archaeologist Groff",
			"Darkshore",
			37.6,
			82.90000000000001,
		},
	},
	[13923] = {
		331,
		13923,
		1,
		22,
		"To Hellscream's Watch",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			34122,
			"Commander Grimfang",
			"Ashenvale",
			12,
			33.9,
		},
	},
	[25823] = {
		406,
		25823,
		1,
		28,
		"The Unrelenting Horde",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			41229,
			"Force Commander Valen",
			"Stonetalon Mountains",
			71.09999999999999,
			79.7,
		},
	},
	[25855] = {
		11,
		25855,
		1,
		23,
		"Gizmos and Gadgets",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			41435,
			"Fradd Swiftgear",
			"Wetlands",
			26.8,
			25.9,
		},
	},
	[13971] = {
		17,
		13971,
		1,
		12,
		"The Kodo's Return",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			[3] = "Northern Barrens",
			[4] = 58.1,
			[5] = 49.2,
		},
	},
	[28030] = {
		51,
		28030,
		1,
		49,
		"They Build a Better Bullet",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			47393,
			"Mountain-Lord Rendan",
			"Searing Gorge",
			0,
			0,
		},
	},
	[28062] = {
		51,
		28062,
		1,
		50,
		"From Whence He Came",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			14625,
			"Overseer Oilfist",
			"Searing Gorge",
			49.9,
			39.1,
		},
	},
	[9957] = {
		3519,
		9957,
		1,
		63,
		"What's Wrong at Cenarion Thicket?",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			17834,
			"Lethyn Moonfire",
			"Zangarmarsh",
			78.59999999999999,
			63.1,
		},
	},
	[28126] = {
		361,
		28126,
		1,
		46,
		"Dousing the Flames of Protection",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			7114,
			"Jaedenar Enforcer",
			"Felwood",
			36,
			59.7,
		},
	},
	[28190] = {
		361,
		28190,
		1,
		47,
		"The Tainted Ooze",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			47692,
			"Altsoba Ragetotem",
			"Felwood",
			41.3,
			49.9,
		},
	},
	[26175] = {
		4,
		26175,
		1,
		57,
		"Surwich",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			16841,
			"Watch Commander Relthorn Netherwane",
			"Blasted Lands",
			54.7,
			50.4,
		},
	},
	[28254] = {
		46,
		28254,
		1,
		50,
		"A Needle in a Hellhole",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			48109,
			"John J. Keeshan",
			"Burning Steppes",
			46.5,
			45.9,
		},
	},
	[26271] = {
		40,
		26271,
		1,
		13,
		"Feeding the Hungry and the Hopeless",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			42575,
			"Hope Saldean",
			"Westfall",
			56.9,
			47.1,
		},
	},
	[14195] = {
		405,
		14195,
		1,
		31,
		"All Becoming Clearer",
		"H",
		2,
		"PALADIN",
		2,
		"BLOODELF",
		{
			[3] = "Desolace",
			[4] = 77,
			[5] = 18.1,
		},
	},
	[28446] = {
		46,
		28446,
		1,
		51,
		"Blood Tour",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48565,
			"Ariok",
			"Burning Steppes",
			54.7,
			24.5,
		},
	},
	[24448] = {
		16,
		24448,
		1,
		17,
		"Field Promotion",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36920,
			"Lieutenant Drex",
			"Azshara",
			41.4,
			53.7,
		},
	},
	[10213] = {
		3483,
		10213,
		1,
		61,
		"Investigate the Crash",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16858,
			"Grelag",
			"Hellfire Peninsula",
			61,
			81.59999999999999,
		},
	},
	[10229] = {
		3483,
		10229,
		1,
		61,
		"Decipher the Tome",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			[3] = "Hellfire Peninsula",
			[4] = 58.5,
			[5] = 80.40000000000001,
		},
	},
	[26623] = {
		10,
		26623,
		1,
		21,
		"Dusky Crab Cakes",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			272,
			"Chef Grual",
			"Duskwood",
			73.8,
			43.5,
		},
	},
	[26655] = {
		10,
		26655,
		1,
		21,
		"Deliver the Thread",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			265,
			"Madame Eva",
			"Duskwood",
			75.8,
			45.3,
		},
	},
	[14371] = {
		16,
		14371,
		1,
		13,
		"A Gigantic Snack",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36077,
			"Assistant Greely",
			"Azshara",
			50.4,
			74.40000000000001,
		},
	},
	[26719] = {
		10,
		26719,
		1,
		24,
		"Delivery to Master Harris",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			43738,
			"Apprentice Fess",
			"Duskwood",
			44.9,
			67.40000000000001,
		},
	},
	[26751] = {
		33,
		26751,
		1,
		27,
		"Population Con-Troll",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			733,
			"Sergeant Yohwa",
			"Northern Stranglethorn",
			47.5,
			10.7,
		},
	},
	[28830] = {
		618,
		28830,
		1,
		54,
		"Chips off the Old Block",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			50263,
			"Jadrag the Slicer",
			"Winterspring",
			61.9,
			74.59999999999999,
		},
	},
	[14435] = {
		16,
		14435,
		1,
		17,
		"The Blackmaw Doublecross",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			8586,
			"Haggrum Bloodfist",
			"Azshara",
			42.5,
			23.7,
		},
	},
	[24928] = {
		440,
		24928,
		1,
		46,
		"To The Ground!",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38703,
			"Megs Dreadshredder",
			"Tanaris",
			71.8,
			45.4,
		},
	},
	[28542] = {
		361,
		28542,
		1,
		45,
		"Warchief's Command: Felwood!",
		"H",
		2,
		"WARRIOR",
		2,
		"TAUREN",
		{
			3296,
			"Orgrimmar Grunt",
			"Orgrimmar",
			49.7,
			76.90000000000001,
		},
	},
	[8470] = {
		361,
		8470,
		1,
		55,
		"Deadwood Ritual Totem",
		"A",
		2,
		"HUNTER",
		2,
		"DRAENEI",
		{
			[3] = "Winterspring",
			[4] = 66.5,
			[5] = 48,
		},
	},
	[25095] = {
		440,
		25095,
		1,
		49,
		"Thunderdrome: Sarinexx! [Group]",
		"H",
		2,
		"WARRIOR",
		2,
		"TAUREN",
		{
			39034,
			"Dr. Dealwell",
			"Tanaris",
			51.8,
			28,
		},
	},
	[25067] = {
		440,
		25067,
		1,
		49,
		"Thunderdrome: The Ginormus! [Group]",
		"H",
		2,
		"WARRIOR",
		2,
		"TAUREN",
		{
			39034,
			"Dr. Dealwell",
			"Tanaris",
			51.8,
			28,
		},
	},
	[27263] = {
		15,
		27263,
		1,
		37,
		"Lieutenant Paval Reethe",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23567,
			"Inspector Tarem",
			"Dustwallow Marsh",
			29.8,
			48.2,
		},
	},
	[24571] = {
		4709,
		24571,
		1,
		31,
		"Lashvine Seeds",
		"AH",
		2,
		"DRUIDMAGEWARLOCK",
		2,
		"NIGHTELFGNOMESCOURGE",
		{
			38314,
			"Muyoh",
			"Southern Barrens",
			50.3,
			40.5,
		},
	},
	[28252] = {
		46,
		28252,
		1,
		50,
		"The Kodocaller's Horn",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			48085,
			"Quartermaster Kaoshin",
			"Burning Steppes",
			45.2,
			51.7,
		},
	},
	[28318] = {
		46,
		28318,
		1,
		51,
		"A Delivery for Neeralak",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			48307,
			"Colonel Troteman",
			"Burning Steppes",
			73.59999999999999,
			67.09999999999999,
		},
	},
	[10629] = {
		3483,
		10629,
		1,
		61,
		"Shizz Work",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16915,
			"Foreman Razelcraz",
			"Hellfire Peninsula",
			51.4,
			30.5,
		},
	},
	[26447] = {
		331,
		26447,
		1,
		21,
		"Diabolical Plans",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			[3] = "Ashenvale",
			[4] = 80.7,
			[5] = 66.5,
		},
	},
	[27455] = {
		139,
		27455,
		1,
		42,
		"Boys Will Be Boys",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			45417,
			"Fiona",
			"Eastern Plaguelands",
			52.9,
			53.1,
		},
	},
	[27487] = {
		139,
		27487,
		1,
		43,
		"Ix'lar the Underlord",
		"A",
		2,
		"ROGUEPALADIN",
		2,
		"NIGHTELFHUMAN",
		{
			45729,
			"Tarenar Sunstrike",
			"Eastern Plaguelands",
			61.6,
			43.3,
		},
	},
	[26687] = {
		15,
		26687,
		1,
		35,
		"Reinforcements From Theramore",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			39118,
			"General Twinbraid",
			"Southern Barrens",
			43.5,
			78.3,
		},
	},
	[27551] = {
		139,
		27551,
		1,
		45,
		"The Baroness' Missive",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			[3] = "Eastern Plaguelands",
			[4] = 25.1,
			[5] = 20.2,
		},
	},
	[13619] = {
		331,
		13619,
		1,
		21,
		"Final Report",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			33294,
			"Gorat",
			"Ashenvale",
			64.09999999999999,
			84.5,
		},
	},
	[27615] = {
		139,
		27615,
		1,
		42,
		"The Wrathcaster",
		"A",
		2,
		"ROGUEPALADIN",
		2,
		"NIGHTELFHUMAN",
		{
			16112,
			"Crusade Commander Korfax",
			"Eastern Plaguelands",
			75.5,
			76.2,
		},
	},
	[13628] = {
		331,
		13628,
		1,
		21,
		"Got Wood?",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			33284,
			"Truun",
			"Northern Barrens",
			42.3,
			15.2,
		},
	},
	[26319] = {
		40,
		26319,
		1,
		15,
		"Secrets Revealed",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			42425,
			"Captain Alpert",
			"Westfall",
			42.1,
			64.2,
		},
	},
	[26287] = {
		40,
		26287,
		1,
		13,
		"The Westfall Brigade",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			821,
			"Captain Danuvin",
			"Westfall",
			56.4,
			47.6,
		},
	},
	[25696] = {
		4,
		25696,
		1,
		57,
		"The Sunveil Excursion",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			19254,
			"Warlord Dar'toon",
			"Blasted Lands",
			54.4,
			50.6,
		},
	},
	[25728] = {
		406,
		25728,
		1,
		27,
		"Mr. P's Wild Ride",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			40908,
			"Alice",
			"Stonetalon Mountains",
			58.5,
			55.1,
		},
	},
	[12884] = {
		66,
		12884,
		1,
		75,
		"The Ebon Watch",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			29687,
			"Crusader Lord Lantinga",
			"Zul'Drak",
			32.2,
			75.7,
		},
	},
	[28316] = {
		46,
		28316,
		1,
		51,
		"A Deal With a Dragon",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			48346,
			"John J. Keeshan",
			"Burning Steppes",
			73.59999999999999,
			67.09999999999999,
		},
	},
	[13505] = {
		148,
		13505,
		1,
		13,
		"Remnants of the Highborne",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			32966,
			"Balthule Shadowstrike",
			"Darkshore",
			58.9,
			19.4,
		},
	},
	[25856] = {
		11,
		25856,
		1,
		23,
		"Crocolisk Hides",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			41433,
			"James Halloran",
			"Wetlands",
			26.7,
			26.7,
		},
	},
	[13875] = {
		331,
		13875,
		1,
		22,
		"Gurtar's Request",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			34242,
			"Guardian Gurtar",
			"Ashenvale",
			89.5,
			48.7,
		},
	},
	[6922] = {
		331,
		6922,
		1,
		30,
		"Baron Aquanis [Dungeon]",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			[3] = "Blackfathom Deeps",
			[4] = 43.2,
			[5] = 71.90000000000001,
		},
	},
	[14365] = {
		405,
		14365,
		1,
		31,
		"Ethel Rethor",
		"A",
		2,
		"WARLOCK",
		2,
		"GNOME",
		{
			5752,
			"Corporal Melkins",
			"Desolace",
			66.8,
			10.8,
		},
	},
	[28031] = {
		400,
		28031,
		1,
		41,
		"[41] [41] Special Delivery for Brivelthwerp",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			40726,
			"Mazzer Stripscrew",
			"Thousand Needles",
			78.09999999999999,
			73.2,
		},
	},
	[26016] = {
		406,
		26016,
		1,
		27,
		"Orders from Base Camp",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			[3] = "Stonetalon Mountains",
			[4] = 62,
			[5] = 67.8,
		},
	},
	[26048] = {
		406,
		26048,
		1,
		27,
		"Spare Parts Up In Here!",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			41991,
			"Sergeant Dontrag",
			"Stonetalon Mountains",
			67.2,
			64.5,
		},
	},
	[13871] = {
		331,
		13871,
		1,
		22,
		"Security!",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			17304,
			"Overseer Gorthak",
			"Ashenvale",
			90.90000000000001,
			58.1,
		},
	},
	[26073] = {
		406,
		26073,
		1,
		30,
		"All's Quiet on the Southern Front",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			3995,
			"Witch Doctor Jin'Zil",
			"Stonetalon Mountains",
			71.09999999999999,
			91.3,
		},
	},
	[13615] = {
		331,
		13615,
		1,
		21,
		"Empty Quivers",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			33284,
			"Truun",
			"Northern Barrens",
			42.3,
			15.3,
		},
	},
	[24] = {
		331,
		24,
		1,
		24,
		"Shadumbra's Head",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			[3] = "Ashenvale",
			[4] = 61.2,
			[5] = 51.6,
		},
	},
	[24637] = {
		4709,
		24637,
		1,
		34,
		"The Butcher of Taurajo",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			37837,
			"Warlord Bloodhilt",
			"Southern Barrens",
			41.7,
			69.8,
		},
	},
	[27982] = {
		51,
		27982,
		1,
		48,
		"Twilight Collars",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			14626,
			"Taskmaster Scrange",
			"Searing Gorge",
			0,
			0,
		},
	},
	[28319] = {
		46,
		28319,
		1,
		51,
		"A Delivery for Xi'lun",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			48307,
			"Colonel Troteman",
			"Burning Steppes",
			73.59999999999999,
			67.09999999999999,
		},
	},
	[14334] = {
		405,
		14334,
		1,
		35,
		"Blubbergut",
		"H",
		2,
		"MAGE",
		2,
		"TROLL",
		{
			12031,
			"Mai'Lahii",
			"Desolace",
			22.7,
			72.09999999999999,
		},
	},
	[13613] = {
		331,
		13613,
		1,
		21,
		"Rescue the Fallen",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			33263,
			"Dinah Halfmoon",
			"Northern Barrens",
			42.4,
			15.7,
		},
	},
	[85] = {
		12,
		85,
		1,
		6,
		"Lost Necklace",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			246,
			"\"Auntie\" Bernice Stonefield",
			"Elwynn Forest",
			34.6,
			84.3,
		},
	},
	[28447] = {
		46,
		28447,
		1,
		51,
		"Draconic Vanguard",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48565,
			"Ariok",
			"Burning Steppes",
			0,
			0,
		},
	},
	[28479] = {
		618,
		28479,
		1,
		51,
		"The Ruins of Kel'Theril",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			10920,
			"Kelek Skykeeper",
			"Winterspring",
			46.8,
			53.8,
		},
	},
	[13841] = {
		331,
		13841,
		1,
		22,
		"All Apologies",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			33726,
			"Splintertree Demolisher",
			"Ashenvale",
			73.40000000000001,
			62.1,
		},
	},
	[24449] = {
		16,
		24449,
		1,
		17,
		"Shore Leave",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36745,
			"Captain Tork",
			"Azshara",
			34.4,
			45,
		},
	},
	[24569] = {
		4709,
		24569,
		1,
		32,
		"Siegebreaker",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			37679,
			"Warlord Bloodhilt",
			"Southern Barrens",
			41.5,
			46.8,
		},
	},
	[26560] = {
		44,
		26560,
		1,
		17,
		"Jorgensen",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			43300,
			"Messner",
			"Redridge Mountains",
			47.7,
			41.6,
		},
	},
	[26592] = {
		5287,
		26592,
		1,
		30,
		"Diffractory Chromascope",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			43096,
			"Flem Gizzix",
			"The Cape of Stranglethorn",
			33.7,
			29.2,
		},
	},
	[26624] = {
		5287,
		26624,
		1,
		33,
		"Getting In With the Bloodsail",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2496,
			"Baron Revilgaz",
			"The Cape of Stranglethorn",
			41.1,
			73.09999999999999,
		},
	},
	[28703] = {
		618,
		28703,
		1,
		53,
		"Step Into My Barrow",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			49407,
			"Rinno Curtainfire",
			"Winterspring",
			45.8,
			41,
		},
	},
	[26688] = {
		10,
		26688,
		1,
		23,
		"Worgen in the Woods",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			663,
			"Calor",
			"Duskwood",
			75.2,
			48,
		},
	},
	[26720] = {
		10,
		26720,
		1,
		24,
		"A Curse We Cannot Lift",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			43730,
			"Oliver Harris",
			"Duskwood",
			18.4,
			57.8,
		},
	},
	[24705] = {
		490,
		24705,
		1,
		54,
		"Damsels Were Made to be Saved",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38255,
			"Maximillian of Northshire",
			"Un'Goro Crater",
			30.7,
			51.2,
		},
	},
	[28831] = {
		618,
		28831,
		1,
		54,
		"Damn You, Frostilicus",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			50263,
			"Jadrag the Slicer",
			"Winterspring",
			61.9,
			74.59999999999999,
		},
	},
	[13870] = {
		331,
		13870,
		1,
		22,
		"As Good as it Gets",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			33889,
			"Krokk",
			"Ashenvale",
			82.5,
			53.7,
		},
	},
	[25711] = {
		4,
		25711,
		1,
		55,
		"Eliminate the Okril'lon",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			5393,
			"Quartermaster Lungertz",
			"Blasted Lands",
			60.1,
			13.6,
		},
	},
	[9773] = {
		3521,
		9773,
		1,
		61,
		"No More Mushrooms!",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			18016,
			"Magasha",
			"Zangarmarsh",
			84.5,
			54.3,
		},
	},
	[9366] = {
		3483,
		9366,
		1,
		62,
		"In Need of Felblood",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16791,
			"Ryathen the Somber",
			"Hellfire Peninsula",
			27,
			59.6,
		},
	},
	[26944] = {
		721,
		26944,
		1,
		26,
		"Exploring Gnomeregan",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			44018,
			"Wulfred Harrys",
			"Northern Stranglethorn",
			53.3,
			66.3,
		},
	},
	[14302] = {
		405,
		14302,
		1,
		32,
		"Official Assessment",
		"HA",
		2,
		"PALADINWARLOCK",
		2,
		"BLOODELFGNOME",
		{
			35773,
			"Cenarion Researcher Korrah",
			"Desolace",
			38.9,
			27.1,
		},
	},
	[13508] = {
		148,
		13508,
		1,
		13,
		"Swift Response",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			32963,
			"Lieutenant Morra Starbreeze",
			"Darkshore",
			58.9,
			19.4,
		},
	},
	[13873] = {
		331,
		13873,
		1,
		22,
		"Sheelah's Last Wish",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			34233,
			"Guardian Menerin",
			"Ashenvale",
			90.8,
			58.2,
		},
	},
	[106] = {
		12,
		106,
		1,
		6,
		"Young Lovers",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			251,
			"Maybell Maclure",
			"Elwynn Forest",
			43.1,
			89.59999999999999,
		},
	},
	[25057] = {
		4709,
		25057,
		1,
		32,
		"Clap 'Em In Irons",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38323,
			"General Hawthorne",
			"Southern Barrens",
			49.9,
			49.6,
		},
	},
	[13572] = {
		148,
		13572,
		1,
		19,
		"Jadefire Braziers",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			32968,
			"Gren Tornfur",
			"Darkshore",
			43.5,
			81,
		},
	},
	[13588] = {
		148,
		13588,
		1,
		17,
		"The Eye of All Storms",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			33091,
			"Malfurion Stormrage",
			"Darkshore",
			43.7,
			53.5,
		},
	},
	[25153] = {
		4709,
		25153,
		1,
		34,
		"Bael'dun Rescue",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			39218,
			"Bael'dun Survivor",
			"Southern Barrens",
			49.4,
			86.90000000000001,
		},
	},
	[13620] = {
		331,
		13620,
		1,
		21,
		"To Dinah, at Once!",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			8582,
			"Kadrak",
			"Northern Barrens",
			42.7,
			15,
		},
	},
	[28222] = {
		361,
		28222,
		1,
		48,
		"Singin' in the Sun",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			[3] = "Felwood",
			[4] = 49.3,
			[5] = 29.2,
		},
	},
	[13598] = {
		148,
		13598,
		1,
		12,
		"Unsavory Remedies",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			33048,
			"Keeper Karithus",
			"Darkshore",
			43,
			39.1,
		},
	},
	[107] = {
		12,
		107,
		1,
		6,
		"Note to William",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			248,
			"Gramma Stonefield",
			"Elwynn Forest",
			34.9,
			84,
		},
	},
	[25185] = {
		4709,
		25185,
		1,
		35,
		"The Deed Is Done",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			39279,
			"Frazzlecraz Foreman",
			"Southern Barrens",
			40.5,
			77.8,
		},
	},
	[27392] = {
		139,
		27392,
		1,
		41,
		"I'm Not Supposed to Tell You This",
		"A",
		2,
		"ROGUEMAGE",
		2,
		"NIGHTELFGNOME",
		{
			10926,
			"Pamela Redpath",
			"Eastern Plaguelands",
			32.4,
			83.7,
		},
	},
	[13983] = {
		331,
		13983,
		1,
		25,
		"Building Your Own Coffin",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			34596,
			"Foreman Jinx",
			"Ashenvale",
			46.1,
			63.2,
		},
	},
	[27456] = {
		139,
		27456,
		1,
		42,
		"Gathering Some Grub(s)",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			16134,
			"Rimblat Earthshatter",
			"Eastern Plaguelands",
			73.90000000000001,
			51.9,
		},
	},
	[27488] = {
		139,
		27488,
		1,
		43,
		"Impatience",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			45729,
			"Tarenar Sunstrike",
			"Eastern Plaguelands",
			61.5,
			43.6,
		},
	},
	[14191] = {
		405,
		14191,
		1,
		30,
		"Furien's Footsteps",
		"H",
		2,
		"PALADIN",
		2,
		"BLOODELF",
		{
			[3] = "Desolace",
			[4] = 69.2,
			[5] = 29.2,
		},
	},
	[26649] = {
		5287,
		26649,
		1,
		34,
		"Drive-By Piracy",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2547,
			"Ironpatch",
			"The Cape of Stranglethorn",
			46.7,
			94.90000000000001,
		},
	},
	[14411] = {
		405,
		14411,
		1,
		35,
		"Feralas Breadcrumb [PH]",
		"H",
		2,
		"MAGE",
		2,
		"TROLL",
		{
			11624,
			"Taiga Wisemane",
			"Desolace",
			25.8,
			68.09999999999999,
		},
	},
	[9718] = {
		3521,
		9718,
		1,
		63,
		"As the Crow Flies",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			17841,
			"Ysiel Windsinger",
			"Zangarmarsh",
			78.40000000000001,
			62.1,
		},
	},
	[27162] = {
		28,
		27162,
		1,
		35,
		"Scholomancer",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			44453,
			"Thassarian",
			"Western Plaguelands",
			41.1,
			70.40000000000001,
		},
	},
	[13844] = {
		148,
		13844,
		1,
		14,
		"The Looting of Althalaxx",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			34041,
			"Mathas Wildwood",
			"Darkshore",
			59.1,
			19.5,
		},
	},
	[28220] = {
		361,
		28220,
		1,
		48,
		"Seeking Soil",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			[3] = "Felwood",
			[4] = 48.7,
			[5] = 25.2,
		},
	},
	[25697] = {
		4,
		25697,
		1,
		56,
		"The Amulet of Allistarj",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			7783,
			"Loramus Thalipedes",
			"Blasted Lands",
			39.3,
			35.8,
		},
	},
	[25729] = {
		406,
		25729,
		1,
		27,
		"Gerenzo the Traitor",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			[3] = "Stonetalon Mountains",
			[4] = 64.7,
			[5] = 43.8,
		},
	},
	[25115] = {
		440,
		25115,
		1,
		45,
		"Blisterpaw Butchery",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			39178,
			"Driz Plunkbow",
			"Tanaris",
			52.2,
			28.1,
		},
	},
	[25793] = {
		406,
		25793,
		1,
		28,
		"The Deep Reaches",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			41229,
			"Force Commander Valen",
			"Stonetalon Mountains",
			71.09999999999999,
			79.7,
		},
	},
	[25825] = {
		400,
		25825,
		1,
		42,
		"[42] [42] Deliver the Goods",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			41190,
			"Crazzle Sprysprocket",
			"Thousand Needles",
			91.3,
			57.7,
		},
	},
	[25857] = {
		11,
		25857,
		1,
		23,
		"Hunting Horrorjaw",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			41433,
			"James Halloran",
			"Wetlands",
			26.8,
			26.8,
		},
	},
	[25889] = {
		406,
		25889,
		1,
		29,
		"[29] [29] Save the Children!",
		"A",
		2,
		"PALADINDRUIDMAGE",
		2,
		"DRAENEINIGHTELFGNOME",
		{
			41482,
			"Master Thal'darah",
			"Stonetalon Mountains",
			39.9,
			33.5,
		},
	},
	[9894] = {
		3521,
		9894,
		1,
		62,
		"Safeguarding the Watchers [Group]",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			18070,
			"Windcaller Blackhoof",
			"Zangarmarsh",
			80.40000000000001,
			64.59999999999999,
		},
	},
	[28000] = {
		361,
		28000,
		1,
		45,
		"Do the Imp-Possible",
		"H",
		2,
		"DRUIDWARRIOR",
		2,
		"TROLLTAUREN",
		{
			47341,
			"Arcanist Delaris",
			"Felwood",
			41.9,
			72,
		},
	},
	[28032] = {
		51,
		28032,
		1,
		49,
		"The Mysteries of the Fire-Gizzard",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			47440,
			"Agnes Flimshale",
			"Searing Gorge",
			0,
			0,
		},
	},
	[28064] = {
		51,
		28064,
		1,
		50,
		"Welcome to the Brotherhood",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			47462,
			"Archduke Calcinder",
			"Searing Gorge",
			43,
			29.4,
		},
	},
	[14052] = {
		17,
		14052,
		1,
		16,
		"Take it up with Tony",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			3453,
			"Wharfmaster Dizzywig",
			"Northern Barrens",
			0,
			0,
		},
	},
	[14068] = {
		17,
		14068,
		1,
		16,
		"Waptor Twapping",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			34828,
			"Kala'ma",
			"Northern Barrens",
			62.3,
			63.8,
		},
	},
	[5561] = {
		405,
		5561,
		1,
		34,
		"Kodo Roundup",
		"H",
		2,
		"PALADINMAGE",
		2,
		"BLOODELFTROLL",
		{
			11596,
			"Smeed Scrabblescrew",
			"Desolace",
			60.8,
			61.8,
		},
	},
	[24855] = {
		490,
		24855,
		1,
		52,
		"Aberrant Flora",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38263,
			"Ithis Moonwarden",
			"Un'Goro Crater",
			76.5,
			48.5,
		},
	},
	[28224] = {
		361,
		28224,
		1,
		48,
		"The Last Protector",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			[3] = "Felwood",
			[4] = 51.4,
			[5] = 23.5,
		},
	},
	[26209] = {
		40,
		26209,
		1,
		11,
		"Murder Was The Case That They Gave Me",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			42308,
			"Lieutenant Horatio Laine",
			"Westfall",
			60.1,
			19.3,
		},
	},
	[26241] = {
		40,
		26241,
		1,
		12,
		"Westfall Stew",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			235,
			"Salma Saldean",
			"Westfall",
			56.4,
			30.6,
		},
	},
	[28320] = {
		46,
		28320,
		1,
		52,
		"Assault on Dreadmaul Rock",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			48306,
			"John J. Keeshan",
			"Burning Steppes",
			73.2,
			66.40000000000001,
		},
	},
	[111] = {
		12,
		111,
		1,
		6,
		"Speak with Gramma",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			252,
			"Tommy Joe Stonefield",
			"Elwynn Forest",
			29.9,
			86,
		},
	},
	[14196] = {
		405,
		14196,
		1,
		31,
		"Firestarter",
		"H",
		2,
		"PALADIN",
		2,
		"BLOODELF",
		{
			[3] = "Desolace",
			[4] = 74.8,
			[5] = 13.3,
		},
	},
	[14339] = {
		405,
		14339,
		1,
		33,
		"Delivery Device",
		"H",
		2,
		"PALADINMAGE",
		2,
		"BLOODELFTROLL",
		{
			4498,
			"Maurin Bonesplitter",
			"Desolace",
			52.3,
			53.6,
		},
	},
	[28448] = {
		46,
		28448,
		1,
		51,
		"A Deal With a Dragon",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48567,
			"Ariok",
			"Burning Steppes",
			0,
			0,
		},
	},
	[26433] = {
		5287,
		26433,
		1,
		30,
		"The Holy Water of Clarity",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			43096,
			"Flem Gizzix",
			"The Cape of Stranglethorn",
			33.7,
			29.2,
		},
	},
	[14260] = {
		405,
		14260,
		1,
		32,
		"Going Deep",
		"HA",
		2,
		"PALADINWARLOCK",
		2,
		"BLOODELFGNOME",
		{
			35773,
			"Cenarion Researcher Korrah",
			"Desolace",
			38.9,
			27.1,
		},
	},
	[10230] = {
		3483,
		10230,
		1,
		61,
		"The Battle Horn",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			19736,
			"Althen the Historian",
			"Hellfire Peninsula",
			61.7,
			81.7,
		},
	},
	[14292] = {
		405,
		14292,
		1,
		32,
		"The Enemy of Our Enemy",
		"HA",
		2,
		"PALADINWARLOCK",
		2,
		"BLOODELFGNOME",
		{
			35773,
			"Cenarion Researcher Korrah",
			"Desolace",
			38.9,
			27.1,
		},
	},
	[26561] = {
		44,
		26561,
		1,
		17,
		"Krakauer",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			43305,
			"Jorgensen",
			"Redridge Mountains",
			33.5,
			11.7,
		},
	},
	[26593] = {
		5287,
		26593,
		1,
		32,
		"Scaring Shaky",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2501,
			"\"Sea Wolf\" MacKinley",
			"The Cape of Stranglethorn",
			42,
			73.5,
		},
	},
	[14340] = {
		16,
		14340,
		1,
		18,
		"Dressed to Impress",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36210,
			"Sorata Firespinner",
			"Azshara",
			42.7,
			25.2,
		},
	},
	[14227] = {
		405,
		14227,
		1,
		31,
		"Putting Their Heads Together",
		"H",
		2,
		"PALADIN",
		2,
		"BLOODELF",
		{
			[3] = "Desolace",
			[4] = 52.5,
			[5] = 29,
		},
	},
	[26689] = {
		10,
		26689,
		1,
		23,
		"The Rotting Orchard",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			663,
			"Calor",
			"Duskwood",
			75.2,
			47.8,
		},
	},
	[26721] = {
		10,
		26721,
		1,
		24,
		"The Jitters-Bugs",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			288,
			"Jitters",
			"Duskwood",
			18.7,
			58.3,
		},
	},
	[26753] = {
		10,
		26753,
		1,
		25,
		"The Halls of the Dead",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Duskwood",
			[4] = 23.6,
			[5] = 35.4,
		},
	},
	[13579] = {
		148,
		13579,
		1,
		15,
		"Protector of Ameth'Aran",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			33091,
			"Malfurion Stormrage",
			"Darkshore",
			43.7,
			53.4,
		},
	},
	[13920] = {
		331,
		13920,
		1,
		22,
		"Before You Go...",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			34122,
			"Commander Grimfang",
			"Ashenvale",
			12,
			33.8,
		},
	},
	[6544] = {
		331,
		6544,
		1,
		24,
		"Torek's Assault",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			12858,
			"Torek",
			"Ashenvale",
			68.3,
			75.2,
		},
	},
	[14468] = {
		16,
		14468,
		1,
		13,
		"Another Warm Body",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36752,
			"Private Worcester",
			"Azshara",
			29.5,
			66.8,
		},
	},
	[14484] = {
		16,
		14484,
		1,
		17,
		"Head of the Snake",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36895,
			"Sergeant Zelks",
			"Azshara",
			34.4,
			44.8,
		},
	},
	[12671] = {
		3711,
		12671,
		1,
		77,
		"Reconnaissance Flight",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			28746,
			"Pilot Vic",
			"Sholazar Basin",
			50,
			61.6,
		},
	},
	[26101] = {
		406,
		26101,
		1,
		30,
		"Might Makes Right",
		"H",
		2,
		"WARLOCKPALADIN",
		2,
		"SCOURGEBLOODELF",
		{
			41023,
			"Overlord Krom'gar",
			"Stonetalon Mountains",
			66.2,
			63.7,
		},
	},
	[24943] = {
		4709,
		24943,
		1,
		30,
		"Re-Take the Courtyard",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38620,
			"Thomas Paxton",
			"Southern Barrens",
			67,
			46.6,
		},
	},
	[14304] = {
		405,
		14304,
		1,
		33,
		"Blood Theory",
		"HA",
		2,
		"PALADINWARLOCK",
		2,
		"BLOODELFGNOME",
		{
			36048,
			"Thressa Amberglen",
			"Desolace",
			58.8,
			46.5,
		},
	},
	[114] = {
		12,
		114,
		1,
		7,
		"The Escape",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			253,
			"William Pestle",
			"Elwynn Forest",
			43.3,
			65.8,
		},
	},
	[13884] = {
		331,
		13884,
		1,
		23,
		"Put Out The Fire",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			34292,
			"Arctanus",
			"Ashenvale",
			52.1,
			56.6,
		},
	},
	[14268] = {
		405,
		14268,
		1,
		32,
		"Deep Impact",
		"HA",
		2,
		"PALADINWARLOCK",
		2,
		"BLOODELFGNOME",
		{
			35827,
			"Valishj",
			"Desolace",
			31.1,
			30.8,
		},
	},
	[27169] = {
		28,
		27169,
		1,
		36,
		"Uther's Blessing",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			10838,
			"Commander Ashlam Valorfist",
			"Western Plaguelands",
			42.7,
			83.90000000000001,
		},
	},
	[14188] = {
		405,
		14188,
		1,
		30,
		"Avenge Furien!",
		"H",
		2,
		"PALADIN",
		2,
		"BLOODELF",
		{
			35295,
			"Cerelia",
			"Desolace",
			44.6,
			29.6,
		},
	},
	[25186] = {
		4709,
		25186,
		1,
		31,
		"Futile Resistance",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38380,
			"Janice Mattingly",
			"Southern Barrens",
			35,
			9.6,
		},
	},
	[13612] = {
		331,
		13612,
		1,
		21,
		"Mor'shan Defense",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			8582,
			"Kadrak",
			"Northern Barrens",
			42.3,
			15.3,
		},
	},
	[12629] = {
		66,
		12629,
		1,
		75,
		"You Can Run, But You Can't Hide",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			28518,
			"Stefan Vadu",
			"Zul'Drak",
			14.1,
			73.8,
		},
	},
	[10238] = {
		3483,
		10238,
		1,
		61,
		"How to Serve Goblins",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16915,
			"Foreman Razelcraz",
			"Hellfire Peninsula",
			51.4,
			30.6,
		},
	},
	[14225] = {
		405,
		14225,
		1,
		31,
		"You'll Know It When You See It",
		"H",
		2,
		"PALADIN",
		2,
		"BLOODELF",
		{
			[3] = "Desolace",
			[4] = 53.2,
			[5] = 33.2,
		},
	},
	[10630] = {
		3483,
		10630,
		1,
		61,
		"Beneath Thrallmar",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16915,
			"Foreman Razelcraz",
			"Hellfire Peninsula",
			51.3,
			30.5,
		},
	},
	[26734] = {
		33,
		26734,
		1,
		25,
		"The Source of the Madness",
		"A",
		2,
		"DRUIDWARLOCK",
		2,
		"NIGHTELFHUMAN",
		{
			739,
			"Brother Nimetz",
			"Northern Stranglethorn",
			47.3,
			11.1,
		},
	},
	[27457] = {
		139,
		27457,
		1,
		42,
		"An Opportune Alliance",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			16134,
			"Rimblat Earthshatter",
			"Eastern Plaguelands",
			73.90000000000001,
			52,
		},
	},
	[27489] = {
		139,
		27489,
		1,
		43,
		"Nobody to Blame but Myself",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			45729,
			"Tarenar Sunstrike",
			"Eastern Plaguelands",
			61.4,
			42.9,
		},
	},
	[27521] = {
		139,
		27521,
		1,
		44,
		"Wretched Hive of Scum and Villainy",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			45826,
			"Kirkian Dawnshield",
			"Eastern Plaguelands",
			50.1,
			19.5,
		},
	},
	[27164] = {
		28,
		27164,
		1,
		35,
		"Araj the Summoner",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			44467,
			"Lang Loosegrip",
			"Western Plaguelands",
			41.2,
			70,
		},
	},
	[26681] = {
		10,
		26681,
		1,
		22,
		"Note to the Mayor",
		"A",
		2,
		"WARLOCKSHAMAN",
		2,
		"HUMANDWARF",
		{
			289,
			"Abercrombie",
			"Duskwood",
			87.40000000000001,
			35.4,
		},
	},
	[27617] = {
		139,
		27617,
		1,
		42,
		"Befouled No More",
		"A",
		2,
		"ROGUEPALADIN",
		2,
		"NIGHTELFHUMAN",
		{
			16115,
			"Crusade Commander Eligor Dawnbringer",
			"Eastern Plaguelands",
			76.7,
			73.09999999999999,
		},
	},
	[24591] = {
		4709,
		24591,
		1,
		33,
		"Changing of the Gar'dul",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			37811,
			"Warlord Gar'dul",
			"Southern Barrens",
			41.7,
			69.8,
		},
	},
	[26654] = {
		10,
		26654,
		1,
		21,
		"Return the Comb",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			302,
			"Blind Mary",
			"Duskwood",
			81.90000000000001,
			59.1,
		},
	},
	[5421] = {
		405,
		5421,
		1,
		34,
		"Fish in a Bucket",
		"H",
		2,
		"MAGE",
		2,
		"TROLL",
		{
			11317,
			"Jinar'Zillen",
			"Desolace",
			22.4,
			73,
		},
	},
	[25698] = {
		4,
		25698,
		1,
		56,
		"The Amulet of Sevine",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			7783,
			"Loramus Thalipedes",
			"Blasted Lands",
			39.3,
			35.8,
		},
	},
	[25730] = {
		406,
		25730,
		1,
		27,
		"BEWARE OF CRAGJAW! [Group]",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			[3] = "Stonetalon Mountains",
			[4] = 65,
			[5] = 49.4,
		},
	},
	[10838] = {
		3483,
		10838,
		1,
		61,
		"The Demoniac Scryer [Group]",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16588,
			"Apothecary Antonivich",
			"Hellfire Peninsula",
			52.3,
			36.5,
		},
	},
	[12901] = {
		66,
		12901,
		1,
		76,
		"Making Something Out Of Nothing",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			29688,
			"Engineer Reed",
			"Zul'Drak",
			25.3,
			63.9,
		},
	},
	[13967] = {
		331,
		13967,
		1,
		25,
		"Thinning the... Herd?",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			12696,
			"Senani Thunderheart",
			"Ashenvale",
			49.8,
			65.2,
		},
	},
	[11212] = {
		15,
		11212,
		1,
		37,
		"Tabetha's Farm",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			4921,
			"Guard Byron",
			"Dustwallow Marsh",
			66.09999999999999,
			46.1,
		},
	},
	[24927] = {
		440,
		24927,
		1,
		46,
		"Dead Man's Chest",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38703,
			"Megs Dreadshredder",
			"Tanaris",
			71.8,
			45.4,
		},
	},
	[28380] = {
		361,
		28380,
		1,
		49,
		"Pikwik in Peril",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			48127,
			"Darla Drilldozer",
			"Felwood",
			56.3,
			8.300000000000001,
		},
	},
	[27827] = {
		3,
		27827,
		1,
		47,
		"The Swift, the Fierce, and the Stout",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			46654,
			"Rhea",
			"Badlands",
			21.2,
			57.7,
		},
	},
	[28033] = {
		51,
		28033,
		1,
		49,
		"Deceit",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			47393,
			"Mountain-Lord Rendan",
			"Searing Gorge",
			39.4,
			67.8,
		},
	},
	[27166] = {
		28,
		27166,
		1,
		36,
		"Go Fletch!",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			10838,
			"Commander Ashlam Valorfist",
			"Western Plaguelands",
			42.8,
			84.09999999999999,
		},
	},
	[26082] = {
		406,
		26082,
		1,
		30,
		"To Battlescar!",
		"H",
		2,
		"WARLOCKPALADIN",
		2,
		"SCOURGEBLOODELF",
		{
			42050,
			"General Grebo",
			"Stonetalon Mountains",
			45.2,
			32.7,
		},
	},
	[28129] = {
		361,
		28129,
		1,
		46,
		"The Demon Prince",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			47617,
			"Farlus Wildheart",
			"Felwood",
			44.1,
			61.9,
		},
	},
	[27612] = {
		139,
		27612,
		1,
		42,
		"Victory From Within",
		"A",
		2,
		"ROGUEPALADIN",
		2,
		"NIGHTELFHUMAN",
		{
			16115,
			"Crusade Commander Eligor Dawnbringer",
			"Eastern Plaguelands",
			76.7,
			73.2,
		},
	},
	[26286] = {
		40,
		26286,
		1,
		13,
		"In Defense of Westfall",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			234,
			"Marshal Gryan Stoutmantle",
			"Westfall",
			56.3,
			47.5,
		},
	},
	[28225] = {
		46,
		28225,
		1,
		50,
		"Prove Yer Allegiance",
		"HA",
		2,
		"DEATHKNIGHTMAGE",
		2,
		"BLOODELFDRAENEI",
		{
			48033,
			"Stebben Oreknuckle",
			"Burning Steppes",
			46.8,
			44.2,
		},
	},
	[28257] = {
		361,
		28257,
		1,
		48,
		"The Fall of Tichondrius",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			47923,
			"Feronas Sindweller",
			"Felwood",
			45.5,
			20.1,
		},
	},
	[28152] = {
		361,
		28152,
		1,
		46,
		"Jaedenar Awaits",
		"H",
		2,
		"DRUIDWARRIOR",
		2,
		"TROLLTAUREN",
		{
			9116,
			"Eridan Bluewind",
			"Felwood",
			42,
			71.8,
		},
	},
	[24865] = {
		490,
		24865,
		1,
		51,
		"Is This Stuff Still Good?",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			[3] = "Un'Goro Crater",
			[4] = 68.59999999999999,
			[5] = 36.5,
		},
	},
	[26077] = {
		406,
		26077,
		1,
		30,
		"Final Delivery",
		"H",
		2,
		"WARLOCKPALADIN",
		2,
		"SCOURGEBLOODELF",
		{
			42033,
			"Jibbly Rakit",
			"Stonetalon Mountains",
			52.9,
			39.2,
		},
	},
	[28449] = {
		46,
		28449,
		1,
		51,
		"Placing the Pawns",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48292,
			"Acride",
			"Burning Steppes",
			82.2,
			31.6,
		},
	},
	[26370] = {
		40,
		26370,
		1,
		15,
		"Return to Sentinel Hill",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			29611,
			"King Varian Wrynn",
			"Stormwind City",
			85.7,
			31.8,
		},
	},
	[5581] = {
		405,
		5581,
		1,
		35,
		"Portals of the Legion",
		"H",
		2,
		"PALADIN",
		2,
		"BLOODELF",
		{
			5395,
			"Felgur Twocuts",
			"Desolace",
			56.2,
			59.5,
		},
	},
	[26434] = {
		5287,
		26434,
		1,
		30,
		"Primal Reagents of Power",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			43096,
			"Flem Gizzix",
			"The Cape of Stranglethorn",
			33.7,
			29.2,
		},
	},
	[28513] = {
		618,
		28513,
		1,
		51,
		"Pride of the Highborne",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			48658,
			"Kaldorei Spirit",
			"Winterspring",
			50.7,
			54.8,
		},
	},
	[9159] = {
		3433,
		9159,
		1,
		15,
		"Curbing the Plague",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			16202,
			"Farstrider Sedina",
			"Ghostlands",
			72.59999999999999,
			32.1,
		},
	},
	[26047] = {
		406,
		26047,
		1,
		27,
		"And That's Why They Call Them Peons...",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			41992,
			"Blastgineer Igore",
			"Stonetalon Mountains",
			67.09999999999999,
			64.40000000000001,
		},
	},
	[28609] = {
		618,
		28609,
		1,
		52,
		"Hammer Time",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			11191,
			"Lilith the Lithe",
			"Winterspring",
			59.8,
			49.3,
		},
	},
	[26594] = {
		5287,
		26594,
		1,
		32,
		"Return to MacKinley",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2502,
			"\"Shaky\" Phillipe",
			"The Cape of Stranglethorn",
			40.4,
			67.8,
		},
	},
	[26390] = {
		12,
		26390,
		1,
		5,
		"Ending the Invasion!",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			197,
			"Marshal McBride",
			"Elwynn Forest",
			48.2,
			42.1,
		},
	},
	[13504] = {
		148,
		13504,
		1,
		13,
		"Shatterspear Laborers",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			32965,
			"Sentinel Tysha Moonblade",
			"Darkshore",
			58.9,
			19.4,
		},
	},
	[26690] = {
		10,
		26690,
		1,
		23,
		"Vile and Tainted",
		"A",
		2,
		"WARLOCKSHAMANPALADIN",
		2,
		"HUMANDWARF",
		{
			663,
			"Calor",
			"Duskwood",
			75.2,
			47.9,
		},
	},
	[26722] = {
		10,
		26722,
		1,
		25,
		"Buried Below",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Duskwood",
			[4] = 20.4,
			[5] = 27.6,
		},
	},
	[26754] = {
		10,
		26754,
		1,
		25,
		"Morbent's Bane",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Duskwood",
			[4] = 18.1,
			[5] = 25.3,
		},
	},
	[24963] = {
		440,
		24963,
		1,
		48,
		"Maul 'Em With Kindness",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38849,
			"Megs Dreadshredder",
			"Tanaris",
			44.6,
			52.6,
		},
	},
	[27832] = {
		3,
		27832,
		1,
		47,
		"The Hidden Clutch",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			[3] = "Badlands",
			[4] = 9.5,
			[5] = 39.7,
		},
	},
	[13621] = {
		331,
		13621,
		1,
		21,
		"Gorat's Vengeance",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			33263,
			"Dinah Halfmoon",
			"Northern Barrens",
			42.5,
			15.7,
		},
	},
	[9351] = {
		3483,
		9351,
		1,
		61,
		"Voidwalkers Gone Wild",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			19367,
			"\"Screaming\" Screed Luckheed",
			"Hellfire Peninsula",
			49.1,
			74.8,
		},
	},
	[26914] = {
		-61,
		26914,
		1,
		3,
		"Immolation",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			459,
			"Drusilla La Salle",
			"Elwynn Forest",
			49.8,
			42.7,
		},
	},
	[25934] = {
		406,
		25934,
		1,
		30,
		"[30] [30] World First: Gnomegen",
		"A",
		2,
		"PALADINDRUIDMAGE",
		2,
		"DRAENEINIGHTELFGNOME",
		{
			41664,
			"Salsbury the \"Help\"",
			"Stonetalon Mountains",
			33.1,
			59.6,
		},
	},
	[24931] = {
		440,
		24931,
		1,
		47,
		"Gazer Tag",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			11811,
			"Narain Soothfancy",
			"Tanaris",
			55.3,
			60.3,
		},
	},
	[13509] = {
		148,
		13509,
		1,
		13,
		"War Supplies",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			32963,
			"Lieutenant Morra Starbreeze",
			"Darkshore",
			58.9,
			19.5,
		},
	},
	[13525] = {
		148,
		13525,
		1,
		19,
		"What's Happening to the Blackwood Furbolg?",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			33250,
			"Foriel Broadleaf",
			"Darkshore",
			45.2,
			75.09999999999999,
		},
	},
	[25027] = {
		4709,
		25027,
		1,
		31,
		"You Flicked a Fine Vine to Leaf Me",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38871,
			"Corporal Teegan",
			"Southern Barrens",
			56.1,
			42.7,
		},
	},
	[13557] = {
		148,
		13557,
		1,
		11,
		"Bearer of Good Fortune",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			[3] = "Darkshore",
			[4] = 57.7,
			[5] = 32.8,
		},
	},
	[13573] = {
		148,
		13573,
		1,
		15,
		"Malfurion's Return",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			32987,
			"Corvine Moonrise",
			"Darkshore",
			42.6,
			45.2,
		},
	},
	[13589] = {
		148,
		13589,
		1,
		13,
		"The Shatterspear Invaders",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			32971,
			"Ranger Glynda Nal'Shea",
			"Darkshore",
			50.6,
			20.4,
		},
	},
	[13605] = {
		148,
		13605,
		1,
		15,
		"The Last Refugee",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			33232,
			"Archaeologist Hollee",
			"Darkshore",
			38.6,
			42.4,
		},
	},
	[27234] = {
		15,
		27234,
		1,
		37,
		"Defias in Dustwallow?",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			5086,
			"Captain Wymor",
			"Dustwallow Marsh",
			59.7,
			41.1,
		},
	},
	[27000] = {
		28,
		27000,
		1,
		37,
		"Learning the Ropes",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			11616,
			"Nathaniel Dumah",
			"Western Plaguelands",
			48.2,
			32.3,
		},
	},
	[13653] = {
		331,
		13653,
		1,
		21,
		"Crisis at Splintertree",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			33421,
			"Gorka",
			"Ashenvale",
			72.90000000000001,
			80.5,
		},
	},
	[123] = {
		12,
		123,
		1,
		10,
		"The Collector",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Elwynn Forest",
			[4] = 79.5,
			[5] = 68.09999999999999,
		},
	},
	[24512] = {
		4709,
		24512,
		1,
		30,
		"Warriors' Redemption",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			37153,
			"Holgom",
			"Southern Barrens",
			37.6,
			16.6,
		},
	},
	[24504] = {
		4709,
		24504,
		1,
		30,
		"Clear the High Road",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			37135,
			"Nura Pathfinder",
			"Southern Barrens",
			31.4,
			13.3,
		},
	},
	[27153] = {
		28,
		27153,
		1,
		37,
		"The Good People of Hearthglen",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			[3] = "Western Plaguelands",
			[4] = 57.5,
			[5] = 35.8,
		},
	},
	[27458] = {
		139,
		27458,
		1,
		42,
		"Smokey and the Bandage",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			11033,
			"Smokey LaRue",
			"Eastern Plaguelands",
			75,
			53.4,
		},
	},
	[24546] = {
		4709,
		24546,
		1,
		32,
		"A Line in the Dirt",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			3418,
			"Kirge Sternhorn",
			"Southern Barrens",
			41.6,
			46.5,
		},
	},
	[27522] = {
		139,
		27522,
		1,
		44,
		"Beat it Out of Them",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			45729,
			"Tarenar Sunstrike",
			"Eastern Plaguelands",
			50.4,
			20.2,
		},
	},
	[28342] = {
		361,
		28342,
		1,
		48,
		"Fel To Pieces",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			48339,
			"Elessa Starbreeze",
			"Felwood",
			43.9,
			28,
		},
	},
	[13797] = {
		331,
		13797,
		1,
		22,
		"Dirty Deeds",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			33760,
			"Durak",
			"Ashenvale",
			72.3,
			57.6,
		},
	},
	[27618] = {
		139,
		27618,
		1,
		42,
		"Argent Upheaval",
		"A",
		2,
		"ROGUEPALADIN",
		2,
		"NIGHTELFHUMAN",
		{
			16112,
			"Crusade Commander Korfax",
			"Eastern Plaguelands",
			75.3,
			76.2,
		},
	},
	[25710] = {
		4,
		25710,
		1,
		55,
		"Minor Distractions",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			5393,
			"Quartermaster Lungertz",
			"Blasted Lands",
			60.1,
			13.6,
		},
	},
	[26010] = {
		406,
		26010,
		1,
		27,
		"Ashes to Ashes",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			41023,
			"Overlord Krom'gar",
			"Stonetalon Mountains",
			66.09999999999999,
			63.8,
		},
	},
	[26046] = {
		406,
		26046,
		1,
		27,
		"Between a Rock and a Hard Place",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			41990,
			"Scout Utvoch",
			"Stonetalon Mountains",
			67.09999999999999,
			64.40000000000001,
		},
	},
	[25699] = {
		4,
		25699,
		1,
		56,
		"The Amulet of Grol",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			7783,
			"Loramus Thalipedes",
			"Blasted Lands",
			39.3,
			35.8,
		},
	},
	[13893] = {
		148,
		13893,
		1,
		19,
		"Soggoth and Kronn",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			34340,
			"Archaeologist Groff",
			"Darkshore",
			37.7,
			82.8,
		},
	},
	[13909] = {
		148,
		13909,
		1,
		18,
		"Got Some Flotsam?",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			34340,
			"Archaeologist Groff",
			"Darkshore",
			37.7,
			82.8,
		},
	},
	[13925] = {
		148,
		13925,
		1,
		18,
		"An Ounce of Prevention",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			34301,
			"Kathrena Winterwisp",
			"Darkshore",
			45.2,
			74.59999999999999,
		},
	},
	[24534] = {
		4709,
		24534,
		1,
		32,
		"Speaking Their Language",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			11857,
			"Makaba Flathoof",
			"Southern Barrens",
			44.2,
			33.7,
		},
	},
	[13973] = {
		17,
		13973,
		1,
		12,
		"The Grol'dom Militia",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			34560,
			"Una Wolfclaw",
			"Northern Barrens",
			0,
			0,
		},
	},
	[25891] = {
		406,
		25891,
		1,
		29,
		"[29] [29] Last Ditch Effort",
		"A",
		2,
		"PALADINDRUIDMAGE",
		2,
		"DRAENEINIGHTELFGNOME",
		{
			41482,
			"Master Thal'darah",
			"Stonetalon Mountains",
			39.9,
			33.5,
		},
	},
	[9895] = {
		3521,
		9895,
		1,
		62,
		"The Dying Balance [Group]",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			17834,
			"Lethyn Moonfire",
			"Zangarmarsh",
			78.59999999999999,
			63.1,
		},
	},
	[24515] = {
		4709,
		24515,
		1,
		31,
		"Signals in the Sky",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			37138,
			"Onatay",
			"Southern Barrens",
			39.5,
			20.4,
		},
	},
	[28034] = {
		51,
		28034,
		1,
		49,
		"Lunk's Adventure: Rendan's Weakness",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			47429,
			"Lunk",
			"Searing Gorge",
			0,
			0,
		},
	},
	[26004] = {
		406,
		26004,
		1,
		26,
		"Krom'gar Fortress",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			34341,
			"Saurboz",
			"Stonetalon Mountains",
			74.3,
			47.8,
		},
	},
	[27533] = {
		139,
		27533,
		1,
		44,
		"A Fate Worse Than Butchery",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			12384,
			"Augustus the Touched",
			"Eastern Plaguelands",
			11.4,
			28.7,
		},
	},
	[37] = {
		12,
		37,
		1,
		10,
		"Find the Lost Guards",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			261,
			"Guard Thomas",
			"Elwynn Forest",
			73.90000000000001,
			72.2,
		},
	},
	[26115] = {
		406,
		26115,
		1,
		30,
		"To Be Horde...",
		"H",
		2,
		"WARLOCKPALADIN",
		2,
		"SCOURGEBLOODELF",
		{
			42106,
			"Overlord Krom'gar",
			"Stonetalon Mountains",
			45.6,
			34.1,
		},
	},
	[334] = {
		1519,
		334,
		1,
		2,
		"Package for Thurman",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			1428,
			"Rema Schneider",
			"Stormwind City",
			57.9,
			67.09999999999999,
		},
	},
	[28226] = {
		46,
		28226,
		1,
		50,
		"Scrapped Golems",
		"HA",
		2,
		"DEATHKNIGHTMAGE",
		2,
		"BLOODELFDRAENEI",
		{
			48033,
			"Stebben Oreknuckle",
			"Burning Steppes",
			0,
			0,
		},
	},
	[28418] = {
		46,
		28418,
		1,
		50,
		"Burning Vengeance",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48559,
			"Ariok",
			"Burning Steppes",
			0,
			0,
		},
	},
	[28610] = {
		618,
		28610,
		1,
		52,
		"Rubble Trouble",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			48965,
			"Deez Rocksnitch",
			"Winterspring",
			59.8,
			49.7,
		},
	},
	[14165] = {
		16,
		14165,
		1,
		11,
		"Stone Cold",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35091,
			"Horzak Zignibble",
			"Azshara",
			29.1,
			66.40000000000001,
		},
	},
	[26627] = {
		10,
		26627,
		1,
		21,
		"The Hermit",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			264,
			"Commander Althea Ebonlocke",
			"Duskwood",
			73.59999999999999,
			46.9,
		},
	},
	[14197] = {
		16,
		14197,
		1,
		11,
		"A Quota to Meet",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35085,
			"Foreman Fisk",
			"Azshara",
			29.1,
			66.59999999999999,
		},
	},
	[14213] = {
		405,
		14213,
		1,
		31,
		"Ten Pounds of Flesh",
		"H",
		2,
		"PALADIN",
		2,
		"BLOODELF",
		{
			[3] = "Desolace",
			[4] = 78.7,
			[5] = 23.2,
		},
	},
	[28450] = {
		46,
		28450,
		1,
		51,
		"A Delivery for Thorg'izog",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48569,
			"Eitrigg",
			"Burning Steppes",
			54.6,
			24.6,
		},
	},
	[26435] = {
		5287,
		26435,
		1,
		32,
		"I'm A Huge Liar and a Fraud",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			43096,
			"Flem Gizzix",
			"The Cape of Stranglethorn",
			33.7,
			29.2,
		},
	},
	[28514] = {
		46,
		28514,
		1,
		50,
		"Mouton Flamestar",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			14625,
			"Overseer Oilfist",
			"Searing Gorge",
			38.1,
			26.7,
		},
	},
	[24452] = {
		16,
		24452,
		1,
		13,
		"Profitability Scouting",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36749,
			"Commander Molotov",
			"Azshara",
			29.4,
			57.7,
		},
	},
	[14357] = {
		405,
		14357,
		1,
		31,
		"To the Hilt!",
		"A",
		2,
		"WARLOCK",
		2,
		"GNOME",
		{
			[3] = "Desolace",
			[4] = 75.90000000000001,
			[5] = 26.5,
		},
	},
	[14309] = {
		405,
		14309,
		1,
		32,
		"Calming the Kodo",
		"HA",
		2,
		"PALADINWARLOCK",
		2,
		"BLOODELFGNOME",
		{
			36048,
			"Thressa Amberglen",
			"Desolace",
			58.7,
			46.4,
		},
	},
	[26595] = {
		5287,
		26595,
		1,
		32,
		"Kill-Collect",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2501,
			"\"Sea Wolf\" MacKinley",
			"The Cape of Stranglethorn",
			42,
			73.5,
		},
	},
	[14341] = {
		405,
		14341,
		1,
		32,
		"Smeed's Harnesses",
		"H",
		2,
		"PALADINMAGE",
		2,
		"BLOODELFTROLL",
		{
			11259,
			"Nataka Longhorn",
			"Desolace",
			55.4,
			55.7,
		},
	},
	[28706] = {
		618,
		28706,
		1,
		53,
		"Spray it Forward",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			49407,
			"Rinno Curtainfire",
			"Winterspring",
			45.8,
			41,
		},
	},
	[26691] = {
		10,
		26691,
		1,
		24,
		"Worgen in the Woods",
		"A",
		2,
		"WARLOCKSHAMAN",
		2,
		"HUMANDWARF",
		{
			663,
			"Calor",
			"Duskwood",
			75.2,
			48,
		},
	},
	[26723] = {
		10,
		26723,
		1,
		24,
		"The Fate of Morbent Fel",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			43861,
			"Sven Yorgen",
			"Duskwood",
			18.4,
			58,
		},
	},
	[24708] = {
		490,
		24708,
		1,
		54,
		"The Fossil-Finder 3000",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			9272,
			"Spark Nilminer",
			"Un'Goro Crater",
			31.9,
			50.4,
		},
	},
	[26787] = {
		10,
		26787,
		1,
		24,
		"Bear In Mind",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			288,
			"Jitters",
			"Duskwood",
			18.7,
			58.1,
		},
	},
	[28335] = {
		361,
		28335,
		1,
		49,
		"Turn it Off! Turn it Off!",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			48333,
			"Foreman Pikwik",
			"Felwood",
			54.7,
			18.4,
		},
	},
	[25853] = {
		11,
		25853,
		1,
		23,
		"Tooling Around",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			41413,
			"Merrin Rockweaver",
			"Wetlands",
			38.8,
			39.7,
		},
	},
	[14469] = {
		16,
		14469,
		1,
		13,
		"Hand-me-downs",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36749,
			"Commander Molotov",
			"Azshara",
			29.4,
			57.8,
		},
	},
	[14485] = {
		16,
		14485,
		1,
		17,
		"Ticker Required",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36895,
			"Sergeant Zelks",
			"Azshara",
			34.5,
			44.7,
		},
	},
	[14300] = {
		16,
		14300,
		1,
		18,
		"The Trial of Fire",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36361,
			"Image of Archmage Xylem",
			"Azshara",
			56,
			12.2,
		},
	},
	[24932] = {
		440,
		24932,
		1,
		47,
		"Cutting Losses",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38706,
			"Zeke Bootscuff",
			"Tanaris",
			55.7,
			60.8,
		},
	},
	[27011] = {
		28,
		27011,
		1,
		37,
		"Redpine Thievery",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			44472,
			"Kelly Dumah",
			"Western Plaguelands",
			48.5,
			32,
		},
	},
	[24577] = {
		4709,
		24577,
		1,
		33,
		"Desolation Hold Inspection",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			37679,
			"Warlord Bloodhilt",
			"Southern Barrens",
			41.5,
			46.8,
		},
	},
	[25028] = {
		4709,
		25028,
		1,
		31,
		"Trouble From the Ground Up",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38876,
			"Hannah Bridgewater",
			"Southern Barrens",
			56.2,
			42.6,
		},
	},
	[26878] = {
		718,
		26878,
		1,
		16,
		"Disciples of Naralex",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			3448,
			"Tonga Runetotem",
			"Northern Barrens",
			49.5,
			58.7,
		},
	},
	[13506] = {
		148,
		13506,
		1,
		13,
		"Reason to Worry",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			[3] = "Darkshore",
			[4] = 60.5,
			[5] = 18.9,
		},
	},
	[24694] = {
		490,
		24694,
		1,
		55,
		"The Shaper's Terrace",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38504,
			"Un'Goro Examinant",
			"Un'Goro Crater",
			53.9,
			62.6,
		},
	},
	[25817] = {
		11,
		25817,
		1,
		22,
		"The Cursed Crew",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			41307,
			"First Mate Snellig",
			"Wetlands",
			15.2,
			29.3,
		},
	},
	[27235] = {
		15,
		27235,
		1,
		37,
		"Renn McGill",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			5086,
			"Captain Wymor",
			"Dustwallow Marsh",
			59.7,
			41.1,
		},
	},
	[26001] = {
		406,
		26001,
		1,
		26,
		"The Missing Blastgineer",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			34341,
			"Saurboz",
			"Stonetalon Mountains",
			74.3,
			47.7,
		},
	},
	[12630] = {
		66,
		12630,
		1,
		75,
		"Kickin' Nass and Takin' Manes",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			28518,
			"Stefan Vadu",
			"Zul'Drak",
			14.1,
			73.7,
		},
	},
	[25284] = {
		4709,
		25284,
		1,
		30,
		"Feeding the Fear",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			37153,
			"Holgom",
			"Southern Barrens",
			37.6,
			16.6,
		},
	},
	[24539] = {
		4709,
		24539,
		1,
		31,
		"When Plants Attack",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			37515,
			"Lane Tallgrass",
			"Southern Barrens",
			44.3,
			33.3,
		},
	},
	[27168] = {
		28,
		27168,
		1,
		36,
		"Those That Couldn't Let Go",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			11053,
			"High Priestess MacDonnell",
			"Western Plaguelands",
			43.3,
			83.8,
		},
	},
	[26957] = {
		28,
		26957,
		1,
		38,
		"The Long Trip Home",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			44905,
			"Del Gahrron",
			"Western Plaguelands",
			42.6,
			14.9,
		},
	},
	[27459] = {
		139,
		27459,
		1,
		42,
		"The Brotherhood of Light",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			11036,
			"Leonid Barthalomew the Revered",
			"Eastern Plaguelands",
			75.7,
			52.1,
		},
	},
	[1258] = {
		15,
		1258,
		1,
		36,
		"... and Bugs",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			4794,
			"Morgan Stern",
			"Dustwallow Marsh",
			68.2,
			48.6,
		},
	},
	[27523] = {
		139,
		27523,
		1,
		44,
		"Duskwing, Oh How I Hate Thee...",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			45816,
			"Corpseburner Tim",
			"Eastern Plaguelands",
			48,
			23,
		},
	},
	[10813] = {
		3483,
		10813,
		1,
		62,
		"The Eyes of Grillok",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			22231,
			"Zezzak",
			"Hellfire Peninsula",
			61.6,
			81.8,
		},
	},
	[26563] = {
		44,
		26563,
		1,
		17,
		"Return of the Bravo Company",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			43302,
			"Danforth",
			"Redridge Mountains",
			28.2,
			17,
		},
	},
	[27619] = {
		139,
		27619,
		1,
		42,
		"The Commander",
		"A",
		2,
		"ROGUEPALADIN",
		2,
		"NIGHTELFHUMAN",
		{
			16112,
			"Crusade Commander Korfax",
			"Eastern Plaguelands",
			75.5,
			76.2,
		},
	},
	[14316] = {
		405,
		14316,
		1,
		32,
		"Cenarion Property",
		"H",
		2,
		"PALADIN",
		2,
		"BLOODELF",
		{
			36052,
			"Garren Darkwind",
			"Desolace",
			58.4,
			49.8,
		},
	},
	[27683] = {
		139,
		27683,
		1,
		40,
		"Into the Woods",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			10840,
			"Argent Officer Pureheart",
			"Western Plaguelands",
			43,
			83.7,
		},
	},
	[895] = {
		17,
		895,
		1,
		16,
		"WANTED: Cap'n Garvey",
		"HA",
		2,
		"DRUIDHUNTERMAGE",
		2,
		"TROLLDRAENEIGNOME",
		{
			3446,
			"Mebok Mizzyrix",
			"Northern Barrens",
			0,
			0,
		},
	},
	[25700] = {
		4,
		25700,
		1,
		56,
		"Loramus Thalipedes Awaits",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			7506,
			"Bloodmage Lynnore",
			"Blasted Lands",
			39.2,
			36.2,
		},
	},
	[28812] = {
		12,
		28812,
		1,
		3,
		"Fear No Evil",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			951,
			"Brother Paxton",
			"Elwynn Forest",
			48.5,
			38.2,
		},
	},
	[26733] = {
		33,
		26733,
		1,
		25,
		"Control Sample",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			739,
			"Brother Nimetz",
			"Northern Stranglethorn",
			47.3,
			11.2,
		},
	},
	[25796] = {
		400,
		25796,
		1,
		41,
		"[41] [41] Eminent Domain",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			41190,
			"Crazzle Sprysprocket",
			"Thousand Needles",
			91.40000000000001,
			57.7,
		},
	},
	[10103] = {
		3483,
		10103,
		1,
		61,
		"Report to Zurai",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16789,
			"Ranger Captain Venn'ren",
			"Hellfire Peninsula",
			28.6,
			60.3,
		},
	},
	[26669] = {
		10,
		26669,
		1,
		23,
		"In A Dark Corner",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			267,
			"Clerk Daltry",
			"Duskwood",
			72.5,
			46.9,
		},
	},
	[14346] = {
		405,
		14346,
		1,
		34,
		"Cleansing Our Crevasse",
		"H",
		2,
		"PALADINMAGE",
		2,
		"BLOODELFTROLL",
		{
			36034,
			"Karnum Marshweaver",
			"Desolace",
			57.4,
			47.7,
		},
	},
	[26605] = {
		5287,
		26605,
		1,
		32,
		"Grubby Little Paws",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2634,
			"Princess Poobah",
			"The Cape of Stranglethorn",
			59.4,
			79.09999999999999,
		},
	},
	[14314] = {
		405,
		14314,
		1,
		32,
		"Breakout!",
		"H",
		2,
		"PALADIN",
		2,
		"BLOODELF",
		{
			36056,
			"Khan Leh'Prah",
			"Desolace",
			58.3,
			50,
		},
	},
	[28035] = {
		51,
		28035,
		1,
		49,
		"The Mountain-Lord's Support",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			47393,
			"Mountain-Lord Rendan",
			"Searing Gorge",
			39.3,
			67.7,
		},
	},
	[26020] = {
		406,
		26020,
		1,
		27,
		"Report to Bombgutz",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			41023,
			"Overlord Krom'gar",
			"Stonetalon Mountains",
			66.2,
			63.7,
		},
	},
	[28099] = {
		51,
		28099,
		1,
		48,
		"Rasha'krak",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			14625,
			"Overseer Oilfist",
			"Searing Gorge",
			38.1,
			27.7,
		},
	},
	[28131] = {
		361,
		28131,
		1,
		46,
		"Twin Temptresses",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			7120,
			"Jaedenar Warlock",
			"Felwood",
			37,
			55.5,
		},
	},
	[14389] = {
		16,
		14389,
		1,
		19,
		"Wasn't It Obvious?",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36372,
			"Joanna",
			"Azshara",
			25.6,
			38,
		},
	},
	[14282] = {
		405,
		14282,
		1,
		32,
		"Mystery Solved",
		"HA",
		2,
		"PALADINWARLOCK",
		2,
		"BLOODELFGNOME",
		{
			[3] = "Desolace",
			[4] = 30,
			[5] = 15.9,
		},
	},
	[28227] = {
		46,
		28227,
		1,
		50,
		"Golem Training",
		"HA",
		2,
		"DEATHKNIGHTMAGE",
		2,
		"BLOODELFDRAENEI",
		{
			48033,
			"Stebben Oreknuckle",
			"Burning Steppes",
			46.7,
			44.2,
		},
	},
	[24701] = {
		490,
		24701,
		1,
		53,
		"Marshal's Refuse",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38277,
			"Doreen",
			"Un'Goro Crater",
			43.3,
			41,
		},
	},
	[13988] = {
		17,
		13988,
		1,
		13,
		"A Growing Problem",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			3448,
			"Tonga Runetotem",
			"Northern Barrens",
			0,
			0,
		},
	},
	[28221] = {
		361,
		28221,
		1,
		48,
		"These Roots Were Made For Stompin'",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			48042,
			"Sapling Protector",
			"Felwood",
			49.2,
			19.3,
		},
	},
	[14284] = {
		405,
		14284,
		1,
		32,
		"A Revenant's Vengeance",
		"HA",
		2,
		"PALADINWARLOCK",
		2,
		"BLOODELFGNOME",
		{
			35902,
			"Lord Hydronis",
			"Desolace",
			29.1,
			8.300000000000001,
		},
	},
	[28387] = {
		361,
		28387,
		1,
		49,
		"Burnout",
		"A",
		2,
		"HUNTER",
		2,
		"DRAENEI",
		{
			48493,
			"Alton Redding",
			"Felwood",
			56.8,
			18.4,
		},
	},
	[28419] = {
		46,
		28419,
		1,
		50,
		"Stocking Up",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48559,
			"Ariok",
			"Burning Steppes",
			17.4,
			51.7,
		},
	},
	[28451] = {
		46,
		28451,
		1,
		51,
		"A Delivery for Neeralak",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48569,
			"Eitrigg",
			"Burning Steppes",
			0,
			0,
		},
	},
	[26349] = {
		40,
		26349,
		1,
		15,
		"The Coastal Menace",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			392,
			"Captain Grayson",
			"Westfall",
			30.5,
			85.59999999999999,
		},
	},
	[6621] = {
		331,
		6621,
		1,
		25,
		"King of the Foulweald",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			12696,
			"Senani Thunderheart",
			"Ashenvale",
			49.8,
			65.2,
		},
	},
	[24453] = {
		16,
		24453,
		1,
		13,
		"Private Chat",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36749,
			"Commander Molotov",
			"Azshara",
			29.5,
			57.8,
		},
	},
	[24723] = {
		490,
		24723,
		1,
		55,
		"The Western Pylon",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			9272,
			"Spark Nilminer",
			"Un'Goro Crater",
			31.9,
			50.3,
		},
	},
	[24517] = {
		4709,
		24517,
		1,
		31,
		"Put the Fear in Them",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			37154,
			"Kilrok Gorehammer",
			"Southern Barrens",
			39.6,
			19.9,
		},
	},
	[26482] = {
		331,
		26482,
		1,
		25,
		"True Power of the Rod",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			3897,
			"Krolg",
			"Ashenvale",
			50.9,
			75.09999999999999,
		},
	},
	[28338] = {
		361,
		28338,
		1,
		49,
		"Deadwood of the North",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			15395,
			"Nafien",
			"Felwood",
			64,
			10.4,
		},
	},
	[26660] = {
		10,
		26660,
		1,
		21,
		"Zombie Juice",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			289,
			"Abercrombie",
			"Duskwood",
			87.40000000000001,
			35.4,
		},
	},
	[26692] = {
		44,
		26692,
		1,
		19,
		"Shadowhide Extinction",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			43607,
			"Danforth",
			"Redridge Mountains",
			77.3,
			65.7,
		},
	},
	[26724] = {
		10,
		26724,
		1,
		25,
		"The Lurking Lich",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			43861,
			"Sven Yorgen",
			"Duskwood",
			18.5,
			58,
		},
	},
	[24709] = {
		490,
		24709,
		1,
		55,
		"A Tale of Two Shovels",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			9272,
			"Spark Nilminer",
			"Un'Goro Crater",
			31.8,
			50.3,
		},
	},
	[26713] = {
		44,
		26713,
		1,
		20,
		"Showdown at Stonewatch",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			43733,
			"Colonel Troteman",
			"Redridge Mountains",
			60.6,
			36.7,
		},
	},
	[27858] = {
		3,
		27858,
		1,
		47,
		"Rheastrasza's Gift",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			[3] = "Badlands",
			[4] = 16.1,
			[5] = 33.2,
		},
	},
	[27002] = {
		28,
		27002,
		1,
		37,
		"An Audience with the Highlord",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			11616,
			"Nathaniel Dumah",
			"Western Plaguelands",
			48.1,
			32.5,
		},
	},
	[28336] = {
		361,
		28336,
		1,
		49,
		"Slap and Cap",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			48127,
			"Darla Drilldozer",
			"Felwood",
			56.3,
			8.199999999999999,
		},
	},
	[28534] = {
		618,
		28534,
		1,
		51,
		"Descendants of the Highborne",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			48658,
			"Kaldorei Spirit",
			"Winterspring",
			50.7,
			54.9,
		},
	},
	[147] = {
		12,
		147,
		1,
		10,
		"Manhunt",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			42256,
			"Marshal McCree",
			"Elwynn Forest",
			81.7,
			66.09999999999999,
		},
	},
	[24933] = {
		440,
		24933,
		1,
		47,
		"Chicken of the Desert",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38706,
			"Zeke Bootscuff",
			"Tanaris",
			55.7,
			60.8,
		},
	},
	[13510] = {
		148,
		13510,
		1,
		13,
		"Timely Arrival",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			32964,
			"Sentinel Aynasha",
			"Darkshore",
			64.5,
			5.4,
		},
	},
	[13526] = {
		148,
		13526,
		1,
		19,
		"The Bear's Paw",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			32967,
			"Elder Brolg",
			"Darkshore",
			43.5,
			81,
		},
	},
	[13542] = {
		148,
		13542,
		1,
		15,
		"Against the Wind",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			3694,
			"Sentinel Selarin",
			"Darkshore",
			42.5,
			45.2,
		},
	},
	[13558] = {
		148,
		13558,
		1,
		16,
		"Call Down the Thunder",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			6887,
			"Yalda",
			"Darkshore",
			39.1,
			43.2,
		},
	},
	[24565] = {
		4709,
		24565,
		1,
		31,
		"Biological Intervention",
		"AH",
		2,
		"DRUIDMAGEWARLOCK",
		2,
		"NIGHTELFGNOMESCOURGE",
		{
			37570,
			"Naralex",
			"Southern Barrens",
			50.4,
			40.7,
		},
	},
	[13590] = {
		148,
		13590,
		1,
		14,
		"The Front Line",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			32963,
			"Lieutenant Morra Starbreeze",
			"Darkshore",
			58.9,
			19.5,
		},
	},
	[14370] = {
		16,
		14370,
		1,
		13,
		"Mysterious Azsharite",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36077,
			"Assistant Greely",
			"Azshara",
			50.4,
			74.3,
		},
	},
	[25189] = {
		14,
		25189,
		1,
		8,
		"Spirits Be Praised [Escort]",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			39325,
			"Grandmatron Tekla",
			"Durotar",
			40.6,
			35,
		},
	},
	[27012] = {
		28,
		27012,
		1,
		37,
		"A Gnoll's Resolve",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			44472,
			"Kelly Dumah",
			"Western Plaguelands",
			48.5,
			32,
		},
	},
	[24731] = {
		490,
		24731,
		1,
		51,
		"The Fare of Lar'korwi",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			9619,
			"Torwa Pathfinder",
			"Un'Goro Crater",
			71.2,
			76.7,
		},
	},
	[28718] = {
		618,
		28718,
		1,
		53,
		"Where There's Smoke, There's Delicious Meat",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			49402,
			"Sana Curtainfire",
			"Winterspring",
			48.1,
			40.6,
		},
	},
	[27152] = {
		28,
		27152,
		1,
		37,
		"Unusual Behavior... Even For Gnolls",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			[3] = "Western Plaguelands",
			[4] = 55,
			[5] = 23.3,
		},
	},
	[4970] = {
		618,
		4970,
		1,
		60,
		"Frostsaber Provisions",
		"A",
		2,
		"HUNTER",
		2,
		"DRAENEI",
		{
			10618,
			"Rivern Frostwind",
			"Winterspring",
			46.7,
			17.7,
		},
	},
	[28305] = {
		361,
		28305,
		1,
		48,
		"The Fate of Bloodvenom Post",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			47617,
			"Farlus Wildheart",
			"Felwood",
			44.1,
			61.8,
		},
	},
	[27460] = {
		139,
		27460,
		1,
		42,
		"Soft Landing",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			16116,
			"Archmage Angela Dosantos",
			"Eastern Plaguelands",
			72.5,
			74.8,
		},
	},
	[24706] = {
		490,
		24706,
		1,
		54,
		"The Spirits of Golakka Hot Springs",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38255,
			"Maximillian of Northshire",
			"Un'Goro Crater",
			29.1,
			22.2,
		},
	},
	[27524] = {
		139,
		27524,
		1,
		44,
		"Blind Fury",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			45417,
			"Fiona",
			"Eastern Plaguelands",
			50.6,
			20.3,
		},
	},
	[24693] = {
		490,
		24693,
		1,
		52,
		"Mossy Pile",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			10977,
			"Quixxil",
			"Un'Goro Crater",
			54.9,
			63.6,
		},
	},
	[13798] = {
		331,
		13798,
		1,
		22,
		"Rain of Destruction",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			33760,
			"Durak",
			"Ashenvale",
			72.2,
			57.6,
		},
	},
	[27620] = {
		139,
		27620,
		1,
		43,
		"Like Rats",
		"A",
		2,
		"ROGUEPALADIN",
		2,
		"NIGHTELFHUMAN",
		{
			16116,
			"Archmage Angela Dosantos",
			"Eastern Plaguelands",
			76.09999999999999,
			75.3,
		},
	},
	[13830] = {
		-101,
		13830,
		3,
		80,
		"The Ghostfish",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			28742,
			"Marcia Chase",
			"Dalaran",
			52.8,
			65.09999999999999,
		},
	},
	[9752] = {
		3521,
		9752,
		1,
		63,
		"Escape from Umbrafen",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			17969,
			"Kayra Longmane",
			"Zangarmarsh",
			83.3,
			85.5,
		},
	},
	[25669] = {
		406,
		25669,
		1,
		27,
		"Rumble in the Lumber... Mill",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			41071,
			"Huntress Illiona",
			"Stonetalon Mountains",
			66.2,
			54.6,
		},
	},
	[13878] = {
		17,
		13878,
		1,
		11,
		"Through Fire and Flames",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			34284,
			"Dorak",
			"Northern Barrens",
			67.09999999999999,
			45.5,
		},
	},
	[25741] = {
		406,
		25741,
		1,
		27,
		"Preparations for the Future",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			40898,
			"Alithia Fallowmere",
			"Stonetalon Mountains",
			59,
			56.4,
		},
	},
	[13910] = {
		148,
		13910,
		1,
		18,
		"A New Home",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			34340,
			"Archaeologist Groff",
			"Darkshore",
			37.7,
			82.8,
		},
	},
	[25709] = {
		4,
		25709,
		1,
		55,
		"Curtail the Darktail",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			9540,
			"Enohar Thunderbrew",
			"Blasted Lands",
			61.5,
			18.6,
		},
	},
	[13942] = {
		331,
		13942,
		1,
		23,
		"Set Us Up the Bomb",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			34395,
			"Tweedle",
			"Ashenvale",
			38,
			43.9,
		},
	},
	[13958] = {
		331,
		13958,
		1,
		23,
		"Condition Critical!",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			34359,
			"Captain Goggath",
			"Ashenvale",
			38.3,
			43.3,
		},
	},
	[13974] = {
		331,
		13974,
		1,
		23,
		"Tweedle's Tiny Package",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			34395,
			"Tweedle",
			"Ashenvale",
			38,
			43.8,
		},
	},
	[25925] = {
		406,
		25925,
		1,
		30,
		"[30] [30] Thal'darah's Vengeance",
		"A",
		2,
		"PALADINDRUIDMAGE",
		2,
		"DRAENEINIGHTELFGNOME",
		{
			41482,
			"Master Thal'darah",
			"Stonetalon Mountains",
			40,
			33.5,
		},
	},
	[9912] = {
		3521,
		9912,
		1,
		62,
		"The Cenarion Expedition",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16885,
			"Amythiel Mistwalker",
			"Hellfire Peninsula",
			16,
			52.2,
		},
	},
	[9772] = {
		3521,
		9772,
		1,
		62,
		"Jyoba's Report",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			18035,
			"Scout Jyoba",
			"Zangarmarsh",
			80.8,
			36.3,
		},
	},
	[28530] = {
		618,
		28530,
		1,
		50,
		"Scalding Signs",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			9298,
			"Donova Snowden",
			"Winterspring",
			25.2,
			58.4,
		},
	},
	[28100] = {
		361,
		28100,
		1,
		46,
		"A Talking Totem",
		"H",
		2,
		"DRUIDWARRIOR",
		2,
		"TROLLTAUREN",
		{
			11554,
			"Grazle",
			"Felwood",
			51.4,
			80.5,
		},
	},
	[26394] = {
		12,
		26394,
		1,
		7,
		"Continue to Stormwind",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			42983,
			"Bartlett the Brave",
			"Elwynn Forest",
			41.8,
			64.7,
		},
	},
	[26980] = {
		11,
		26980,
		1,
		23,
		"Swiftgear Station",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			2104,
			"Captain Stoutfist",
			"Wetlands",
			10.5,
			55.8,
		},
	},
	[14198] = {
		405,
		14198,
		1,
		31,
		"Rider on the Storm",
		"H",
		2,
		"PALADIN",
		2,
		"BLOODELF",
		{
			[3] = "Desolace",
			[4] = 74.8,
			[5] = 13.2,
		},
	},
	[14118] = {
		16,
		14118,
		1,
		10,
		"Venison for the Troops",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			8576,
			"Ag'tor Bloodfist",
			"Azshara",
			26.9,
			76.90000000000001,
		},
	},
	[14134] = {
		16,
		14134,
		1,
		11,
		"The Captain's Logs",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35129,
			"Reprogrammed Shredder",
			"Azshara",
			28.8,
			75,
		},
	},
	[27154] = {
		28,
		27154,
		1,
		37,
		"Bagging Bisp",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			45149,
			"Outfitter Mendelev",
			"Western Plaguelands",
			44.9,
			12.5,
		},
	},
	[24692] = {
		490,
		24692,
		1,
		53,
		"The Fledgling Colossus [Group]",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			9271,
			"Hol'anyee Marshal",
			"Un'Goro Crater",
			55.1,
			62.2,
		},
	},
	[28676] = {
		618,
		28676,
		1,
		53,
		"Exterminators at Work",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			11079,
			"Wynd Nightchaser",
			"Winterspring",
			48.7,
			41,
		},
	},
	[28388] = {
		361,
		28388,
		1,
		49,
		"Bloody Wages",
		"A",
		2,
		"HUNTER",
		2,
		"DRAENEI",
		{
			48493,
			"Alton Redding",
			"Felwood",
			56.8,
			18.4,
		},
	},
	[28420] = {
		46,
		28420,
		1,
		50,
		"A Future Project",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48559,
			"Ariok",
			"Burning Steppes",
			0,
			0,
		},
	},
	[14230] = {
		16,
		14230,
		1,
		18,
		"Manual Labor",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35756,
			"Teresa Spireleaf",
			"Azshara",
			47.2,
			21.2,
		},
	},
	[14390] = {
		16,
		14390,
		1,
		19,
		"Easy is Boring",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36436,
			"Spirit of Azuregos",
			"Azshara",
			28,
			40.3,
		},
	},
	[14262] = {
		16,
		14262,
		1,
		13,
		"To Gut a Fish",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35657,
			"Torg Twocrush",
			"Azshara",
			50.7,
			75.2,
		},
	},
	[28219] = {
		361,
		28219,
		1,
		48,
		"Buzzers for Baby",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			48032,
			"Seedling Protector",
			"Felwood",
			48.1,
			31.1,
		},
	},
	[26533] = {
		5287,
		26533,
		1,
		31,
		"Zanzil's Secret",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			43097,
			"Mixmaster Jasper",
			"The Cape of Stranglethorn",
			35.1,
			27.5,
		},
	},
	[24518] = {
		4709,
		24518,
		1,
		31,
		"The Low Road",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			[3] = "Southern Barrens",
			[4] = 41.6,
			[5] = 19.9,
		},
	},
	[26597] = {
		5287,
		26597,
		1,
		33,
		"Stranglethorn Fever",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2486,
			"Fin Fizracket",
			"The Cape of Stranglethorn",
			41.9,
			72.90000000000001,
		},
	},
	[26629] = {
		5287,
		26629,
		1,
		33,
		"Seeing Where Your Loyalties Lie",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			43504,
			"Yancey Grillsen",
			"The Cape of Stranglethorn",
			43.9,
			56.4,
		},
	},
	[14358] = {
		405,
		14358,
		1,
		31,
		"Ten Pounds of Flesh",
		"A",
		2,
		"WARLOCK",
		2,
		"GNOME",
		{
			[3] = "Desolace",
			[4] = 78.8,
			[5] = 23.1,
		},
	},
	[26693] = {
		44,
		26693,
		1,
		19,
		"The Dark Tower",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			43611,
			"John J. Keeshan",
			"Redridge Mountains",
			77.7,
			65.5,
		},
	},
	[26725] = {
		10,
		26725,
		1,
		25,
		"Guided by the Light",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			43731,
			"Sister Elsington",
			"Duskwood",
			20,
			57.8,
		},
	},
	[14310] = {
		16,
		14310,
		1,
		13,
		"Segmentation Fault: Core Dumped",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			[3] = "Azshara",
			[4] = 43.8,
			[5] = 77.40000000000001,
		},
	},
	[14422] = {
		16,
		14422,
		1,
		14,
		"Raptor Raptor Rocket",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36500,
			"Subject Nine",
			"Azshara",
			42.2,
			76.09999999999999,
		},
	},
	[26661] = {
		10,
		26661,
		1,
		22,
		"Gather Rot Blossoms",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			273,
			"Tavernkeep Smitts",
			"Duskwood",
			74,
			44.8,
		},
	},
	[28128] = {
		361,
		28128,
		1,
		46,
		"The Inner Circle",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			[3] = "Felwood",
			[4] = 39.4,
			[5] = 57.9,
		},
	},
	[14470] = {
		16,
		14470,
		1,
		13,
		"Military Breakthrough",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36744,
			"Glix Grindlock",
			"Azshara",
			29.4,
			57.7,
		},
	},
	[14486] = {
		16,
		14486,
		1,
		17,
		"Handling the Goods",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36894,
			"Tora Halotrix",
			"Azshara",
			34.5,
			44.8,
		},
	},
	[24934] = {
		4709,
		24934,
		1,
		30,
		"Repel Boarders!",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38619,
			"Admiral Aubrey",
			"Southern Barrens",
			69.2,
			49.1,
		},
	},
	[26981] = {
		11,
		26981,
		1,
		23,
		"Whelgar's Retreat",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			41415,
			"Shilah Slabchisel",
			"Wetlands",
			26.9,
			26.2,
		},
	},
	[27013] = {
		28,
		27013,
		1,
		37,
		"Too Close for Comfort",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			44472,
			"Kelly Dumah",
			"Western Plaguelands",
			48.4,
			32,
		},
	},
	[25026] = {
		440,
		25026,
		1,
		45,
		"Darkest Mojo",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38927,
			"Mazoga",
			"Tanaris",
			42.3,
			23.9,
		},
	},
	[9215] = {
		3433,
		9215,
		1,
		20,
		"Bring Me Kel'gash's Head! [Group]",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			16463,
			"Farstrider Solanna",
			"Ghostlands",
			72.2,
			31.3,
		},
	},
	[28674] = {
		618,
		28674,
		1,
		53,
		"Starfall Village",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			48965,
			"Deez Rocksnitch",
			"Winterspring",
			59.8,
			49.7,
		},
	},
	[25094] = {
		440,
		25094,
		1,
		49,
		"Thunderdrome: Zumonga! [Group]",
		"H",
		2,
		"WARRIOR",
		2,
		"TAUREN",
		{
			39034,
			"Dr. Dealwell",
			"Tanaris",
			51.8,
			28,
		},
	},
	[24736] = {
		490,
		24736,
		1,
		53,
		"Shizzle's Flyer",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			9998,
			"Shizzle",
			"Un'Goro Crater",
			43.3,
			41.3,
		},
	},
	[25069] = {
		440,
		25069,
		1,
		49,
		"The Secrets of Uldum",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38922,
			"Examiner Andoren Dawnrise",
			"Tanaris",
			33.3,
			77,
		},
	},
	[27237] = {
		15,
		27237,
		1,
		37,
		"Recover the Cargo!",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23569,
			"Renn McGill",
			"Dustwallow Marsh",
			63.7,
			17.1,
		},
	},
	[25541] = {
		440,
		25541,
		1,
		46,
		"Filling Our Pockets",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38703,
			"Megs Dreadshredder",
			"Tanaris",
			71.90000000000001,
			45.4,
		},
	},
	[12631] = {
		66,
		12631,
		1,
		75,
		"An Invitation, of Sorts...",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			[3] = "Zul'Drak",
			[4] = 16.6,
			[5] = 74.90000000000001,
		},
	},
	[5041] = {
		17,
		5041,
		1,
		12,
		"Supplies for the Crossroads",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			34258,
			"Halga Bloodeye",
			"Northern Barrens",
			0,
			0,
		},
	},
	[25681] = {
		4,
		25681,
		1,
		55,
		"Some People Just Need Killing",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			41134,
			"Tak'arili",
			"Blasted Lands",
			62.3,
			1.4,
		},
	},
	[28639] = {
		618,
		28639,
		1,
		53,
		"Ursius",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			[3] = "Winterspring",
			[4] = 57.9,
			[5] = 36.7,
		},
	},
	[28707] = {
		618,
		28707,
		1,
		53,
		"Spray it Again",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			49399,
			"Remma Curtainfire",
			"Winterspring",
			45.6,
			41.6,
		},
	},
	[27461] = {
		139,
		27461,
		1,
		42,
		"To Take the Abbey",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			46138,
			"Argent Centurion",
			"Eastern Plaguelands",
			77.59999999999999,
			79.5,
		},
	},
	[24742] = {
		490,
		24742,
		1,
		52,
		"Finding the Source",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			10302,
			"Krakle",
			"Un'Goro Crater",
			55.3,
			62.5,
		},
	},
	[27525] = {
		139,
		27525,
		1,
		45,
		"Guardians of Stratholme",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			45729,
			"Tarenar Sunstrike",
			"Eastern Plaguelands",
			27.6,
			21.1,
		},
	},
	[9356] = {
		3483,
		9356,
		1,
		61,
		"Smooth as Butter",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			19344,
			"Legassi",
			"Hellfire Peninsula",
			49.3,
			74.8,
		},
	},
	[25542] = {
		400,
		25542,
		1,
		40,
		"[40] [40] Circle the Wagons... er, Boats",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			[3] = "Thousand Needles",
			[4] = 78.3,
			[5] = 73.3,
		},
	},
	[24690] = {
		490,
		24690,
		1,
		53,
		"Blazerunner",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			9270,
			"Williden Marshal",
			"Un'Goro Crater",
			55.1,
			62.1,
		},
	},
	[28638] = {
		618,
		28638,
		1,
		53,
		"The Owls Have It",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			49537,
			"Jeb Guthrie",
			"Winterspring",
			56,
			28.2,
		},
	},
	[28213] = {
		361,
		28213,
		1,
		47,
		"Hazzard Disposal",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			47696,
			"Kelnir Leafsong",
			"Felwood",
			41.3,
			50,
		},
	},
	[10792] = {
		3483,
		10792,
		1,
		61,
		"Zeth'Gor Must Burn!",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			0,
			"Onigumo",
			"Hellfire Peninsula",
			61.1,
			81.3,
		},
	},
	[25702] = {
		4,
		25702,
		1,
		57,
		"Home... Gone... Naga...",
		"AH",
		2,
		"WARLOCKDRUIDWARRIOR",
		2,
		"HUMANTROLLDRAENEI",
		{
			41265,
			"Salt-Flop",
			"Blasted Lands",
			73.2,
			47.5,
		},
	},
	[26393] = {
		12,
		26393,
		1,
		7,
		"A Swift Message",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			514,
			"Smith Argus",
			"Elwynn Forest",
			41.7,
			65.59999999999999,
		},
	},
	[25766] = {
		406,
		25766,
		1,
		28,
		"Arcane Legacy",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			40899,
			"Arcanist Valdurian",
			"Stonetalon Mountains",
			58.8,
			55.9,
		},
	},
	[25798] = {
		400,
		25798,
		1,
		41,
		"[41] [41] Defend the Drill",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			41190,
			"Crazzle Sprysprocket",
			"Thousand Needles",
			91.40000000000001,
			57.7,
		},
	},
	[25683] = {
		4,
		25683,
		1,
		55,
		"The Dreadmaul Furnace",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			41124,
			"Okrilla",
			"Blasted Lands",
			40.5,
			11.8,
		},
	},
	[24653] = {
		4709,
		24653,
		1,
		35,
		"Echoes of Agamaggan",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			37812,
			"Mahka",
			"Southern Barrens",
			45.2,
			85.40000000000001,
		},
	},
	[28372] = {
		361,
		28372,
		1,
		49,
		"Back to Business",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			48469,
			"Fez Hobnob",
			"Felwood",
			44.2,
			28,
		},
	},
	[28442] = {
		46,
		28442,
		1,
		51,
		"Flame Crest",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48568,
			"Eitrigg",
			"Burning Steppes",
			44.6,
			44.4,
		},
	},
	[26604] = {
		5287,
		26604,
		1,
		32,
		"Protecting Her Royal Highness Poobah",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2634,
			"Princess Poobah",
			"The Cape of Stranglethorn",
			59.4,
			79.09999999999999,
		},
	},
	[9747] = {
		3521,
		9747,
		1,
		62,
		"The Umbrafen Tribe",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			17956,
			"Ikeyen",
			"Zangarmarsh",
			80.40000000000001,
			64.2,
		},
	},
	[10287] = {
		3483,
		10287,
		1,
		62,
		"The Mistress Revealed",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			20159,
			"Magister Aledis",
			"Hellfire Peninsula",
			49,
			51.8,
		},
	},
	[11211] = {
		15,
		11211,
		1,
		39,
		"Help for Mudsprocket",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			6546,
			"Tabetha",
			"Dustwallow Marsh",
			46,
			57.1,
		},
	},
	[10096] = {
		3521,
		10096,
		1,
		62,
		"Saving the Sporeloks",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			17909,
			"Lauranna Thar'well",
			"Zangarmarsh",
			80.40000000000001,
			64.2,
		},
	},
	[24698] = {
		490,
		24698,
		1,
		53,
		"Adventures in Archaeology",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38270,
			"Nolen Tacker",
			"Un'Goro Crater",
			55,
			60.6,
		},
	},
	[26150] = {
		12,
		26150,
		1,
		6,
		"A Visit With Maybell",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			253,
			"William Pestle",
			"Elwynn Forest",
			43.3,
			65.8,
		},
	},
	[28229] = {
		361,
		28229,
		1,
		48,
		"Nature and Nurture",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			48126,
			"Isural Forestsworn",
			"Felwood",
			43.9,
			28.2,
		},
	},
	[26214] = {
		40,
		26214,
		1,
		11,
		"Hot On the Trail: Murlocs",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			42308,
			"Lieutenant Horatio Laine",
			"Westfall",
			60,
			19.2,
		},
	},
	[28261] = {
		361,
		28261,
		1,
		48,
		"Deceivers In Our Midst",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			47923,
			"Feronas Sindweller",
			"Felwood",
			45.5,
			20.1,
		},
	},
	[26278] = {
		33,
		26278,
		1,
		25,
		"The Defense of Grom'gol: Raptor Risk",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			2464,
			"Commander Aggro'gosh",
			"Northern Stranglethorn",
			38.4,
			50.4,
		},
	},
	[28357] = {
		361,
		28357,
		1,
		49,
		"Take it to the Tree",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			48127,
			"Darla Drilldozer",
			"Felwood",
			56.3,
			8.300000000000001,
		},
	},
	[28389] = {
		361,
		28389,
		1,
		49,
		"Report to the Denmother",
		"A",
		2,
		"HUNTER",
		2,
		"DRAENEI",
		{
			48493,
			"Alton Redding",
			"Felwood",
			56.8,
			18.5,
		},
	},
	[28421] = {
		46,
		28421,
		1,
		50,
		"Mud Hunter",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48559,
			"Ariok",
			"Burning Steppes",
			0,
			0,
		},
	},
	[28453] = {
		46,
		28453,
		1,
		52,
		"Locked and Loaded",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48314,
			"Dragon-Lord Neeralak",
			"Burning Steppes",
			70.2,
			47.2,
		},
	},
	[26609] = {
		5287,
		26609,
		1,
		32,
		"The Bloodsail Buccaneers",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2490,
			"First Mate Crazz",
			"The Cape of Stranglethorn",
			42.6,
			72,
		},
	},
	[26726] = {
		44,
		26726,
		1,
		20,
		"Triumphant Return",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			43733,
			"Colonel Troteman",
			"Redridge Mountains",
			60.7,
			36.6,
		},
	},
	[24455] = {
		16,
		24455,
		1,
		16,
		"Rapid Deployment",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36749,
			"Commander Molotov",
			"Azshara",
			60.6,
			50.6,
		},
	},
	[11] = {
		12,
		11,
		1,
		10,
		"Riverpaw Gnoll Bounty",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			963,
			"Deputy Rainer",
			"Elwynn Forest",
			24.3,
			74.5,
		},
	},
	[24519] = {
		4709,
		24519,
		1,
		31,
		"Stalling the Survey",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			37154,
			"Kilrok Gorehammer",
			"Southern Barrens",
			39.6,
			19.9,
		},
	},
	[24551] = {
		4709,
		24551,
		1,
		32,
		"Meet the New Boss",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			3433,
			"Tatternack Steelforge",
			"Southern Barrens",
			41.7,
			46.6,
		},
	},
	[26630] = {
		5287,
		26630,
		1,
		33,
		"Looks Like a Tauren Pirate to Me",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2487,
			"Fleet Master Seahorn",
			"The Cape of Stranglethorn",
			41.1,
			73.2,
		},
	},
	[26662] = {
		5287,
		26662,
		1,
		35,
		"The Brashtide Crew",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			[3] = "The Cape of Stranglethorn",
			[4] = 50.3,
			[5] = 91.5,
		},
	},
	[26694] = {
		44,
		26694,
		1,
		19,
		"The Grand Magus Doane",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			[3] = "Redridge Mountains",
			[4] = 67.59999999999999,
			[5] = 30.5,
		},
	},
	[28773] = {
		12,
		28773,
		1,
		3,
		"Lions for Lambs",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			197,
			"Marshal McBride",
			"Elwynn Forest",
			48.1,
			42,
		},
	},
	[25780] = {
		11,
		25780,
		1,
		21,
		"Assault on Menethil Keep",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			2104,
			"Captain Stoutfist",
			"Wetlands",
			10.5,
			55.8,
		},
	},
	[28837] = {
		618,
		28837,
		1,
		54,
		"Altered Beasts",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			10929,
			"Haleh",
			"Winterspring",
			58,
			63.8,
		},
	},
	[24824] = {
		4709,
		24824,
		1,
		34,
		"The Disturbed Earth",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			37834,
			"Tauna Skychaser",
			"Southern Barrens",
			45.2,
			85.40000000000001,
		},
	},
	[24807] = {
		4709,
		24807,
		1,
		32,
		"Winnoa Pineforest",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			37570,
			"Naralex",
			"Southern Barrens",
			48.2,
			38.6,
		},
	},
	[25488] = {
		400,
		25488,
		1,
		40,
		"[40] [40] Two If By Boat",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			39992,
			"Rendow",
			"Feralas",
			88.40000000000001,
			44.5,
		},
	},
	[26534] = {
		5287,
		26534,
		1,
		31,
		"Let's See What You've Got, Zanzil",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			43097,
			"Mixmaster Jasper",
			"The Cape of Stranglethorn",
			35.2,
			27.6,
		},
	},
	[13904] = {
		490,
		13904,
		3,
		53,
		"Poached, Scrambled, Or Raw?",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			34320,
			"Venomhide Hatchling",
			"Tanaris",
			52.6,
			27.3,
		},
	},
	[9401] = {
		3483,
		9401,
		1,
		62,
		"A Strange Weapon",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			17062,
			"Fel Orc Corpse",
			"Hellfire Peninsula",
			33.6,
			43.5,
		},
	},
	[13511] = {
		148,
		13511,
		1,
		13,
		"One Bitter Wish",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			33055,
			"Alanndarian Nightsong",
			"Darkshore",
			63.8,
			6,
		},
	},
	[13527] = {
		148,
		13527,
		1,
		11,
		"No Accounting for Taste",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			[3] = "Darkshore",
			[4] = 53.2,
			[5] = 19.6,
		},
	},
	[13543] = {
		148,
		13543,
		1,
		15,
		"Three Hammers to Break",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			32987,
			"Corvine Moonrise",
			"Darkshore",
			42.6,
			45.2,
		},
	},
	[24732] = {
		490,
		24732,
		1,
		52,
		"The Scent of Lar'korwi",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			9619,
			"Torwa Pathfinder",
			"Un'Goro Crater",
			71.2,
			76.5,
		},
	},
	[13575] = {
		148,
		13575,
		1,
		15,
		"The Land Is in Their Blood",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			33091,
			"Malfurion Stormrage",
			"Darkshore",
			43.7,
			53.4,
		},
	},
	[13591] = {
		148,
		13591,
		1,
		15,
		"Disturbing Connections",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			[3] = "Darkshore",
			[4] = 72.8,
			[5] = 18.1,
		},
	},
	[27238] = {
		15,
		27238,
		1,
		37,
		"Jaina Must Know",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23569,
			"Renn McGill",
			"Dustwallow Marsh",
			63.8,
			17.1,
		},
	},
	[25191] = {
		4709,
		25191,
		1,
		30,
		"Survey the Destruction",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			38383,
			"Nibb Spindlegear",
			"Southern Barrens",
			39,
			11.4,
		},
	},
	[176] = {
		12,
		176,
		1,
		11,
		"Wanted:  \"Hogger\" [Group]",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Elwynn Forest",
			[4] = 24.5,
			[5] = 74.8,
		},
	},
	[28417] = {
		46,
		28417,
		1,
		50,
		"Done Nothing Wrong",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			47779,
			"Mouton Flamestar",
			"Burning Steppes",
			17,
			51.3,
		},
	},
	[14127] = {
		16,
		14127,
		1,
		10,
		"Return of the Highborne?",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			[3] = "Azshara",
			[4] = 30.6,
			[5] = 72.8,
		},
	},
	[24704] = {
		490,
		24704,
		1,
		54,
		"The Evil Dragons of Un'Goro Crater",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38237,
			"Maximillian of Northshire",
			"Un'Goro Crater",
			30.7,
			51.1,
		},
	},
	[27961] = {
		51,
		27961,
		1,
		47,
		"Out of Place",
		"HA",
		2,
		"DEATHKNIGHTMAGE",
		2,
		"BLOODELFDRAENEI",
		{
			47267,
			"Burrian Coalpart",
			"Searing Gorge",
			0,
			0,
		},
	},
	[850] = {
		17,
		850,
		1,
		14,
		"Kolkar Leaders",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			34841,
			"Telar Highstrider",
			"Northern Barrens",
			38,
			46.6,
		},
	},
	[27462] = {
		139,
		27462,
		1,
		42,
		"To Take the Barracks",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			46138,
			"Argent Centurion",
			"Eastern Plaguelands",
			77.59999999999999,
			79.5,
		},
	},
	[13751] = {
		331,
		13751,
		1,
		22,
		"Tell No One!",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			33726,
			"Splintertree Demolisher",
			"Ashenvale",
			73.40000000000001,
			62.1,
		},
	},
	[25479] = {
		357,
		25479,
		1,
		40,
		"[40] [40] To New Thalanaar",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			40345,
			"Thyssiana",
			"Dustwallow Marsh",
			41.8,
			73.90000000000001,
		},
	},
	[26131] = {
		1,
		26131,
		1,
		10,
		"Reinforcements for Loch Modan",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			1959,
			"Mountaineer Barleybrew",
			"Ironforge",
			41.9,
			52,
		},
	},
	[184] = {
		40,
		184,
		1,
		10,
		"Furlbrow's Deed",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Elwynn Forest",
			[4] = 24.8,
			[5] = 95.2,
		},
	},
	[13815] = {
		331,
		13815,
		1,
		22,
		"Making Stumps",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			33889,
			"Krokk",
			"Ashenvale",
			82.5,
			53.7,
		},
	},
	[25767] = {
		406,
		25767,
		1,
		28,
		"Capturing Memories",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			40900,
			"Neophyte Starcrest",
			"Stonetalon Mountains",
			58.8,
			55.9,
		},
	},
	[28217] = {
		361,
		28217,
		1,
		48,
		"Wanted: The Demon Hunter",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			47843,
			"Huntress Selura",
			"Felwood",
			43.5,
			28.3,
		},
	},
	[9769] = {
		3521,
		9769,
		1,
		62,
		"There's No Explanation for Fashion",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			18016,
			"Magasha",
			"Zangarmarsh",
			84.5,
			54.3,
		},
	},
	[13879] = {
		331,
		13879,
		1,
		23,
		"Thunder Peak",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			34510,
			"Broyk",
			"Ashenvale",
			38.8,
			43.3,
		},
	},
	[13895] = {
		148,
		13895,
		1,
		19,
		"The Slumbering Ancients",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			33072,
			"Onu",
			"Darkshore",
			45.4,
			74.90000000000001,
		},
	},
	[13911] = {
		148,
		13911,
		1,
		18,
		"The Absent-Minded Prospector",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			34343,
			"Prospector Remtravel",
			"Darkshore",
			37.6,
			82.90000000000001,
		},
	},
	[186] = {
		33,
		186,
		1,
		26,
		"Tiger Stalking",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Northern Stranglethorn",
			[4] = 42.6,
			[5] = 27.4,
		},
	},
	[13943] = {
		331,
		13943,
		1,
		23,
		"Breathing Room",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			34359,
			"Captain Goggath",
			"Ashenvale",
			38.1,
			43.8,
		},
	},
	[28102] = {
		361,
		28102,
		1,
		46,
		"Fight the Power",
		"H",
		2,
		"DRUIDWARRIOR",
		2,
		"TROLLTAUREN",
		{
			9116,
			"Eridan Bluewind",
			"Felwood",
			42,
			71.90000000000001,
		},
	},
	[13975] = {
		17,
		13975,
		1,
		13,
		"Crossroads Caravan Delivery",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			34578,
			"Rocco Whipshank",
			"Northern Barrens",
			0,
			0,
		},
	},
	[187] = {
		33,
		187,
		1,
		27,
		"Tiger Prowess",
		"A",
		2,
		"DRUIDWARLOCK",
		2,
		"NIGHTELFHUMAN",
		{
			717,
			"Ajeck Rouack",
			"Northern Stranglethorn",
			44.5,
			22.8,
		},
	},
	[26215] = {
		40,
		26215,
		1,
		11,
		"Meet Two-Shoed Lou",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			42308,
			"Lieutenant Horatio Laine",
			"Westfall",
			60,
			19.3,
		},
	},
	[25703] = {
		4,
		25703,
		1,
		57,
		"Atrocities",
		"AH",
		2,
		"WARLOCKDRUIDWARRIOR",
		2,
		"HUMANTROLLDRAENEI",
		{
			41354,
			"Neptool",
			"Blasted Lands",
			71,
			60,
		},
	},
	[1097] = {
		1519,
		1097,
		1,
		15,
		"Elmore's Task",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			514,
			"Smith Argus",
			"Elwynn Forest",
			41.7,
			65.59999999999999,
		},
	},
	[188] = {
		33,
		188,
		1,
		28,
		"Tiger Mastery",
		"A",
		2,
		"DRUIDWARLOCK",
		2,
		"NIGHTELFHUMAN",
		{
			717,
			"Ajeck Rouack",
			"Northern Stranglethorn",
			44.4,
			22.5,
		},
	},
	[6134] = {
		405,
		6134,
		1,
		39,
		"Ghost-o-plasm Round Up",
		"H",
		2,
		"PALADINMAGE",
		2,
		"BLOODELFTROLL",
		{
			6019,
			"Hornizz Brimbuzzle",
			"Desolace",
			47.9,
			61.7,
		},
	},
	[14311] = {
		405,
		14311,
		1,
		32,
		"Taking Part",
		"HA",
		2,
		"PALADINWARLOCK",
		2,
		"BLOODELFGNOME",
		{
			36060,
			"Botanist Ferrah",
			"Desolace",
			58.6,
			48.7,
		},
	},
	[26695] = {
		5287,
		26695,
		1,
		35,
		"Prepare for Takeoff",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2496,
			"Baron Revilgaz",
			"The Cape of Stranglethorn",
			41.1,
			73.09999999999999,
		},
	},
	[26183] = {
		-304,
		26183,
		3,
		80,
		"The King's Cider",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			42288,
			"Robby Flay",
			"Stormwind City",
			50.6,
			71.8,
		},
	},
	[14135] = {
		16,
		14135,
		1,
		11,
		"Up a Tree",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35111,
			"Runaway Shredder",
			"Azshara",
			29.6,
			75,
		},
	},
	[14423] = {
		16,
		14423,
		1,
		12,
		"Dozercism",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35088,
			"Custer Clubnik",
			"Azshara",
			29.8,
			67,
		},
	},
	[28326] = {
		46,
		28326,
		1,
		51,
		"Placing the Pawns",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			48292,
			"Acride",
			"Burning Steppes",
			82.09999999999999,
			31.6,
		},
	},
	[28358] = {
		361,
		28358,
		1,
		48,
		"Hunting the Damned",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			48349,
			"Hurak Wildhorn",
			"Felwood",
			44,
			28,
		},
	},
	[26343] = {
		33,
		26343,
		1,
		26,
		"Supply and Demand",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			2495,
			"Drizzlik",
			"Northern Stranglethorn",
			43.6,
			23.5,
		},
	},
	[14215] = {
		16,
		14215,
		1,
		12,
		"Memories of the Dead",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35087,
			"Malynea Skyreaver",
			"Azshara",
			29.7,
			66.90000000000001,
		},
	},
	[28454] = {
		46,
		28454,
		1,
		52,
		"Assault on Dreadmaul Rock",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48565,
			"Ariok",
			"Burning Steppes",
			54.6,
			25.2,
		},
	},
	[191] = {
		33,
		191,
		1,
		26,
		"Panther Stalking",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Northern Stranglethorn",
			[4] = 51.8,
			[5] = 23.4,
		},
	},
	[28518] = {
		618,
		28518,
		1,
		51,
		"Legacy of the High Elves",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			48659,
			"Quel'dorei Spirit",
			"Winterspring",
			50.8,
			55,
		},
	},
	[26503] = {
		44,
		26503,
		1,
		15,
		"Still Assessing the Threat",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			464,
			"Watch Captain Parker",
			"Redridge Mountains",
			15.3,
			64.7,
		},
	},
	[26535] = {
		5287,
		26535,
		1,
		32,
		"Recipe for Disaster",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			43097,
			"Mixmaster Jasper",
			"The Cape of Stranglethorn",
			35.2,
			27.6,
		},
	},
	[192] = {
		33,
		192,
		1,
		27,
		"Panther Prowess",
		"A",
		2,
		"DRUIDWARLOCK",
		2,
		"NIGHTELFHUMAN",
		{
			718,
			"Sir S. J. Erlgadin",
			"Northern Stranglethorn",
			43.8,
			22.5,
		},
	},
	[24552] = {
		4709,
		24552,
		1,
		33,
		"Lion's Pride",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			3387,
			"Jorn Skyseer",
			"Southern Barrens",
			41.5,
			47.2,
		},
	},
	[26631] = {
		5287,
		26631,
		1,
		33,
		"Your First Day as a Pirate",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			43504,
			"Yancey Grillsen",
			"The Cape of Stranglethorn",
			43.9,
			56.4,
		},
	},
	[26663] = {
		5287,
		26663,
		1,
		35,
		"Sinking From Within",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			[3] = "The Cape of Stranglethorn",
			[4] = 50.3,
			[5] = 91.5,
		},
	},
	[193] = {
		33,
		193,
		1,
		28,
		"Panther Mastery",
		"A",
		2,
		"DRUIDWARLOCK",
		2,
		"NIGHTELFHUMAN",
		{
			718,
			"Sir S. J. Erlgadin",
			"Northern Stranglethorn",
			43.8,
			22.4,
		},
	},
	[14391] = {
		16,
		14391,
		1,
		19,
		"Turning the Tables",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36436,
			"Spirit of Azuregos",
			"Azshara",
			27.9,
			40.3,
		},
	},
	[14407] = {
		16,
		14407,
		1,
		17,
		"Azshara Blues",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36999,
			"Teemo",
			"Azshara",
			59.5,
			50.8,
		},
	},
	[28838] = {
		618,
		28838,
		1,
		54,
		"The Owlbeasts' Defense",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			10929,
			"Haleh",
			"Winterspring",
			58,
			63.8,
		},
	},
	[194] = {
		33,
		194,
		1,
		25,
		"Raptor Hunting",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			715,
			"Hemet Nesingwary Jr.",
			"Northern Stranglethorn",
			44.1,
			23,
		},
	},
	[28742] = {
		618,
		28742,
		1,
		53,
		"Shy-Rotam",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			[3] = "Winterspring",
			[4] = 47.6,
			[5] = 24.6,
		},
	},
	[14471] = {
		16,
		14471,
		1,
		13,
		"First Degree Mortar",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36746,
			"Xiz \"The Eye\" Salvoblast",
			"Azshara",
			29.2,
			57.8,
		},
	},
	[14487] = {
		16,
		14487,
		1,
		17,
		"Still Beating Heart",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36745,
			"Captain Tork",
			"Azshara",
			34.3,
			45,
		},
	},
	[195] = {
		33,
		195,
		1,
		26,
		"Raptor Stalking",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Northern Stranglethorn",
			[4] = 29.9,
			[5] = 32.5,
		},
	},
	[26983] = {
		796,
		26983,
		1,
		33,
		"[33] [33] Just Close Enough",
		"A",
		2,
		"PALADINMAGE",
		2,
		"DRAENEIGNOME",
		{
			39084,
			"Mizzy Pistonhammer",
			"Southern Barrens",
			49.4,
			67.5,
		},
	},
	[25756] = {
		400,
		25756,
		1,
		41,
		"[41] [41] Get Zherin!",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			41190,
			"Crazzle Sprysprocket",
			"Thousand Needles",
			91.40000000000001,
			57.7,
		},
	},
	[25000] = {
		4709,
		25000,
		1,
		31,
		"Teegan's People",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			38621,
			"Jeffrey Long",
			"Southern Barrens",
			64.90000000000001,
			46.1,
		},
	},
	[25032] = {
		440,
		25032,
		1,
		46,
		"Secrets in the Oasis",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38927,
			"Mazoga",
			"Tanaris",
			42.3,
			23.9,
		},
	},
	[28207] = {
		361,
		28207,
		1,
		47,
		"A Slimy Situation",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			47696,
			"Kelnir Leafsong",
			"Felwood",
			41.3,
			49.9,
		},
	},
	[26488] = {
		-101,
		26488,
		3,
		80,
		"Big Gulp",
		"A",
		2,
		"WARLOCKHUNTERMAGE",
		2,
		"HUMANDRAENEIGNOME",
		{
			5494,
			"Catherine Leland",
			"Stormwind City",
			55,
			69.59999999999999,
		},
	},
	[27175] = {
		28,
		27175,
		1,
		37,
		"The Menders' Stead",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			10840,
			"Argent Officer Pureheart",
			"Western Plaguelands",
			43,
			83.7,
		},
	},
	[197] = {
		33,
		197,
		1,
		28,
		"Raptor Mastery",
		"A",
		2,
		"DRUIDWARLOCK",
		2,
		"NIGHTELFHUMAN",
		{
			715,
			"Hemet Nesingwary Jr.",
			"Northern Stranglethorn",
			44.1,
			23.2,
		},
	},
	[27239] = {
		15,
		27239,
		1,
		37,
		"Survey Alcaz Island",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			4968,
			"Lady Jaina Proudmoore",
			"Dustwallow Marsh",
			66.3,
			49.2,
		},
	},
	[24854] = {
		490,
		24854,
		1,
		51,
		"Finding Stormclaw",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38269,
			"Zen'Aliri",
			"Un'Goro Crater",
			55.7,
			60.6,
		},
	},
	[25256] = {
		14,
		25256,
		1,
		10,
		"Sent for Help",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			39604,
			"Vek'nag",
			"Durotar",
			56.4,
			20.2,
		},
	},
	[28614] = {
		618,
		28614,
		1,
		52,
		"Bearzerker",
		"AH",
		2,
		"HUNTERDRUID",
		2,
		"DRAENEITROLL",
		{
			48722,
			"Burndl",
			"Winterspring",
			65.3,
			46.2,
		},
	},
	[27367] = {
		139,
		27367,
		1,
		40,
		"Gidwin Goldbraids",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			45417,
			"Fiona",
			"Eastern Plaguelands",
			9.1,
			66.40000000000001,
		},
	},
	[14295] = {
		16,
		14295,
		1,
		13,
		"Sisters of the Sea",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35657,
			"Torg Twocrush",
			"Azshara",
			50.7,
			75.2,
		},
	},
	[28472] = {
		618,
		28472,
		1,
		50,
		"Words of the High Chief",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			9298,
			"Donova Snowden",
			"Winterspring",
			25.2,
			58.5,
		},
	},
	[27463] = {
		139,
		27463,
		1,
		42,
		"A Boyhood Dream",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			45431,
			"Gidwin Goldbraids",
			"Eastern Plaguelands",
			74.3,
			53.4,
		},
	},
	[27526] = {
		139,
		27526,
		1,
		45,
		"Gidwin's Fate Revealed",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			45729,
			"Tarenar Sunstrike",
			"Eastern Plaguelands",
			27.6,
			21.3,
		},
	},
	[27527] = {
		139,
		27527,
		1,
		45,
		"Journey's End",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			45730,
			"Gidwin Goldbraids",
			"Eastern Plaguelands",
			28.4,
			26,
		},
	},
	[27156] = {
		28,
		27156,
		1,
		37,
		"It's About Time!",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			45157,
			"Lieutenant Myner",
			"Western Plaguelands",
			43.2,
			16,
		},
	},
	[24689] = {
		490,
		24689,
		1,
		51,
		"Flowing to the North",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38274,
			"Garl Stormclaw",
			"Un'Goro Crater",
			70.59999999999999,
			76.09999999999999,
		},
	},
	[24687] = {
		490,
		24687,
		1,
		51,
		"Bouquets of Death",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38263,
			"Ithis Moonwarden",
			"Un'Goro Crater",
			76.40000000000001,
			48.4,
		},
	},
	[27055] = {
		28,
		27055,
		1,
		39,
		"Students of Krastinov",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			[3] = "Western Plaguelands",
			[4] = 66,
			[5] = 48,
		},
	},
	[25640] = {
		406,
		25640,
		1,
		26,
		"Bombs Away: Windshear Mine!",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			[3] = "Stonetalon Mountains",
			[4] = 74.2,
			[5] = 49.5,
		},
	},
	[25672] = {
		400,
		25672,
		1,
		42,
		"[42] [42] Carcass Collection",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			41060,
			"Ajamon Ghostcaller",
			"Thousand Needles",
			96.8,
			72.40000000000001,
		},
	},
	[112] = {
		12,
		112,
		1,
		7,
		"Collecting Kelp",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			253,
			"William Pestle",
			"Elwynn Forest",
			43.3,
			65.8,
		},
	},
	[27578] = {
		1584,
		27578,
		1,
		58,
		"Morgan's Fruition",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			45890,
			"Marshal Maxwell",
			"Blackrock Depths",
			57.9,
			22.4,
		},
	},
	[25768] = {
		406,
		25768,
		1,
		28,
		"Bombs Away: Mirkfallon Post!",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			40896,
			"Lord Fallowmere",
			"Stonetalon Mountains",
			59.5,
			56.9,
		},
	},
	[25800] = {
		11,
		25800,
		1,
		22,
		"When Life Gives You Crabs",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			41297,
			"Karl Boran",
			"Wetlands",
			11.2,
			57.8,
		},
	},
	[26567] = {
		44,
		26567,
		1,
		17,
		"John J. Keeshan",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			43221,
			"Colonel Troteman",
			"Redridge Mountains",
			28.6,
			40.8,
		},
	},
	[25864] = {
		11,
		25864,
		1,
		23,
		"Dinosaur Crisis",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			41415,
			"Shilah Slabchisel",
			"Wetlands",
			26.9,
			26.1,
		},
	},
	[24695] = {
		490,
		24695,
		1,
		55,
		"Ever Watching From Above",
		"H",
		2,
		"DRUIDMAGE",
		2,
		"TROLL",
		{
			38502,
			"Nablya",
			"Un'Goro Crater",
			83.5,
			45.9,
		},
	},
	[24606] = {
		4709,
		24606,
		1,
		34,
		"Blood of the Barrens",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			[3] = "Southern Barrens",
			[4] = 44.1,
			[5] = 82.5,
		},
	},
	[24435] = {
		16,
		24435,
		1,
		16,
		"Mop Up",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36920,
			"Lieutenant Drex",
			"Azshara",
			41.4,
			53.6,
		},
	},
	[208] = {
		33,
		208,
		1,
		29,
		"Big Game Hunter",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			715,
			"Hemet Nesingwary Jr.",
			"Northern Stranglethorn",
			44,
			23.2,
		},
	},
	[24697] = {
		490,
		24697,
		1,
		52,
		"How to Make Meat Fresh Again",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38270,
			"Nolen Tacker",
			"Un'Goro Crater",
			55.1,
			60.5,
		},
	},
	[26727] = {
		10,
		26727,
		1,
		22,
		"The Embalmer's Revenge",
		"A",
		2,
		"WARLOCKSHAMAN",
		2,
		"HUMANDWARF",
		{
			[3] = "Duskwood",
			[4] = 71.90000000000001,
			[5] = 46.4,
		},
	},
	[14430] = {
		16,
		14430,
		1,
		18,
		"Hacking the Construct",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			[3] = "Azshara",
			[4] = 53,
			[5] = 29,
		},
	},
	[26408] = {
		331,
		26408,
		1,
		20,
		"Ashes in Ashenvale",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			34402,
			"Balren of the Claw",
			"Darkshore",
			45.3,
			75.09999999999999,
		},
	},
	[26152] = {
		12,
		26152,
		1,
		10,
		"Wanted: James Clark",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Elwynn Forest",
			[4] = 74,
			[5] = 72.3,
		},
	},
	[26184] = {
		4,
		26184,
		1,
		58,
		"Wormthorn's Dream",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			42349,
			"Mayor Charlton Connisport",
			"Blasted Lands",
			46.4,
			87.2,
		},
	},
	[25111] = {
		440,
		25111,
		1,
		45,
		"Scavengers Scavenged",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			39178,
			"Driz Plunkbow",
			"Tanaris",
			52.2,
			28,
		},
	},
	[28842] = {
		618,
		28842,
		1,
		55,
		"Umbranse's Deliverance",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			10929,
			"Haleh",
			"Winterspring",
			58,
			63.9,
		},
	},
	[28327] = {
		46,
		28327,
		1,
		52,
		"Locked and Loaded",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			48316,
			"General Thorg'izog",
			"Burning Steppes",
			66.5,
			40.6,
		},
	},
	[28359] = {
		361,
		28359,
		1,
		48,
		"The Core of Kroshius",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			48349,
			"Hurak Wildhorn",
			"Felwood",
			44,
			28,
		},
	},
	[26344] = {
		33,
		26344,
		1,
		27,
		"Some Assembly Required",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			2495,
			"Drizzlik",
			"Northern Stranglethorn",
			43.7,
			23.5,
		},
	},
	[28423] = {
		46,
		28423,
		1,
		50,
		"Warlocks Have the Neatest Stuff",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			14437,
			"Gorzeeki Wildeyes",
			"Burning Steppes",
			0,
			0,
		},
	},
	[28455] = {
		46,
		28455,
		1,
		52,
		"Glory Amidst Chaos",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48569,
			"Eitrigg",
			"Burning Steppes",
			54.6,
			24.5,
		},
	},
	[12902] = {
		66,
		12902,
		1,
		75,
		"In Search Of Answers",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			29687,
			"Crusader Lord Lantinga",
			"Zul'Drak",
			32.1,
			75.7,
		},
	},
	[28519] = {
		618,
		28519,
		1,
		51,
		"Pain of the Blood Elves",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			48660,
			"Sin'dorei Spirit",
			"Winterspring",
			50.7,
			55,
		},
	},
	[26504] = {
		44,
		26504,
		1,
		15,
		"Wanted: Redridge Gnolls",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Redridge Mountains",
			[4] = 16.1,
			[5] = 64.59999999999999,
		},
	},
	[28615] = {
		618,
		28615,
		1,
		52,
		"Turning the Earth",
		"HA",
		2,
		"PRIESTHUNTERDRUID",
		2,
		"SCOURGEDRAENEITROLL",
		{
			48723,
			"Tanrir",
			"Winterspring",
			65.3,
			46.1,
		},
	},
	[26568] = {
		95,
		26568,
		1,
		17,
		"This Ain't My War",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			43184,
			"John J. Keeshan",
			"Redridge Mountains",
			26.3,
			40.1,
		},
	},
	[26600] = {
		5287,
		26600,
		1,
		33,
		"A Giant's Feast",
		"HA",
		2,
		"PRIESTHUNTER",
		2,
		"SCOURGEDRAENEI",
		{
			2500,
			"Captain Hecklebury Smotts",
			"The Cape of Stranglethorn",
			40.4,
			67.8,
		},
	},
	[14377] = {
		16,
		14377,
		1,
		13,
		"Befriending Giants",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36077,
			"Assistant Greely",
			"Azshara",
			50.4,
			74.40000000000001,
		},
	},
	[26664] = {
		5287,
		26664,
		1,
		35,
		"Making Mutiny",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			[3] = "The Cape of Stranglethorn",
			[4] = 50.3,
			[5] = 91.5,
		},
	},
	[26696] = {
		15,
		26696,
		1,
		35,
		"The Call of Kalimdor",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			48797,
			"Gim'hila",
			"The Cape of Stranglethorn",
			39.4,
			68.3,
		},
	},
	[26728] = {
		10,
		26728,
		1,
		20,
		"Hero's Call: Duskwood!",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			900,
			"Bailiff Conacher",
			"Redridge Mountains",
			28.7,
			40.9,
		},
	},
	[26760] = {
		10,
		26760,
		1,
		24,
		"Cry For The Moon",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Duskwood",
			[4] = 18.4,
			[5] = 57.6,
		},
	},
	[28839] = {
		618,
		28839,
		1,
		54,
		"Magic Prehistoric",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			7452,
			"Crazed Owlbeast",
			"Winterspring",
			57,
			75.8,
		},
	},
	[26667] = {
		10,
		26667,
		1,
		23,
		"The Stolen Letters",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			267,
			"Clerk Daltry",
			"Duskwood",
			72.59999999999999,
			46.9,
		},
	},
	[26635] = {
		5287,
		26635,
		1,
		33,
		"Cannonball Swim",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2545,
			"\"Pretty Boy\" Duncan",
			"The Cape of Stranglethorn",
			44.6,
			93.40000000000001,
		},
	},
	[26888] = {
		719,
		26888,
		1,
		27,
		"Nightmare of the Deeps [Dungeon]",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			12736,
			"Je'neu Sancrea",
			"Blackfathom Deeps",
			0,
			0,
		},
	},
	[9370] = {
		3483,
		9370,
		1,
		62,
		"The Cleansing Must Be Stopped",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16791,
			"Ryathen the Somber",
			"Hellfire Peninsula",
			27,
			59.6,
		},
	},
	[24905] = {
		440,
		24905,
		1,
		47,
		"Returning a Favor",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38706,
			"Zeke Bootscuff",
			"Tanaris",
			55.6,
			60.8,
		},
	},
	[25534] = {
		440,
		25534,
		1,
		46,
		"Going Off-Task",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38703,
			"Megs Dreadshredder",
			"Tanaris",
			71.90000000000001,
			45.4,
		},
	},
	[13512] = {
		148,
		13512,
		1,
		14,
		"Strategic Strikes",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			32963,
			"Lieutenant Morra Starbreeze",
			"Darkshore",
			58.9,
			19.5,
		},
	},
	[13528] = {
		148,
		13528,
		1,
		11,
		"Buzzbox 723",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			32977,
			"Wizbang Cranktoggle",
			"Darkshore",
			51.2,
			19.6,
		},
	},
	[13544] = {
		148,
		13544,
		1,
		19,
		"The Bear's Blessing",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			32967,
			"Elder Brolg",
			"Darkshore",
			43.5,
			80.90000000000001,
		},
	},
	[13560] = {
		148,
		13560,
		1,
		13,
		"An Ocean Not So Deep",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			32979,
			"Gorbold Steelhand",
			"Darkshore",
			51,
			19.2,
		},
	},
	[13576] = {
		148,
		13576,
		1,
		15,
		"Mutual Aid",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			33117,
			"Elder Brownpaw",
			"Darkshore",
			41,
			56.5,
		},
	},
	[28618] = {
		618,
		28618,
		1,
		52,
		"Boulder Delivery",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			48965,
			"Deez Rocksnitch",
			"Winterspring",
			59.8,
			49.7,
		},
	},
	[9788] = {
		3521,
		9788,
		1,
		62,
		"A Damp, Dark Place",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			17956,
			"Ikeyen",
			"Zangarmarsh",
			80.40000000000001,
			64.2,
		},
	},
	[25193] = {
		14,
		25193,
		1,
		8,
		"Lost But Not Forgotten",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			3193,
			"Misha Tor'kren",
			"Durotar",
			43.4,
			30.7,
		},
	},
	[13640] = {
		331,
		13640,
		1,
		21,
		"Management Material",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			33421,
			"Gorka",
			"Ashenvale",
			72.90000000000001,
			80.40000000000001,
		},
	},
	[25257] = {
		14,
		25257,
		1,
		10,
		"Ghislania",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			39590,
			"Spiketooth",
			"Durotar",
			0,
			0,
		},
	},
	[26371] = {
		40,
		26371,
		1,
		15,
		"The Legend of Captain Grayson",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			878,
			"Scout Galiaan",
			"Westfall",
			56.4,
			47.4,
		},
	},
	[27368] = {
		139,
		27368,
		1,
		40,
		"Just Encased",
		"A",
		2,
		"ROGUEMAGE",
		2,
		"NIGHTELFGNOME",
		{
			45428,
			"Gidwin Goldbraids",
			"Eastern Plaguelands",
			4.1,
			36.2,
		},
	},
	[845] = {
		17,
		845,
		1,
		13,
		"The Zhevra",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			3338,
			"Sergra Darkthorn",
			"Northern Barrens",
			0,
			0,
		},
	},
	[27432] = {
		139,
		27432,
		1,
		41,
		"Zaeldarr the Outcast",
		"A",
		2,
		"ROGUEMAGE",
		2,
		"NIGHTELFGNOME",
		{
			45500,
			"Urk Gagbaz",
			"Eastern Plaguelands",
			34.9,
			68.2,
		},
	},
	[27464] = {
		139,
		27464,
		1,
		42,
		"Argent Call: The Trial of the Crypt",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			11034,
			"Lord Maxwell Tyrosus",
			"Eastern Plaguelands",
			75.8,
			52,
		},
	},
	[9770] = {
		3521,
		9770,
		1,
		62,
		"Menacing Marshfangs",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			18012,
			"Reavij",
			"Zangarmarsh",
			85,
			54.1,
		},
	},
	[27528] = {
		139,
		27528,
		1,
		44,
		"Scourged Mass",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			45831,
			"Crusader Kevin Frost",
			"Eastern Plaguelands",
			27.6,
			21,
		},
	},
	[13896] = {
		148,
		13896,
		1,
		19,
		"Unearthed Knowledge",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			34404,
			"Larien",
			"Darkshore",
			45.3,
			75.09999999999999,
		},
	},
	[13912] = {
		148,
		13912,
		1,
		18,
		"Swamped Secrets",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			34342,
			"Jr. Archaeologist Ferd",
			"Darkshore",
			37.7,
			83,
		},
	},
	[14201] = {
		16,
		14201,
		1,
		12,
		"A Thousand Stories in the Sand",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35087,
			"Malynea Skyreaver",
			"Azshara",
			29.6,
			66.90000000000001,
		},
	},
	[25609] = {
		400,
		25609,
		1,
		41,
		"[41] [41] Sunken Treasure",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			40885,
			"Wizzle Brassbolts",
			"Thousand Needles",
			91.59999999999999,
			78.59999999999999,
		},
	},
	[13848] = {
		331,
		13848,
		1,
		22,
		"Bad News Bear-er",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			33837,
			"Kadrak",
			"Ashenvale",
			73.59999999999999,
			62.1,
		},
	},
	[25673] = {
		406,
		25673,
		1,
		27,
		"Just Ask Alice",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			40908,
			"Alice",
			"Stonetalon Mountains",
			58.5,
			55.3,
		},
	},
	[13880] = {
		331,
		13880,
		1,
		23,
		"Hot Lava",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			34290,
			"Core",
			"Ashenvale",
			52.2,
			56.6,
		},
	},
	[9802] = {
		3521,
		9802,
		1,
		63,
		"Plants of Zangarmarsh",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			17909,
			"Lauranna Thar'well",
			"Zangarmarsh",
			80.40000000000001,
			64.2,
		},
	},
	[25769] = {
		406,
		25769,
		1,
		28,
		"Fallowmere Beckons",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			40899,
			"Arcanist Valdurian",
			"Stonetalon Mountains",
			58.7,
			55.9,
		},
	},
	[25801] = {
		11,
		25801,
		1,
		22,
		"Claws from the Deep",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			41297,
			"Karl Boran",
			"Wetlands",
			11.1,
			57.8,
		},
	},
	[13944] = {
		331,
		13944,
		1,
		23,
		"Small Hands, Short Fuse",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			34395,
			"Tweedle",
			"Ashenvale",
			38,
			43.8,
		},
	},
	[25865] = {
		11,
		25865,
		1,
		23,
		"The Mosshide Job",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			41415,
			"Shilah Slabchisel",
			"Wetlands",
			27,
			26.1,
		},
	},
	[9898] = {
		3521,
		9898,
		1,
		62,
		"Nothin' Says Lovin' Like a Big Stinger",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			18012,
			"Reavij",
			"Zangarmarsh",
			85,
			54,
		},
	},
	[13992] = {
		17,
		13992,
		1,
		13,
		"A Little Diversion",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			34613,
			"Ta'jari",
			"Northern Barrens",
			0,
			0,
		},
	},
	[14226] = {
		16,
		14226,
		1,
		18,
		"Trouble Under Foot",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35187,
			"Image of Archmage Xylem",
			"Azshara",
			47.3,
			21,
		},
	},
	[24566] = {
		4709,
		24566,
		1,
		31,
		"Sowing a Solution",
		"AH",
		2,
		"DRUIDMAGEWARLOCK",
		2,
		"NIGHTELFGNOMESCOURGE",
		{
			38314,
			"Muyoh",
			"Southern Barrens",
			50.3,
			40.6,
		},
	},
	[26781] = {
		33,
		26781,
		1,
		28,
		"The Mind's Eye",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			44019,
			"Livingston Marshal",
			"Northern Stranglethorn",
			53.2,
			66.8,
		},
	},
	[26749] = {
		33,
		26749,
		1,
		27,
		"Priestess Thaalia",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			43884,
			"Osborn Obnoticus",
			"Northern Stranglethorn",
			47.2,
			10.6,
		},
	},
	[27976] = {
		51,
		27976,
		1,
		48,
		"Curse These Fat Fingers",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			14627,
			"Hansel Heavyhands",
			"Searing Gorge",
			0,
			0,
		},
	},
	[26665] = {
		5287,
		26665,
		1,
		35,
		"Call of Booty",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			43661,
			"Wailing Mary Smitts",
			"The Cape of Stranglethorn",
			44.8,
			93.8,
		},
	},
	[26153] = {
		-304,
		26153,
		3,
		80,
		"Penny's Pumpkin Pancakes",
		"A",
		2,
		"HUNTERMAGE",
		2,
		"DRAENEIGNOME",
		{
			42288,
			"Robby Flay",
			"Stormwind City",
			50.7,
			71.5,
		},
	},
	[26185] = {
		4,
		26185,
		1,
		58,
		"Advice from the Cenarion Circle",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			42349,
			"Mayor Charlton Connisport",
			"Blasted Lands",
			46.3,
			87.09999999999999,
		},
	},
	[28264] = {
		361,
		28264,
		1,
		48,
		"Navarax's Gambit",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			[3] = "Felwood",
			[4] = 45.5,
			[5] = 20.1,
		},
	},
	[10294] = {
		3483,
		10294,
		1,
		61,
		"Void Ridge",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			19683,
			"Ogath the Mad",
			"Hellfire Peninsula",
			61.8,
			81.5,
		},
	},
	[14360] = {
		405,
		14360,
		1,
		30,
		"Nothing a Couple of Melons Won't Fix",
		"H",
		2,
		"PALADIN",
		2,
		"BLOODELF",
		{
			[3] = "Desolace",
			[4] = 77.3,
			[5] = 18.3,
		},
	},
	[28360] = {
		361,
		28360,
		1,
		48,
		"Running their Course",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			48459,
			"Tender Puregrove",
			"Felwood",
			43.3,
			30.4,
		},
	},
	[26345] = {
		33,
		26345,
		1,
		28,
		"Excelsior",
		"A",
		2,
		"DRUIDWARLOCK",
		2,
		"NIGHTELFHUMAN",
		{
			2495,
			"Drizzlik",
			"Northern Stranglethorn",
			43.6,
			23.4,
		},
	},
	[14216] = {
		16,
		14216,
		1,
		12,
		"Mystery of the Sarcen Stone",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			[3] = "Azshara",
			[4] = 37.5,
			[5] = 74.2,
		},
	},
	[28456] = {
		46,
		28456,
		1,
		52,
		"The Spoils of War",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48569,
			"Eitrigg",
			"Burning Steppes",
			54.6,
			24.4,
		},
	},
	[26793] = {
		10,
		26793,
		1,
		25,
		"The Weathered Grave",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Duskwood",
			[4] = 17.7,
			[5] = 29.1,
		},
	},
	[14264] = {
		405,
		14264,
		1,
		32,
		"Wetter Than Wet",
		"HA",
		2,
		"PALADINWARLOCK",
		2,
		"BLOODELFGNOME",
		{
			35827,
			"Valishj",
			"Desolace",
			31.1,
			30.8,
		},
	},
	[24458] = {
		16,
		24458,
		1,
		15,
		"A Hello to Arms",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36379,
			"Hobart Grapplehammer",
			"Azshara",
			50.4,
			74.40000000000001,
		},
	},
	[14296] = {
		16,
		14296,
		1,
		18,
		"Watch Your Step",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36334,
			"Image of Archmage Xylem",
			"Azshara",
			55.7,
			14.7,
		},
	},
	[14312] = {
		405,
		14312,
		1,
		32,
		"An Introduction Is In Order",
		"H",
		2,
		"PALADIN",
		2,
		"BLOODELF",
		{
			36052,
			"Garren Darkwind",
			"Desolace",
			58.4,
			49.8,
		},
	},
	[26601] = {
		5287,
		26601,
		1,
		33,
		"Mok'rash the Cleaver",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2500,
			"Captain Hecklebury Smotts",
			"The Cape of Stranglethorn",
			40.4,
			67.8,
		},
	},
	[26633] = {
		5287,
		26633,
		1,
		33,
		"Swabbing Duty",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2548,
			"Captain Keelhaul",
			"The Cape of Stranglethorn",
			44.4,
			91.59999999999999,
		},
	},
	[24618] = {
		4709,
		24618,
		1,
		34,
		"Claim the Battle Scar",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			37837,
			"Warlord Bloodhilt",
			"Southern Barrens",
			41.6,
			69.8,
		},
	},
	[26697] = {
		5287,
		26697,
		1,
		35,
		"The Final Voyage of the Brashtide",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2496,
			"Baron Revilgaz",
			"The Cape of Stranglethorn",
			41.2,
			73.09999999999999,
		},
	},
	[26729] = {
		33,
		26729,
		1,
		26,
		"Water Elementals",
		"A",
		2,
		"DRUIDWARLOCK",
		2,
		"NIGHTELFHUMAN",
		{
			43885,
			"Emerine Junis",
			"Northern Stranglethorn",
			47.6,
			10.4,
		},
	},
	[14408] = {
		16,
		14408,
		1,
		14,
		"Nine's Plan",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36500,
			"Subject Nine",
			"Azshara",
			42.2,
			76,
		},
	},
	[14424] = {
		16,
		14424,
		1,
		13,
		"Need More Science",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35088,
			"Custer Clubnik",
			"Azshara",
			29.7,
			67.2,
		},
	},
	[27616] = {
		139,
		27616,
		1,
		42,
		"The Huntsman",
		"A",
		2,
		"ROGUEPALADIN",
		2,
		"NIGHTELFHUMAN",
		{
			16112,
			"Crusade Commander Korfax",
			"Eastern Plaguelands",
			75.5,
			76.2,
		},
	},
	[28782] = {
		618,
		28782,
		1,
		53,
		"A Bird of Legend",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			[3] = "Winterspring",
			[4] = 52.8,
			[5] = 40.6,
		},
	},
	[14472] = {
		16,
		14472,
		1,
		13,
		"In The Face!",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36744,
			"Glix Grindlock",
			"Azshara",
			29.3,
			57.7,
		},
	},
	[25931] = {
		406,
		25931,
		1,
		30,
		"[30] [30] Brood of Seldarria",
		"A",
		2,
		"PALADINDRUIDMAGE",
		2,
		"DRAENEINIGHTELFGNOME",
		{
			[3] = "Stonetalon Mountains",
			[4] = 29.8,
			[5] = 70,
		},
	},
	[26953] = {
		28,
		26953,
		1,
		37,
		"Zen'Kiki, the Druid",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			44456,
			"Adrine Towhide",
			"Western Plaguelands",
			48.9,
			54.8,
		},
	},
	[24938] = {
		4709,
		24938,
		1,
		30,
		"The Guns of Northwatch",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38619,
			"Admiral Aubrey",
			"Southern Barrens",
			69.2,
			49.1,
		},
	},
	[27017] = {
		28,
		27017,
		1,
		38,
		"Memories from a Lost Past",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			44458,
			"Del Gahrron",
			"Western Plaguelands",
			50.6,
			52.5,
		},
	},
	[25002] = {
		4709,
		25002,
		1,
		31,
		"Scavenged",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38878,
			"Mangled Body",
			"Southern Barrens",
			61.8,
			42.1,
		},
	},
	[25034] = {
		4709,
		25034,
		1,
		31,
		"To the Front!",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38871,
			"Corporal Teegan",
			"Southern Barrens",
			56.1,
			42.7,
		},
	},
	[28840] = {
		618,
		28840,
		1,
		54,
		"Winterwater",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			[3] = "Winterspring",
			[4] = 64.90000000000001,
			[5] = 74.7,
		},
	},
	[25867] = {
		11,
		25867,
		1,
		23,
		"Gnoll Escape",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			41415,
			"Shilah Slabchisel",
			"Wetlands",
			26.9,
			26.1,
		},
	},
	[25001] = {
		440,
		25001,
		1,
		48,
		"Sandscraper",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38849,
			"Megs Dreadshredder",
			"Tanaris",
			44.6,
			52.6,
		},
	},
	[10442] = {
		3483,
		10442,
		1,
		61,
		"Helping the Cenarion Post",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16790,
			"Falconer Drenna Riverwind",
			"Hellfire Peninsula",
			27.7,
			60.4,
		},
	},
	[25194] = {
		14,
		25194,
		1,
		8,
		"Unbidden Visitors",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			39324,
			"Zen'Taji",
			"Durotar",
			35.9,
			41.4,
		},
	},
	[26554] = {
		5287,
		26554,
		1,
		32,
		"Plunging Into Zul'Gurub",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			[3] = "Northern Stranglethorn",
			[4] = 78.09999999999999,
			[5] = 44.1,
		},
	},
	[25258] = {
		14,
		25258,
		1,
		10,
		"Griswold Hanniston",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			39590,
			"Spiketooth",
			"Durotar",
			0,
			0,
		},
	},
	[25739] = {
		406,
		25739,
		1,
		27,
		"If the Horde Don't Get You...",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			40897,
			"Northwatch Captain Kosak",
			"Stonetalon Mountains",
			59.5,
			57,
		},
	},
	[27369] = {
		139,
		27369,
		1,
		40,
		"Greasing the Wheel",
		"A",
		2,
		"ROGUEMAGE",
		2,
		"NIGHTELFGNOME",
		{
			45431,
			"Gidwin Goldbraids",
			"Eastern Plaguelands",
			4.2,
			36.1,
		},
	},
	[25707] = {
		4,
		25707,
		1,
		57,
		"The Future of the Rockpool",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			41402,
			"Abandoned Bloodwash Crate",
			"Blasted Lands",
			61.5,
			63,
		},
	},
	[25675] = {
		4,
		25675,
		1,
		55,
		"Ogre Combat",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			41125,
			"Master Aitokk",
			"Blasted Lands",
			42.6,
			13.9,
		},
	},
	[27465] = {
		139,
		27465,
		1,
		42,
		"Argent Call: The Noxious Glade",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			11034,
			"Lord Maxwell Tyrosus",
			"Eastern Plaguelands",
			75.8,
			52,
		},
	},
	[26765] = {
		33,
		26765,
		1,
		28,
		"Return to Corporal Kaleb",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			773,
			"Krazek",
			"Northern Stranglethorn",
			43.7,
			23,
		},
	},
	[27529] = {
		139,
		27529,
		1,
		44,
		"Defenders of Darrowshire",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			45831,
			"Crusader Kevin Frost",
			"Eastern Plaguelands",
			27.6,
			21,
		},
	},
	[14184] = {
		405,
		14184,
		1,
		30,
		"My Time Has Passed",
		"H",
		2,
		"PALADIN",
		2,
		"BLOODELF",
		{
			35286,
			"Furien",
			"Desolace",
			54.7,
			8.800000000000001,
		},
	},
	[13865] = {
		331,
		13865,
		1,
		22,
		"Wet Work",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			33889,
			"Krokk",
			"Ashenvale",
			82.5,
			53.7,
		},
	},
	[28452] = {
		46,
		28452,
		1,
		51,
		"A Delivery for Xi'lun",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48569,
			"Eitrigg",
			"Burning Steppes",
			0,
			0,
		},
	},
	[26505] = {
		44,
		26505,
		1,
		16,
		"Parker's Report",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			464,
			"Watch Captain Parker",
			"Redridge Mountains",
			15.3,
			64.59999999999999,
		},
	},
	[25642] = {
		406,
		25642,
		1,
		26,
		"Don't Look Them in the Eyes",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			40879,
			"Boog the \"Gear Whisperer\"",
			"Stonetalon Mountains",
			72.5,
			61.5,
		},
	},
	[25674] = {
		4,
		25674,
		1,
		55,
		"Futile Pride",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			41124,
			"Okrilla",
			"Blasted Lands",
			40.5,
			11.8,
		},
	},
	[12857] = {
		66,
		12857,
		1,
		75,
		"Wanted: Ragemane's Flipper [Group]",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			29687,
			"Crusader Lord Lantinga",
			"Zul'Drak",
			32.2,
			75.7,
		},
	},
	[27960] = {
		51,
		27960,
		1,
		47,
		"The Fewer, the Better",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			47267,
			"Burrian Coalpart",
			"Searing Gorge",
			68.5,
			53.5,
		},
	},
	[24866] = {
		490,
		24866,
		1,
		51,
		"An Abandoned Research Camp",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			[3] = "Un'Goro Crater",
			[4] = 38.6,
			[5] = 66.09999999999999,
		},
	},
	[25802] = {
		11,
		25802,
		1,
		22,
		"Reclaiming Goods",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			41297,
			"Karl Boran",
			"Wetlands",
			11.1,
			57.8,
		},
	},
	[25834] = {
		406,
		25834,
		1,
		29,
		"Death by Proxy",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			41229,
			"Force Commander Valen",
			"Stonetalon Mountains",
			71.09999999999999,
			79.7,
		},
	},
	[25866] = {
		11,
		25866,
		1,
		23,
		"Dark Iron Trappers",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			41415,
			"Shilah Slabchisel",
			"Wetlands",
			26.9,
			26.1,
		},
	},
	[25930] = {
		406,
		25930,
		1,
		30,
		"[30] [30] Ascending the Vale",
		"A",
		2,
		"PALADINDRUIDMAGE",
		2,
		"DRAENEINIGHTELFGNOME",
		{
			41487,
			"Hierophant Malyk",
			"Stonetalon Mountains",
			33.1,
			59.6,
		},
	},
	[27977] = {
		51,
		27977,
		1,
		48,
		"Recon Essentials",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			14626,
			"Taskmaster Scrange",
			"Searing Gorge",
			0,
			0,
		},
	},
	[26237] = {
		40,
		26237,
		1,
		12,
		"Times are Tough",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			233,
			"Farmer Saldean",
			"Westfall",
			56,
			31.3,
		},
	},
	[14232] = {
		405,
		14232,
		1,
		31,
		"Ears Are Burning",
		"H",
		2,
		"PALADIN",
		2,
		"BLOODELF",
		{
			[3] = "Desolace",
			[4] = 53.2,
			[5] = 33.2,
		},
	},
	[26026] = {
		406,
		26026,
		1,
		27,
		"Dream of a Better Tomorrow",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			40907,
			"Clarissa",
			"Stonetalon Mountains",
			66.09999999999999,
			64.2,
		},
	},
	[26058] = {
		406,
		26058,
		1,
		27,
		"In Defense of Krom'gar Fortress",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			40902,
			"Chief Blastgineer Bombgutz",
			"Stonetalon Mountains",
			66.2,
			63,
		},
	},
	[903] = {
		17,
		903,
		1,
		13,
		"Hunting the Huntress",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			3338,
			"Sergra Darkthorn",
			"Northern Barrens",
			0,
			0,
		},
	},
	[25706] = {
		4,
		25706,
		1,
		57,
		"Neptool's Revenge",
		"AH",
		2,
		"WARLOCKDRUIDWARRIOR",
		2,
		"HUMANTROLLDRAENEI",
		{
			41354,
			"Neptool",
			"Blasted Lands",
			71,
			60,
		},
	},
	[26493] = {
		5287,
		26493,
		1,
		30,
		"There's Somebody Out There Who Wants It",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			43095,
			"Sassy Hardwrench",
			"The Cape of Stranglethorn",
			34.8,
			29.6,
		},
	},
	[26186] = {
		4,
		26186,
		1,
		58,
		"Demoniac Vessel",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			42352,
			"Cenarion Observer Shayana",
			"Blasted Lands",
			44.9,
			86.09999999999999,
		},
	},
	[28425] = {
		46,
		28425,
		1,
		50,
		"Return to Ariok",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			14437,
			"Gorzeeki Wildeyes",
			"Burning Steppes",
			8.300000000000001,
			35.9,
		},
	},
	[27242] = {
		15,
		27242,
		1,
		37,
		"Raptor Captor",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23723,
			"Sergeant Lukas",
			"Dustwallow Marsh",
			46.7,
			23.1,
		},
	},
	[25163] = {
		4709,
		25163,
		1,
		34,
		"Who Did This?",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			39220,
			"Wounded Bael'dun Officer",
			"Southern Barrens",
			49.6,
			87.09999999999999,
		},
	},
	[28361] = {
		361,
		28361,
		1,
		48,
		"Squirrely Clean",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			48459,
			"Tender Puregrove",
			"Felwood",
			43.3,
			30.4,
		},
	},
	[24619] = {
		4709,
		24619,
		1,
		34,
		"Parts-is-Parts",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			37908,
			"Calder Gray",
			"Southern Barrens",
			42.6,
			70.2,
		},
	},
	[26378] = {
		40,
		26378,
		1,
		10,
		"Hero's Call: Westfall!",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			240,
			"Marshal Dughan",
			"Elwynn Forest",
			42.1,
			65.90000000000001,
		},
	},
	[26698] = {
		5287,
		26698,
		1,
		35,
		"Seeking Seahorn",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2496,
			"Baron Revilgaz",
			"The Cape of Stranglethorn",
			41.1,
			73.09999999999999,
		},
	},
	[239] = {
		12,
		239,
		1,
		10,
		"Westbrook Garrison Needs Help!",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			240,
			"Marshal Dughan",
			"Elwynn Forest",
			42.1,
			65.8,
		},
	},
	[26730] = {
		33,
		26730,
		1,
		26,
		"You Can Take the Murloc Out of the Ocean...",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			43885,
			"Emerine Junis",
			"Northern Stranglethorn",
			20.2,
			40,
		},
	},
	[26506] = {
		44,
		26506,
		1,
		16,
		"Franks and Beans",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			379,
			"Darcy Parker",
			"Redridge Mountains",
			15.7,
			65.3,
		},
	},
	[28841] = {
		618,
		28841,
		1,
		55,
		"The Arcane Storm Within",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			10929,
			"Haleh",
			"Winterspring",
			58,
			63.9,
		},
	},
	[26570] = {
		44,
		26570,
		1,
		17,
		"Render's Army",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			382,
			"Marshal Marris",
			"Redridge Mountains",
			29.7,
			44.5,
		},
	},
	[26602] = {
		5287,
		26602,
		1,
		33,
		"A Dish Best Served Huge",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2500,
			"Captain Hecklebury Smotts",
			"The Cape of Stranglethorn",
			40.3,
			67.90000000000001,
		},
	},
	[26634] = {
		5287,
		26634,
		1,
		33,
		"The Bane of Many A Pirate",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2549,
			"Garr Salthoof",
			"The Cape of Stranglethorn",
			44.4,
			92.09999999999999,
		},
	},
	[26666] = {
		10,
		26666,
		1,
		23,
		"The Legend of Stalvan",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			43453,
			"Tobias Mistmantle",
			"Duskwood",
			79,
			44.2,
		},
	},
	[28745] = {
		618,
		28745,
		1,
		53,
		"Screechy Keen",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			[3] = "Winterspring",
			[4] = 51.7,
			[5] = 32.7,
		},
	},
	[9275] = {
		3433,
		9275,
		1,
		19,
		"A Little Dash of Seasoning",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			16464,
			"Apothecary Venustus",
			"Ghostlands",
			72.7,
			31.6,
		},
	},
	[24715] = {
		490,
		24715,
		1,
		52,
		"Repairing A-Me 01",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			9623,
			"A-Me 01",
			"Un'Goro Crater",
			63.7,
			19.8,
		},
	},
	[26794] = {
		10,
		26794,
		1,
		25,
		"Morgan Ladimore",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			268,
			"Sirra Von'Indi",
			"Duskwood",
			72.59999999999999,
			47.6,
		},
	},
	[26708] = {
		44,
		26708,
		1,
		20,
		"AHHHHHHHHHHHH! AHHHHHHHHH!!!",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			43733,
			"Colonel Troteman",
			"Redridge Mountains",
			77.2,
			65.90000000000001,
		},
	},
	[28424] = {
		46,
		28424,
		1,
		50,
		"Shadow Boxing",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			14437,
			"Gorzeeki Wildeyes",
			"Burning Steppes",
			8.4,
			35.7,
		},
	},
	[26890] = {
		331,
		26890,
		1,
		22,
		"The Essence of Aku'Mai",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			34303,
			"Dagrun Ragehammer",
			"Ashenvale",
			11.6,
			35.5,
		},
	},
	[26954] = {
		28,
		26954,
		1,
		37,
		"A Different Approach",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			44456,
			"Adrine Towhide",
			"Western Plaguelands",
			48.9,
			54.9,
		},
	},
	[9387] = {
		3483,
		9387,
		1,
		63,
		"Source of the Corruption",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16794,
			"Apothecary Azethen",
			"Hellfire Peninsula",
			26.8,
			59.7,
		},
	},
	[24939] = {
		4709,
		24939,
		1,
		30,
		"Run Out the Guns",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			3454,
			"Cannoneer Smythe",
			"Southern Barrens",
			68.59999999999999,
			44.5,
		},
	},
	[13513] = {
		148,
		13513,
		1,
		14,
		"On the Brink",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			32966,
			"Balthule Shadowstrike",
			"Darkshore",
			58.9,
			19.5,
		},
	},
	[13529] = {
		148,
		13529,
		1,
		11,
		"The Corruption's Source",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			32978,
			"Tharnariun Treetender",
			"Darkshore",
			56.8,
			30.1,
		},
	},
	[13545] = {
		148,
		13545,
		1,
		19,
		"Cleansing the Afflicted",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			32967,
			"Elder Brolg",
			"Darkshore",
			43.5,
			81,
		},
	},
	[13561] = {
		148,
		13561,
		1,
		11,
		"Solace for the Highborne",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			33177,
			"Arya Autumnlight",
			"Darkshore",
			46.8,
			33.3,
		},
	},
	[13577] = {
		148,
		13577,
		1,
		16,
		"The Last Wildkin",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			33091,
			"Malfurion Stormrage",
			"Darkshore",
			43.7,
			53.4,
		},
	},
	[14324] = {
		16,
		14324,
		1,
		17,
		"Full of Hot Water",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36131,
			"Vile Splash",
			"Azshara",
			85,
			42.1,
		},
	},
	[27210] = {
		15,
		27210,
		1,
		36,
		"Traitors Among Us",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23566,
			"Calia Hastings",
			"Dustwallow Marsh",
			68.3,
			51.1,
		},
	},
	[25195] = {
		14,
		25195,
		1,
		9,
		"That's the End of That Raptor",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			39324,
			"Zen'Taji",
			"Durotar",
			35.8,
			41.4,
		},
	},
	[26552] = {
		5287,
		26552,
		1,
		32,
		"Through the Troll Hole",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			[3] = "The Cape of Stranglethorn",
			[4] = 61.4,
			[5] = 43.6,
		},
	},
	[25259] = {
		14,
		25259,
		1,
		10,
		"Gaur Icehorn",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			39590,
			"Spiketooth",
			"Durotar",
			0,
			0,
		},
	},
	[13100] = {
		-304,
		13100,
		3,
		80,
		"Infused Mushroom Meatloaf",
		"A",
		2,
		"HUNTER",
		2,
		"DRAENEI",
		{
			28705,
			"Katherine Lee",
			"Dalaran",
			40.5,
			65.09999999999999,
		},
	},
	[27370] = {
		139,
		27370,
		1,
		40,
		"Tarenar Sunstrike",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			45417,
			"Fiona",
			"Eastern Plaguelands",
			9.1,
			66.40000000000001,
		},
	},
	[28208] = {
		361,
		28208,
		1,
		47,
		"Winna's Kitten",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			47696,
			"Kelnir Leafsong",
			"Felwood",
			41.3,
			50,
		},
	},
	[9418] = {
		3483,
		9418,
		1,
		63,
		"Avruu's Orb",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			[3] = "Hellfire Peninsula",
			[4] = 25.7,
			[5] = 76.90000000000001,
		},
	},
	[27466] = {
		139,
		27466,
		1,
		43,
		"Argent Call: Northdale",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			45729,
			"Tarenar Sunstrike",
			"Eastern Plaguelands",
			61.5,
			43.1,
		},
	},
	[1222] = {
		15,
		1222,
		1,
		37,
		"Stinky's Escape [Escort]",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			4880,
			"\"Stinky\" Ignatz",
			"Dustwallow Marsh",
			46.8,
			17.5,
		},
	},
	[9697] = {
		3521,
		9697,
		1,
		63,
		"Watcher Leesa'oh",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			17834,
			"Lethyn Moonfire",
			"Zangarmarsh",
			78.59999999999999,
			63.1,
		},
	},
	[25515] = {
		400,
		25515,
		1,
		40,
		"[40] [40] Down in the Deeps",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			40475,
			"Jinky Twizzlefixxit",
			"Thousand Needles",
			76.5,
			73.7,
		},
	},
	[13801] = {
		331,
		13801,
		1,
		21,
		"Dead Elves Walking",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			12724,
			"Pixel",
			"Ashenvale",
			73.90000000000001,
			62.5,
		},
	},
	[27959] = {
		51,
		27959,
		1,
		47,
		"Lunk's Adventure: Spider Rider",
		"HA",
		2,
		"DEATHKNIGHTMAGE",
		2,
		"BLOODELFDRAENEI",
		{
			47280,
			"Lunk",
			"Searing Gorge",
			0,
			0,
		},
	},
	[12904] = {
		66,
		12904,
		1,
		76,
		"Light Won't Grant Me Vengeance",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			29455,
			"Gerk",
			"Zul'Drak",
			17.7,
			57.6,
		},
	},
	[28443] = {
		46,
		28443,
		1,
		51,
		"Blackened Ashes",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48569,
			"Eitrigg",
			"Burning Steppes",
			0,
			0,
		},
	},
	[9771] = {
		3521,
		9771,
		1,
		62,
		"Searching for Scout Jyoba",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			18011,
			"Zurai",
			"Zangarmarsh",
			85.2,
			54.7,
		},
	},
	[13881] = {
		148,
		13881,
		1,
		18,
		"Consumed",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			34301,
			"Kathrena Winterwisp",
			"Darkshore",
			45.2,
			74.59999999999999,
		},
	},
	[13897] = {
		148,
		13897,
		1,
		19,
		"The Battle for Darkshore",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			34422,
			"Malfurion Stormrage",
			"Darkshore",
			32.8,
			84.3,
		},
	},
	[25771] = {
		4,
		25771,
		1,
		55,
		"One Draenei's Junk...",
		"AH",
		2,
		"WARLOCKDRUIDWARRIOR",
		2,
		"HUMANTROLLDRAENEI",
		{
			[3] = "Blasted Lands",
			[4] = 46.1,
			[5] = 27,
		},
	},
	[25803] = {
		11,
		25803,
		1,
		22,
		"The Search Continues",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			[3] = "Wetlands",
			[4] = 13.5,
			[5] = 41.4,
		},
	},
	[26562] = {
		44,
		26562,
		1,
		17,
		"And Last But Not Least... Danforth",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			43303,
			"Krakauer",
			"Redridge Mountains",
			26,
			10.5,
		},
	},
	[13961] = {
		17,
		13961,
		1,
		12,
		"Drag it Out of Them",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			34513,
			"Togrik",
			"Northern Barrens",
			0,
			0,
		},
	},
	[13977] = {
		331,
		13977,
		1,
		24,
		"Mass Production",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			34569,
			"Flooz",
			"Ashenvale",
			50,
			67.2,
		},
	},
	[9899] = {
		3521,
		9899,
		1,
		62,
		"A Job Undone",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			18016,
			"Magasha",
			"Zangarmarsh",
			84.40000000000001,
			54.3,
		},
	},
	[24714] = {
		490,
		24714,
		1,
		52,
		"Chasing A-Me 01",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			9618,
			"Karna Remtravel",
			"Un'Goro Crater",
			43.4,
			41,
		},
	},
	[26782] = {
		33,
		26782,
		1,
		28,
		"The Mosh'Ogg Bounty",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			44018,
			"Wulfred Harrys",
			"Northern Stranglethorn",
			53.3,
			66.3,
		},
	},
	[26761] = {
		44,
		26761,
		1,
		15,
		"Threat to the Kingdom",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			234,
			"Marshal Gryan Stoutmantle",
			"Westfall",
			56.4,
			49.6,
		},
	},
	[26059] = {
		406,
		26059,
		1,
		28,
		"Eyes and Ears: Malaka'jin",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			41023,
			"Overlord Krom'gar",
			"Stonetalon Mountains",
			66.2,
			63.7,
		},
	},
	[10250] = {
		3483,
		10250,
		1,
		61,
		"Bloody Vengeance",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			19736,
			"Althen the Historian",
			"Hellfire Peninsula",
			61.7,
			81.7,
		},
	},
	[26569] = {
		44,
		26569,
		1,
		17,
		"Surveying Equipment",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			43194,
			"Foreman Oslow",
			"Redridge Mountains",
			29.6,
			44.5,
		},
	},
	[28256] = {
		361,
		28256,
		1,
		48,
		"The Skull of Gul'dan",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			47923,
			"Feronas Sindweller",
			"Felwood",
			45.5,
			20.1,
		},
	},
	[26187] = {
		4,
		26187,
		1,
		59,
		"The Downfall of Marl Wormthorn",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			42349,
			"Mayor Charlton Connisport",
			"Blasted Lands",
			46.4,
			87.09999999999999,
		},
	},
	[12903] = {
		66,
		12903,
		1,
		76,
		"That's What Friends Are For...",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			29689,
			"Crusader MacKellar",
			"Zul'Drak",
			25.3,
			64,
		},
	},
	[26495] = {
		5287,
		26495,
		1,
		31,
		"Chabal",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			43095,
			"Sassy Hardwrench",
			"The Cape of Stranglethorn",
			34.7,
			29.5,
		},
	},
	[28228] = {
		361,
		28228,
		1,
		48,
		"Rejoining the Forest",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			[3] = "Felwood",
			[4] = 53.1,
			[5] = 24.2,
		},
	},
	[28362] = {
		361,
		28362,
		1,
		49,
		"Stupid Drizle!",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			48461,
			"Ferli",
			"Felwood",
			64.09999999999999,
			10.3,
		},
	},
	[26347] = {
		40,
		26347,
		1,
		14,
		"Keeper of the Flame",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			392,
			"Captain Grayson",
			"Westfall",
			30.5,
			85.59999999999999,
		},
	},
	[28426] = {
		46,
		28426,
		1,
		50,
		"Chiselgrip, the Heart of the Steppes",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48559,
			"Ariok",
			"Burning Steppes",
			17.4,
			51.6,
		},
	},
	[25705] = {
		4,
		25705,
		1,
		57,
		"False Idols",
		"AH",
		2,
		"WARLOCKDRUIDWARRIOR",
		2,
		"HUMANTROLLDRAENEI",
		{
			41354,
			"Neptool",
			"Blasted Lands",
			71,
			60,
		},
	},
	[14249] = {
		16,
		14249,
		1,
		18,
		"Shear Will",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35648,
			"Will Robotronic",
			"Azshara",
			47.2,
			21.1,
		},
	},
	[28522] = {
		618,
		28522,
		1,
		50,
		"Winterfall Activity",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			11556,
			"Salfa",
			"Winterspring",
			21.1,
			46.2,
		},
	},
	[14361] = {
		405,
		14361,
		1,
		30,
		"Peace of Mind",
		"A",
		2,
		"WARLOCK",
		2,
		"GNOME",
		{
			5396,
			"Captain Pentigast",
			"Desolace",
			66.59999999999999,
			11,
		},
	},
	[14297] = {
		16,
		14297,
		1,
		19,
		"Pro-liberation",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			37061,
			"Jellix Fuselighter",
			"Azshara",
			66.3,
			20.2,
		},
	},
	[26571] = {
		44,
		26571,
		1,
		17,
		"Weapons of War",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			43221,
			"Colonel Troteman",
			"Redridge Mountains",
			28.6,
			40.8,
		},
	},
	[26603] = {
		5287,
		26603,
		1,
		32,
		"Message in a Bottle",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			[3] = "The Cape of Stranglethorn",
			[4] = 62.4,
			[5] = 46.6,
		},
	},
	[14345] = {
		16,
		14345,
		1,
		17,
		"Wash Out",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35142,
			"Ergll",
			"Azshara",
			70.3,
			36.1,
		},
	},
	[24620] = {
		4709,
		24620,
		1,
		34,
		"Hearts-is-Hearts",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			37908,
			"Calder Gray",
			"Southern Barrens",
			42.6,
			70.2,
		},
	},
	[26699] = {
		5287,
		26699,
		1,
		35,
		"Turning the Brashtide",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2487,
			"Fleet Master Seahorn",
			"The Cape of Stranglethorn",
			41.6,
			73,
		},
	},
	[26731] = {
		33,
		26731,
		1,
		26,
		"The Altar of Naias",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			43885,
			"Emerine Junis",
			"Northern Stranglethorn",
			43.2,
			40.7,
		},
	},
	[26763] = {
		33,
		26763,
		1,
		28,
		"Venture Company Mining",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			773,
			"Krazek",
			"Northern Stranglethorn",
			43.7,
			23.1,
		},
	},
	[26795] = {
		10,
		26795,
		1,
		25,
		"Mor'Ladim [Group]",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			264,
			"Commander Althea Ebonlocke",
			"Duskwood",
			73.5,
			46.9,
		},
	},
	[27762] = {
		3,
		27762,
		1,
		45,
		"Fuselight, Ho!",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			48704,
			"Gek Nozzlerocket",
			"Eastern Plaguelands",
			73.8,
			53.1,
		},
	},
	[28339] = {
		361,
		28339,
		1,
		49,
		"Is Your Oil Running?",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			48127,
			"Darla Drilldozer",
			"Felwood",
			56.3,
			8.199999999999999,
		},
	},
	[26891] = {
		719,
		26891,
		1,
		26,
		"Amongst the Ruins [Dungeon]",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			12736,
			"Je'neu Sancrea",
			"Blackfathom Deeps",
			0,
			0,
		},
	},
	[25504] = {
		400,
		25504,
		1,
		40,
		"[40] [40] Do Me a Favor?",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			40027,
			"Fizzle Brassbolts",
			"Thousand Needles",
			75.90000000000001,
			74.59999999999999,
		},
	},
	[26955] = {
		28,
		26955,
		1,
		38,
		"Zen'Kiki and the Cultists",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			44456,
			"Adrine Towhide",
			"Western Plaguelands",
			49,
			54.8,
		},
	},
	[24953] = {
		440,
		24953,
		1,
		47,
		"Just Trying to Kill Some Bugs",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38706,
			"Zeke Bootscuff",
			"Tanaris",
			55.7,
			60.8,
		},
	},
	[24734] = {
		490,
		24734,
		1,
		52,
		"Lost!",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			9997,
			"Spraggle Frock",
			"Un'Goro Crater",
			55.1,
			62.6,
		},
	},
	[28288] = {
		361,
		28288,
		1,
		46,
		"Open Their Eyes",
		"H",
		2,
		"DRUIDWARRIOR",
		2,
		"TROLLTAUREN",
		{
			47341,
			"Arcanist Delaris",
			"Felwood",
			41.9,
			72,
		},
	},
	[25036] = {
		4709,
		25036,
		1,
		31,
		"Teegan's Troubles",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38620,
			"Thomas Paxton",
			"Southern Barrens",
			67,
			46.6,
		},
	},
	[25068] = {
		440,
		25068,
		1,
		49,
		"The Crumbling Past",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38922,
			"Examiner Andoren Dawnrise",
			"Tanaris",
			33.3,
			77,
		},
	},
	[14299] = {
		16,
		14299,
		1,
		18,
		"Xylem's Asylum",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36361,
			"Image of Archmage Xylem",
			"Azshara",
			56,
			12.1,
		},
	},
	[25532] = {
		400,
		25532,
		1,
		40,
		"[40] [40] Pirate Accuracy Increasing",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			[3] = "Thousand Needles",
			[4] = 76.5,
			[5] = 73.7,
		},
	},
	[27211] = {
		15,
		27211,
		1,
		36,
		"Propaganda War",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23566,
			"Calia Hastings",
			"Dustwallow Marsh",
			68.3,
			51.1,
		},
	},
	[27243] = {
		15,
		27243,
		1,
		37,
		"Unleash the Raptors",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23723,
			"Sergeant Lukas",
			"Dustwallow Marsh",
			46.6,
			23,
		},
	},
	[24735] = {
		490,
		24735,
		1,
		52,
		"A Little Help From My Friends [Escort]",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			9999,
			"Ringo",
			"Un'Goro Crater",
			52,
			49.9,
		},
	},
	[25260] = {
		14,
		25260,
		1,
		10,
		"Fizzled",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			39379,
			"Gor the Enforcer",
			"Durotar",
			45,
			14.7,
		},
	},
	[27339] = {
		15,
		27339,
		1,
		38,
		"The Reagent Thief",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23601,
			"Apprentice Garion",
			"Dustwallow Marsh",
			46,
			57.2,
		},
	},
	[27371] = {
		139,
		27371,
		1,
		40,
		"What I Do Best",
		"A",
		2,
		"ROGUEMAGE",
		2,
		"NIGHTELFGNOME",
		{
			45429,
			"Tarenar Sunstrike",
			"Eastern Plaguelands",
			18.3,
			74.8,
		},
	},
	[9785] = {
		3521,
		9785,
		1,
		64,
		"Blessings of the Ancients",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			18070,
			"Windcaller Blackhoof",
			"Zangarmarsh",
			80.3,
			64.8,
		},
	},
	[14263] = {
		16,
		14263,
		1,
		18,
		"Waste of Thyme",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35754,
			"Quarla Whistlebreak",
			"Azshara",
			47,
			20.9,
		},
	},
	[27467] = {
		139,
		27467,
		1,
		42,
		"Buried Blades",
		"A",
		2,
		"ROGUE",
		2,
		"NIGHTELF",
		{
			16365,
			"Master Craftsman Omarion",
			"Eastern Plaguelands",
			75.7,
			52.1,
		},
	},
	[24707] = {
		490,
		24707,
		1,
		55,
		"The Ballad of Maximillian",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38237,
			"Maximillian of Northshire",
			"Un'Goro Crater",
			30.5,
			51.3,
		},
	},
	[27531] = {
		139,
		27531,
		1,
		44,
		"Counter-Plague Research",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			45828,
			"Argent Apothecary Judkins",
			"Eastern Plaguelands",
			17.8,
			28,
		},
	},
	[196] = {
		33,
		196,
		1,
		27,
		"Raptor Prowess",
		"A",
		2,
		"DRUIDWARLOCK",
		2,
		"NIGHTELFHUMAN",
		{
			715,
			"Hemet Nesingwary Jr.",
			"Northern Stranglethorn",
			44,
			23.4,
		},
	},
	[28422] = {
		46,
		28422,
		1,
		50,
		"The Sand, the Cider, and the Orb",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48559,
			"Ariok",
			"Burning Steppes",
			17.3,
			51.5,
		},
	},
	[28710] = {
		618,
		28710,
		1,
		53,
		"Spray it One More Time",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			49400,
			"Marcy Curtainfire",
			"Winterspring",
			46.3,
			42.6,
		},
	},
	[14343] = {
		405,
		14343,
		1,
		34,
		"Maurin's Concoction",
		"H",
		2,
		"PALADINMAGE",
		2,
		"BLOODELFTROLL",
		{
			4498,
			"Maurin Bonesplitter",
			"Desolace",
			52.3,
			53.6,
		},
	},
	[26599] = {
		5287,
		26599,
		1,
		33,
		"The Captain's Chest",
		"HA",
		2,
		"PRIESTHUNTER",
		2,
		"SCOURGEDRAENEI",
		{
			2500,
			"Captain Hecklebury Smotts",
			"The Cape of Stranglethorn",
			40.4,
			67.90000000000001,
		},
	},
	[25676] = {
		4,
		25676,
		1,
		55,
		"Heartstrike",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			41124,
			"Okrilla",
			"Blasted Lands",
			40.5,
			11.7,
		},
	},
	[25708] = {
		4,
		25708,
		1,
		55,
		"Our Fallen Friends",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			9540,
			"Enohar Thunderbrew",
			"Blasted Lands",
			61.5,
			18.6,
		},
	},
	[190] = {
		33,
		190,
		1,
		25,
		"Panther Hunting",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			718,
			"Sir S. J. Erlgadin",
			"Northern Stranglethorn",
			43.8,
			22.3,
		},
	},
	[25772] = {
		4,
		25772,
		1,
		55,
		"Kum'isha's Endeavors",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			[3] = "Blasted Lands",
			[4] = 48.9,
			[5] = 34,
		},
	},
	[25804] = {
		11,
		25804,
		1,
		22,
		"Search More Hovels",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			[3] = "Wetlands",
			[4] = 13.6,
			[5] = 38.4,
		},
	},
	[10875] = {
		3483,
		10875,
		1,
		61,
		"Report to Nazgrel",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16588,
			"Apothecary Antonivich",
			"Hellfire Peninsula",
			52.3,
			36.5,
		},
	},
	[25868] = {
		11,
		25868,
		1,
		23,
		"Yorla Darksnare",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			41415,
			"Shilah Slabchisel",
			"Wetlands",
			26.9,
			26.1,
		},
	},
	[185] = {
		33,
		185,
		1,
		25,
		"Tiger Hunting",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			717,
			"Ajeck Rouack",
			"Northern Stranglethorn",
			44.5,
			22.7,
		},
	},
	[27979] = {
		51,
		27979,
		1,
		48,
		"Dark Ministry",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			14627,
			"Hansel Heavyhands",
			"Searing Gorge",
			38.4,
			28.1,
		},
	},
	[14131] = {
		16,
		14131,
		1,
		17,
		"A Little Pick-me-up",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35142,
			"Ergll",
			"Azshara",
			70.3,
			36.2,
		},
	},
	[9720] = {
		3521,
		9720,
		1,
		64,
		"Balance Must Be Preserved",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			17841,
			"Ysiel Windsinger",
			"Zangarmarsh",
			78.40000000000001,
			62.1,
		},
	},
	[26028] = {
		406,
		26028,
		1,
		27,
		"Mr. D's Wild Ride",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			40907,
			"Clarissa",
			"Stonetalon Mountains",
			66.09999999999999,
			64.09999999999999,
		},
	},
	[26060] = {
		406,
		26060,
		1,
		28,
		"Da Voodoo: Stormer Heart",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			3995,
			"Witch Doctor Jin'Zil",
			"Stonetalon Mountains",
			71.09999999999999,
			91.3,
		},
	},
	[27252] = {
		15,
		27252,
		1,
		37,
		"The Black Shield",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23567,
			"Inspector Tarem",
			"Dustwallow Marsh",
			29.6,
			48.5,
		},
	},
	[27160] = {
		28,
		27160,
		1,
		35,
		"War Machines",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			44471,
			"Lurid",
			"Western Plaguelands",
			41,
			70.40000000000001,
		},
	},
	[28203] = {
		46,
		28203,
		1,
		50,
		"A Perfect Costume",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			48001,
			"Thelaron Direneedle",
			"Burning Steppes",
			45.4,
			46.1,
		},
	},
	[24514] = {
		4709,
		24514,
		1,
		30,
		"Raptor Scraps",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			37138,
			"Onatay",
			"Southern Barrens",
			39.5,
			20.4,
		},
	},
	[26220] = {
		-304,
		26220,
		3,
		80,
		"Everything Is Better with Bacon",
		"H",
		2,
		"DRUIDDEATHKNIGHT",
		2,
		"TROLLBLOODELF",
		{
			42506,
			"Marogg",
			"Orgrimmar",
			56.6,
			62.6,
		},
	},
	[26252] = {
		40,
		26252,
		1,
		12,
		"Heart of the Watcher",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Westfall",
			[4] = 55.3,
			[5] = 34.7,
		},
	},
	[24730] = {
		490,
		24730,
		1,
		53,
		"Roll the Bones",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			9272,
			"Spark Nilminer",
			"Un'Goro Crater",
			31.9,
			50.4,
		},
	},
	[25019] = {
		440,
		25019,
		1,
		49,
		"Laying Claim",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38922,
			"Examiner Andoren Dawnrise",
			"Tanaris",
			33.3,
			77,
		},
	},
	[26348] = {
		40,
		26348,
		1,
		15,
		"The Coast Isn't Clear",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			392,
			"Captain Grayson",
			"Westfall",
			30.5,
			85.59999999999999,
		},
	},
	[28427] = {
		46,
		28427,
		1,
		50,
		"A Needle in a Hellhole",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48568,
			"Eitrigg",
			"Burning Steppes",
			0,
			0,
		},
	},
	[24691] = {
		490,
		24691,
		1,
		52,
		"Peculiar Delicacies",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			10977,
			"Quixxil",
			"Un'Goro Crater",
			54.8,
			63.8,
		},
	},
	[28491] = {
		46,
		28491,
		1,
		51,
		"Not Fireflies, Flameflies",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			10260,
			"Kibler",
			"Burning Steppes",
			55.1,
			22.5,
		},
	},
	[24737] = {
		490,
		24737,
		1,
		52,
		"Super Sticky",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38276,
			"Tara",
			"Un'Goro Crater",
			43.3,
			41,
		},
	},
	[26508] = {
		44,
		26508,
		1,
		16,
		"Nida's Necklace",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			8965,
			"Shawn",
			"Redridge Mountains",
			28.3,
			48.8,
		},
	},
	[28641] = {
		618,
		28641,
		1,
		53,
		"Pride of the Dinner Table",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			7431,
			"Frostsaber",
			"Winterspring",
			52.5,
			22.2,
		},
	},
	[24525] = {
		4709,
		24525,
		1,
		31,
		"Keeping the Dogs at Bay",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			11857,
			"Makaba Flathoof",
			"Southern Barrens",
			44.2,
			33.7,
		},
	},
	[9212] = {
		3433,
		9212,
		1,
		17,
		"Escape from the Catacombs",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			16295,
			"Ranger Lilatha",
			"Ghostlands",
			63,
			32.6,
		},
	},
	[26636] = {
		44,
		26636,
		1,
		18,
		"Bravo Company Field Kit: Camouflage",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			43461,
			"Krakauer",
			"Redridge Mountains",
			52.4,
			55.4,
		},
	},
	[26668] = {
		44,
		26668,
		1,
		18,
		"Detonation",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			43611,
			"John J. Keeshan",
			"Redridge Mountains",
			77.7,
			65.5,
		},
	},
	[26700] = {
		5287,
		26700,
		1,
		35,
		"The Damsel's (Bad) Luck",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2487,
			"Fleet Master Seahorn",
			"The Cape of Stranglethorn",
			41.6,
			72.90000000000001,
		},
	},
	[26732] = {
		33,
		26732,
		1,
		25,
		"Bad Medicine",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			739,
			"Brother Nimetz",
			"Northern Stranglethorn",
			47.2,
			11,
		},
	},
	[24717] = {
		490,
		24717,
		1,
		52,
		"The Apes of Un'Goro",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38275,
			"Gremix",
			"Un'Goro Crater",
			43.2,
			41.1,
		},
	},
	[26796] = {
		10,
		26796,
		1,
		25,
		"The Daughter Who Lived",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			264,
			"Commander Althea Ebonlocke",
			"Duskwood",
			73.59999999999999,
			46.9,
		},
	},
	[27167] = {
		28,
		27167,
		1,
		36,
		"A Mighty Hunger",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			45165,
			"Thurman Grant",
			"Western Plaguelands",
			42.8,
			84.2,
		},
	},
	[9340] = {
		3483,
		9340,
		1,
		62,
		"The Great Fissure",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16789,
			"Ranger Captain Venn'ren",
			"Hellfire Peninsula",
			28.6,
			60.3,
		},
	},
	[26892] = {
		719,
		26892,
		1,
		26,
		"Deep in the Deeps",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			44375,
			"Zeya",
			"Blackfathom Deeps",
			0,
			0,
		},
	},
	[9372] = {
		3483,
		9372,
		1,
		63,
		"Demonic Contamination",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16991,
			"Thiah Redmane",
			"Hellfire Peninsula",
			15.7,
			52.2,
		},
	},
	[26956] = {
		28,
		26956,
		1,
		37,
		"I Ain't Sayin' You a Gourd-Digger...",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			44457,
			"Selyria Groenveld",
			"Western Plaguelands",
			48.6,
			54.9,
		},
	},
	[24941] = {
		4709,
		24941,
		1,
		30,
		"Langridge Shot",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38620,
			"Thomas Paxton",
			"Southern Barrens",
			67,
			46.6,
		},
	},
	[13514] = {
		148,
		13514,
		1,
		14,
		"The Ancients' Ire",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			33176,
			"Kerlonian Evershade",
			"Darkshore",
			69.09999999999999,
			19.2,
		},
	},
	[25701] = {
		4,
		25701,
		1,
		57,
		"You Are Rakh'likh, Demon",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			7783,
			"Loramus Thalipedes",
			"Blasted Lands",
			39.3,
			35.9,
		},
	},
	[13546] = {
		148,
		13546,
		1,
		19,
		"The Defiler",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			32967,
			"Elder Brolg",
			"Darkshore",
			43.5,
			81,
		},
	},
	[13562] = {
		148,
		13562,
		1,
		11,
		"The Final Flame of Bashal'Aran",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			32971,
			"Ranger Glynda Nal'Shea",
			"Darkshore",
			50.9,
			20.1,
		},
	},
	[13578] = {
		148,
		13578,
		1,
		17,
		"Aroom's Farewell",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			33119,
			"Aroom",
			"Darkshore",
			45.5,
			48.5,
		},
	},
	[25025] = {
		440,
		25025,
		1,
		45,
		"Sang'thraze the Deflector",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38927,
			"Mazoga",
			"Tanaris",
			42.3,
			23.9,
		},
	},
	[27212] = {
		15,
		27212,
		1,
		36,
		"Discrediting the Deserters",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23566,
			"Calia Hastings",
			"Dustwallow Marsh",
			68.3,
			51.1,
		},
	},
	[25197] = {
		4709,
		25197,
		1,
		30,
		"The Admiral Won't Back Down",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			39322,
			"Horton Gimbleheart",
			"Southern Barrens",
			68.59999999999999,
			49.2,
		},
	},
	[10295] = {
		3483,
		10295,
		1,
		63,
		"From the Abyss",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			19683,
			"Ogath the Mad",
			"Hellfire Peninsula",
			61.8,
			81.5,
		},
	},
	[25261] = {
		14,
		25261,
		1,
		10,
		"Margoz",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			[3] = "Durotar",
			[4] = 45,
			[5] = 14.7,
		},
	},
	[27340] = {
		15,
		27340,
		1,
		38,
		"Direhorn Raiders",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23600,
			"Apprentice Morlann",
			"Dustwallow Marsh",
			46.1,
			57.5,
		},
	},
	[27372] = {
		139,
		27372,
		1,
		40,
		"A Gift For Fiona",
		"A",
		2,
		"ROGUEMAGE",
		2,
		"NIGHTELFGNOME",
		{
			[3] = "Eastern Plaguelands",
			[4] = 18.5,
			[5] = 79.8,
		},
	},
	[25765] = {
		406,
		25765,
		1,
		28,
		"Tell 'Em Koko Sent You",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			40897,
			"Northwatch Captain Kosak",
			"Stonetalon Mountains",
			59.4,
			56.9,
		},
	},
	[14342] = {
		405,
		14342,
		1,
		35,
		"Infernal Encroachment",
		"H",
		2,
		"PALADINMAGE",
		2,
		"BLOODELFTROLL",
		{
			5395,
			"Felgur Twocuts",
			"Desolace",
			56.2,
			59.5,
		},
	},
	[27151] = {
		28,
		27151,
		1,
		37,
		"Taelan Fordring's Legacy",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			45147,
			"Daria L'Rayne",
			"Western Plaguelands",
			42.1,
			14.9,
		},
	},
	[24601] = {
		4709,
		24601,
		1,
		32,
		"The Nightmare Scar",
		"AH",
		2,
		"DRUIDMAGEWARLOCK",
		2,
		"NIGHTELFGNOMESCOURGE",
		{
			37570,
			"Naralex",
			"Southern Barrens",
			50.4,
			40.7,
		},
	},
	[27532] = {
		139,
		27532,
		1,
		44,
		"The Plaguewood Tower",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			45451,
			"Argus Highbeacon",
			"Eastern Plaguelands",
			50.8,
			20.4,
		},
	},
	[25517] = {
		400,
		25517,
		1,
		40,
		"[40] [40] Bar Fight!",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			40554,
			"Rizzle Brassbolts",
			"Thousand Needles",
			78,
			73.40000000000001,
		},
	},
	[26213] = {
		40,
		26213,
		1,
		10,
		"Hot On the Trail: The Riverpaw Clan",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			42308,
			"Lieutenant Horatio Laine",
			"Westfall",
			60,
			19.2,
		},
	},
	[28436] = {
		46,
		28436,
		1,
		50,
		"Taking the Horn For Ourselves",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			48111,
			"Blackrock War Kodo",
			"Burning Steppes",
			96.59999999999999,
			13.8,
		},
	},
	[13834] = {
		-101,
		13834,
		3,
		80,
		"Dangerously Delicious",
		"A",
		2,
		"HUNTER",
		2,
		"DRAENEI",
		{
			28742,
			"Marcia Chase",
			"Dalaran",
			53,
			65.2,
		},
	},
	[13850] = {
		490,
		13850,
		1,
		53,
		"Toxic Tolerance",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			11701,
			"Mor'vek",
			"Un'Goro Crater",
			71.5,
			74,
		},
	},
	[25677] = {
		4,
		25677,
		1,
		55,
		"It's All Mine",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			41133,
			"Rofilian Dane",
			"Blasted Lands",
			59.5,
			3.5,
		},
	},
	[13882] = {
		148,
		13882,
		1,
		18,
		"The Seeds of Life",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			34301,
			"Kathrena Winterwisp",
			"Darkshore",
			45.2,
			74.7,
		},
	},
	[13898] = {
		148,
		13898,
		1,
		20,
		"The Tides Turn Against Us",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			34403,
			"Felros",
			"Darkshore",
			45.3,
			75.09999999999999,
		},
	},
	[24740] = {
		490,
		24740,
		1,
		52,
		"Volcanic Activity",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			9270,
			"Williden Marshal",
			"Un'Goro Crater",
			55.2,
			62.2,
		},
	},
	[27236] = {
		15,
		27236,
		1,
		37,
		"Secondhand Diving Gear",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23569,
			"Renn McGill",
			"Dustwallow Marsh",
			63.8,
			17.1,
		},
	},
	[25837] = {
		406,
		25837,
		1,
		28,
		"A Proper Peace Offerin'",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			41278,
			"\"Cookie\" McWeaksauce",
			"Stonetalon Mountains",
			70.90000000000001,
			79.7,
		},
	},
	[13962] = {
		331,
		13962,
		1,
		24,
		"Stalemate",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			34518,
			"Thagg",
			"Ashenvale",
			60,
			53.1,
		},
	},
	[1204] = {
		15,
		1204,
		1,
		36,
		"Mudrock Soup and Bugs",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			4794,
			"Morgan Stern",
			"Dustwallow Marsh",
			68.2,
			48.6,
		},
	},
	[27980] = {
		51,
		27980,
		1,
		48,
		"The Spiders Have to Go",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			14634,
			"Lookout Captain Lolo Longstriker",
			"Searing Gorge",
			37.8,
			26.8,
		},
	},
	[14323] = {
		16,
		14323,
		1,
		17,
		"Absorbent",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35142,
			"Ergll",
			"Azshara",
			70.40000000000001,
			36.2,
		},
	},
	[28044] = {
		361,
		28044,
		1,
		46,
		"Touch the Untouchable",
		"H",
		2,
		"DRUIDWARRIOR",
		2,
		"TROLLTAUREN",
		{
			47366,
			"Impsy",
			"Felwood",
			41.9,
			71.90000000000001,
		},
	},
	[26069] = {
		406,
		26069,
		1,
		30,
		"Nura Pathfinder",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			3995,
			"Witch Doctor Jin'Zil",
			"Stonetalon Mountains",
			71.09999999999999,
			91.3,
		},
	},
	[26061] = {
		406,
		26061,
		1,
		28,
		"Da Voodoo: Ram Horns",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			3995,
			"Witch Doctor Jin'Zil",
			"Stonetalon Mountains",
			71.09999999999999,
			91.3,
		},
	},
	[28214] = {
		361,
		28214,
		1,
		47,
		"Cleanup at Bloodvenom Post",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			47692,
			"Altsoba Ragetotem",
			"Felwood",
			41.3,
			50,
		},
	},
	[28172] = {
		46,
		28172,
		1,
		50,
		"Done Nothing Wrong",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			47779,
			"Mouton Flamestar",
			"Burning Steppes",
			16.9,
			51.4,
		},
	},
	[26157] = {
		4,
		26157,
		1,
		55,
		"Kasim Sharim",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			5385,
			"Watcher Mahar Ba",
			"Blasted Lands",
			63.2,
			16.9,
		},
	},
	[27930] = {
		3,
		27930,
		1,
		47,
		"Devastation",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			[3] = "Badlands",
			[4] = 15.8,
			[5] = 33.2,
		},
	},
	[14117] = {
		16,
		14117,
		1,
		10,
		"The Eyes of Ashenvale",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			8576,
			"Ag'tor Bloodfist",
			"Azshara",
			26.9,
			76.90000000000001,
		},
	},
	[28218] = {
		361,
		28218,
		1,
		48,
		"A Destiny of Flame and Sorrow",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			47923,
			"Feronas Sindweller",
			"Felwood",
			45.6,
			20,
		},
	},
	[24700] = {
		490,
		24700,
		1,
		52,
		"Hard to Harvest",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38276,
			"Tara",
			"Un'Goro Crater",
			43.3,
			41,
		},
	},
	[28364] = {
		361,
		28364,
		1,
		49,
		"The Chieftain's Key",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			47556,
			"Drizle",
			"Felwood",
			60.6,
			9.5,
		},
	},
	[14202] = {
		16,
		14202,
		1,
		12,
		"Survey the Lakeshore",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35088,
			"Custer Clubnik",
			"Azshara",
			29.6,
			66.90000000000001,
		},
	},
	[14132] = {
		16,
		14132,
		1,
		17,
		"That's Just Rude!",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35142,
			"Ergll",
			"Azshara",
			70.3,
			36.2,
		},
	},
	[28460] = {
		618,
		28460,
		1,
		50,
		"Threat of the Winterfall",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			9298,
			"Donova Snowden",
			"Winterspring",
			25.2,
			58.5,
		},
	},
	[14250] = {
		16,
		14250,
		1,
		18,
		"Renewable Resource",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35755,
			"Tharkul Ironskull",
			"Azshara",
			47.2,
			21.2,
		},
	},
	[28524] = {
		618,
		28524,
		1,
		50,
		"Delivery for Donova",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			11556,
			"Salfa",
			"Winterspring",
			21.1,
			46.2,
		},
	},
	[26509] = {
		44,
		26509,
		1,
		16,
		"An Unwelcome Guest",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			342,
			"Martie Jainrose",
			"Redridge Mountains",
			22,
			42.9,
		},
	},
	[25816] = {
		11,
		25816,
		1,
		22,
		"Cursed to Roam",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			1239,
			"First Mate Fitzsimmons",
			"Wetlands",
			10.9,
			59.7,
		},
	},
	[26573] = {
		44,
		26573,
		1,
		17,
		"His Heart Must Be In It",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			[3] = "Redridge Mountains",
			[4] = 51.3,
			[5] = 41.5,
		},
	},
	[10236] = {
		3483,
		10236,
		1,
		61,
		"Outland Sucks!",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			16915,
			"Foreman Razelcraz",
			"Hellfire Peninsula",
			51.3,
			30.6,
		},
	},
	[26637] = {
		44,
		26637,
		1,
		18,
		"Bravo Company Field Kit: Chloroform",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			43459,
			"Messner",
			"Redridge Mountains",
			52.5,
			55.5,
		},
	},
	[14362] = {
		405,
		14362,
		1,
		31,
		"Ears Are Burning",
		"A",
		2,
		"WARLOCK",
		2,
		"GNOME",
		{
			[3] = "Desolace",
			[4] = 75.90000000000001,
			[5] = 26.6,
		},
	},
	[24654] = {
		4709,
		24654,
		1,
		34,
		"Silithissues",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			37910,
			"Crawgol",
			"Southern Barrens",
			41.6,
			69.40000000000001,
		},
	},
	[24686] = {
		490,
		24686,
		1,
		51,
		"Carried on the Waves",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38274,
			"Garl Stormclaw",
			"Un'Goro Crater",
			70.90000000000001,
			75.59999999999999,
		},
	},
	[24718] = {
		490,
		24718,
		1,
		53,
		"The Mighty U'cha",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			[3] = "Un'Goro Crater",
			[4] = 64.8,
			[5] = 16.6,
		},
	},
	[26797] = {
		10,
		26797,
		1,
		25,
		"A Daughter's Love",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			576,
			"Watcher Ladimore",
			"Duskwood",
			73.59999999999999,
			47.1,
		},
	},
	[12861] = {
		66,
		12861,
		1,
		75,
		"Trolls Is Gone Crazy!",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			29690,
			"Chief Rageclaw",
			"Zul'Drak",
			32.1,
			75.59999999999999,
		},
	},
	[26775] = {
		33,
		26775,
		1,
		29,
		"Be Raptor",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			44017,
			"Priestess Thaalia",
			"Northern Stranglethorn",
			53.4,
			66.7,
		},
	},
	[25091] = {
		440,
		25091,
		1,
		45,
		"Sandsorrow Watch",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			39178,
			"Driz Plunkbow",
			"Tanaris",
			52.2,
			28,
		},
	},
	[24733] = {
		490,
		24733,
		1,
		53,
		"The Bait for Lar'korwi",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			9619,
			"Torwa Pathfinder",
			"Un'Goro Crater",
			71.3,
			76.7,
		},
	},
	[24910] = {
		440,
		24910,
		1,
		45,
		"Rocket Rescue",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38534,
			"Megs Dreadshredder",
			"Tanaris",
			51.3,
			29.9,
		},
	},
	[14261] = {
		16,
		14261,
		1,
		19,
		"Ice Cold",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			37064,
			"Feno Blastnoggin",
			"Azshara",
			66.5,
			19.6,
		},
	},
	[13599] = {
		148,
		13599,
		1,
		12,
		"Grimclaw's Return",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			33048,
			"Keeper Karithus",
			"Darkshore",
			42.9,
			39,
		},
	},
	[27053] = {
		28,
		27053,
		1,
		38,
		"Gahrron's Withering Cauldron",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			44454,
			"Field Agent Kaartish",
			"Western Plaguelands",
			49.3,
			54.9,
		},
	},
	[26672] = {
		10,
		26672,
		1,
		23,
		"Clawing at the Truth",
		"A",
		2,
		"WARLOCKSHAMAN",
		2,
		"HUMANDWARF",
		{
			43453,
			"Tobias Mistmantle",
			"Duskwood",
			79,
			44.2,
		},
	},
	[24505] = {
		4709,
		24505,
		1,
		30,
		"Holdout at Hunter's Hill",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			37137,
			"Tunawa Stillwind",
			"Southern Barrens",
			37.4,
			16.8,
		},
	},
	[25102] = {
		4709,
		25102,
		1,
		34,
		"No Bull",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			39154,
			"Hurlston Stonesthrow",
			"Southern Barrens",
			43.5,
			78.3,
		},
	},
	[25820] = {
		11,
		25820,
		1,
		22,
		"A Mother's Worries",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			1484,
			"Derina Rumdnul",
			"Wetlands",
			11.8,
			57.9,
		},
	},
	[27213] = {
		15,
		27213,
		1,
		36,
		"The End of the Deserters",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23566,
			"Calia Hastings",
			"Dustwallow Marsh",
			68.3,
			51,
		},
	},
	[27245] = {
		15,
		27245,
		1,
		37,
		"Prisoners of the Grimtotems",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23723,
			"Sergeant Lukas",
			"Dustwallow Marsh",
			46.6,
			23,
		},
	},
	[14428] = {
		16,
		14428,
		1,
		18,
		"Amberwind's Journal",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36596,
			"Andorel Sunsworn",
			"Azshara",
			42.6,
			23.8,
		},
	},
	[25262] = {
		14,
		25262,
		1,
		12,
		"Skull Rock",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			3208,
			"Margoz",
			"Durotar",
			56.4,
			20,
		},
	},
	[332] = {
		1519,
		332,
		1,
		2,
		"Wine Shop Advert",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			1432,
			"Renato Gallina",
			"Stormwind City",
			63.7,
			73.09999999999999,
		},
	},
	[27373] = {
		139,
		27373,
		1,
		40,
		"Onward, to Light's Hope Chapel",
		"A",
		2,
		"ROGUEMAGE",
		2,
		"NIGHTELFGNOME",
		{
			45417,
			"Fiona",
			"Eastern Plaguelands",
			9,
			66.5,
		},
	},
	[333] = {
		1519,
		333,
		1,
		2,
		"Harlan Needs a Resupply",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			1427,
			"Harlan Bagley",
			"Stormwind City",
			62.5,
			67.90000000000001,
		},
	},
	[12699] = {
		3711,
		12699,
		1,
		77,
		"An Embarassing Incident",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			28746,
			"Pilot Vic",
			"Sholazar Basin",
			49.9,
			61.6,
		},
	},
	[27469] = {
		1583,
		27469,
		1,
		58,
		"Friends on The Other Side",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			9563,
			"Ragged John",
			"Burning Steppes",
			54.2,
			23.9,
		},
	},
	[13940] = {
		148,
		13940,
		1,
		17,
		"Leaving the Dream",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			33166,
			"Thessera",
			"Darkshore",
			49.2,
			56.8,
		},
	},
	[25486] = {
		357,
		25486,
		1,
		40,
		"[40] [40] The Grimtotem are Coming",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			39946,
			"Caryssia Moonhunter",
			"Feralas",
			86.09999999999999,
			45.2,
		},
	},
	[27155] = {
		28,
		27155,
		1,
		37,
		"Turning Yourself In",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			[3] = "Western Plaguelands",
			[4] = 45.9,
			[5] = 18.4,
		},
	},
	[45] = {
		12,
		45,
		1,
		10,
		"Discover Rolf's Fate",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			[3] = "Elwynn Forest",
			[4] = 72.7,
			[5] = 60.4,
		},
	},
	[12795] = {
		66,
		12795,
		1,
		75,
		"Taking a Stand",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			28532,
			"Bloodrose Datura",
			"Zul'Drak",
			14.2,
			74,
		},
	},
	[25614] = {
		406,
		25614,
		1,
		25,
		"The Only Way Down is in a Body Bag",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			39256,
			"Kalen Trueshot",
			"Stonetalon Mountains",
			71.8,
			45.6,
		},
	},
	[25646] = {
		406,
		25646,
		1,
		26,
		"Windshear Mine Cleanup",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			40973,
			"Sentinel Heliana",
			"Stonetalon Mountains",
			72.5,
			61.5,
		},
	},
	[25678] = {
		4,
		25678,
		1,
		55,
		"Pick Your Fate",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			41133,
			"Rofilian Dane",
			"Blasted Lands",
			59.5,
			3.5,
		},
	},
	[12859] = {
		66,
		12859,
		1,
		75,
		"This Just In: Fire Still Hot!",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			29733,
			"Elder Shaman Moky",
			"Zul'Drak",
			32,
			75.5,
		},
	},
	[24634] = {
		4709,
		24634,
		1,
		34,
		"Intelligence Warfare",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			37837,
			"Warlord Bloodhilt",
			"Southern Barrens",
			41.6,
			69.8,
		},
	},
	[25774] = {
		400,
		25774,
		1,
		42,
		"[42] [42] Fool's Gold",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			41190,
			"Crazzle Sprysprocket",
			"Thousand Needles",
			91.40000000000001,
			57.7,
		},
	},
	[25806] = {
		406,
		25806,
		1,
		28,
		"They Put the Assass in... Never Mind",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			41277,
			"Lieutenant Paulson",
			"Stonetalon Mountains",
			72,
			76,
		},
	},
	[14189] = {
		405,
		14189,
		1,
		30,
		"Translation",
		"H",
		2,
		"PALADIN",
		2,
		"BLOODELF",
		{
			35298,
			"Sorrem",
			"Desolace",
			44.8,
			29.5,
		},
	},
	[26066] = {
		406,
		26066,
		1,
		29,
		"Reinforcements...",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			42023,
			"Subjugator Devo",
			"Stonetalon Mountains",
			71.09999999999999,
			91.09999999999999,
		},
	},
	[14034] = {
		17,
		14034,
		1,
		16,
		"Club Foote",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			3391,
			"Gazlowe",
			"Northern Barrens",
			0,
			0,
		},
	},
	[27981] = {
		51,
		27981,
		1,
		48,
		"Heat That Just Don't Quit",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			14627,
			"Hansel Heavyhands",
			"Searing Gorge",
			0,
			0,
		},
	},
	[25059] = {
		4709,
		25059,
		1,
		32,
		"The Taurajo Briefs",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			38986,
			"Ambassador Gaines",
			"Southern Barrens",
			50,
			49.6,
		},
	},
	[28045] = {
		400,
		28045,
		1,
		41,
		"[41] [41] The Greatest Flavor in the World!",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			47383,
			"Brivelthwerp",
			"Thousand Needles",
			70,
			85.2,
		},
	},
	[24543] = {
		4709,
		24543,
		1,
		32,
		"A Family Divided",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			37516,
			"Tawane",
			"Southern Barrens",
			44.5,
			33.6,
		},
	},
	[26062] = {
		406,
		26062,
		1,
		28,
		"Da Voodoo: Resonite Crystal",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			3995,
			"Witch Doctor Jin'Zil",
			"Stonetalon Mountains",
			71.09999999999999,
			91.2,
		},
	},
	[13892] = {
		148,
		13892,
		1,
		19,
		"Leave No Tracks",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			34402,
			"Balren of the Claw",
			"Darkshore",
			45.3,
			75.09999999999999,
		},
	},
	[25120] = {
		4709,
		25120,
		1,
		34,
		"Marley's Final Flight",
		"A",
		2,
		"DRUIDMAGE",
		2,
		"NIGHTELFGNOME",
		{
			39155,
			"Marley Twinbraid",
			"Southern Barrens",
			47.2,
			88.5,
		},
	},
	[26158] = {
		4,
		26158,
		1,
		55,
		"Attune the Bloodstone",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			42298,
			"Kasim Sharim",
			"Blasted Lands",
			62.5,
			26.3,
		},
	},
	[14308] = {
		16,
		14308,
		1,
		13,
		"When Science Attacks",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36077,
			"Assistant Greely",
			"Azshara",
			50.4,
			74.3,
		},
	},
	[24542] = {
		4709,
		24542,
		1,
		31,
		"A Curious Bloom",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			37515,
			"Lane Tallgrass",
			"Southern Barrens",
			44.4,
			33.3,
		},
	},
	[26134] = {
		406,
		26134,
		1,
		30,
		"Nothing Left for You Here",
		"H",
		2,
		"WARLOCKPALADIN",
		2,
		"SCOURGEBLOODELF",
		{
			42039,
			"High Chieftain Cliffwalker",
			"Stonetalon Mountains",
			45.5,
			33.8,
		},
	},
	[28333] = {
		361,
		28333,
		1,
		49,
		"It's Time to Oil Up",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			48127,
			"Darla Drilldozer",
			"Felwood",
			56.3,
			8.1,
		},
	},
	[24631] = {
		4709,
		24631,
		1,
		34,
		"Flightmare",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			37909,
			"Tomusa",
			"Southern Barrens",
			41.1,
			71,
		},
	},
	[14388] = {
		16,
		14388,
		1,
		14,
		"Azsharite Experiment Number Two",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			36077,
			"Assistant Greely",
			"Azshara",
			50.3,
			74.3,
		},
	},
	[13953] = {
		148,
		13953,
		1,
		19,
		"Naga In Our Midst",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			34498,
			"Darkscale Assassin",
			"Darkshore",
			45.7,
			71.7,
		},
	},
	[26414] = {
		-101,
		26414,
		3,
		80,
		"Hitting a Walleye",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			5494,
			"Catherine Leland",
			"Stormwind City",
			54.9,
			69.5,
		},
	},
	[26297] = {
		40,
		26297,
		1,
		15,
		"The Dawning of a New Day",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			42425,
			"Captain Alpert",
			"Westfall",
			42.1,
			64.09999999999999,
		},
	},
	[14255] = {
		405,
		14255,
		1,
		31,
		"Ethel Rethor",
		"H",
		2,
		"PALADIN",
		2,
		"BLOODELF",
		{
			35295,
			"Cerelia",
			"Desolace",
			44.6,
			29.5,
		},
	},
	[26510] = {
		44,
		26510,
		1,
		16,
		"We Must Prepare!",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			344,
			"Magistrate Solomon",
			"Redridge Mountains",
			28.9,
			41,
		},
	},
	[25762] = {
		400,
		25762,
		1,
		42,
		"[42] [42] The Ancient Brazier",
		"A",
		2,
		"PALADIN",
		2,
		"DRAENEI",
		{
			40082,
			"Skycaller Vrakthris",
			"Thousand Needles",
			90.09999999999999,
			53.1,
		},
	},
	[14223] = {
		405,
		14223,
		1,
		30,
		"Peace of Mind",
		"H",
		2,
		"PALADIN",
		2,
		"BLOODELF",
		{
			35298,
			"Sorrem",
			"Desolace",
			44.8,
			29.6,
		},
	},
	[26606] = {
		5287,
		26606,
		1,
		33,
		"Mukla's Demise",
		"H",
		2,
		"PRIEST",
		2,
		"SCOURGE",
		{
			2634,
			"Princess Poobah",
			"The Cape of Stranglethorn",
			59.5,
			79,
		},
	},
	[26638] = {
		44,
		26638,
		1,
		18,
		"Hunting the Hunters",
		"A",
		2,
		"WARLOCKPALADIN",
		2,
		"HUMAN",
		{
			43462,
			"Danforth",
			"Redridge Mountains",
			52.5,
			55.5,
		},
	},
	[26670] = {
		10,
		26670,
		1,
		23,
		"Roland's Doom",
		"A",
		2,
		"WARLOCKSHAMANPALADIN",
		2,
		"HUMANDWARF",
		{
			267,
			"Clerk Daltry",
			"Duskwood",
			72.5,
			46.9,
		},
	},
	[27828] = {
		3,
		27828,
		1,
		47,
		"Eric, the Utility Dwarf",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			46852,
			"Eric \"The Swift\"",
			"Badlands",
			20.6,
			56,
		},
	},
	[9277] = {
		3433,
		9277,
		1,
		19,
		"Assault on Zeb'Nowa",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			16463,
			"Farstrider Solanna",
			"Ghostlands",
			72.3,
			31.3,
		},
	},
	[24719] = {
		490,
		24719,
		1,
		51,
		"Claws of White",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38274,
			"Garl Stormclaw",
			"Un'Goro Crater",
			70.5,
			76.8,
		},
	},
	[24699] = {
		490,
		24699,
		1,
		54,
		"Gormashh the Glutinous",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38276,
			"Tara",
			"Un'Goro Crater",
			43.1,
			41.2,
		},
	},
	[13596] = {
		148,
		13596,
		1,
		13,
		"Twilight Plans",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			32912,
			"Sentinel Lendra",
			"Darkshore",
			50.3,
			20.3,
		},
	},
	[28640] = {
		618,
		28640,
		1,
		53,
		"Fresh Frostsabers",
		"H",
		2,
		"PRIESTDRUID",
		2,
		"SCOURGETROLL",
		{
			49396,
			"Jez Goodgrub",
			"Winterspring",
			56,
			28.2,
		},
	},
	[26894] = {
		719,
		26894,
		1,
		24,
		"Blackfathom Deeps",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			34122,
			"Commander Grimfang",
			"Ashenvale",
			12,
			33.8,
		},
	},
	[9373] = {
		3483,
		9373,
		1,
		61,
		"Missing Missive",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			[3] = "Hellfire Peninsula",
			[4] = 46.7,
			[5] = 62.9,
		},
	},
	[24911] = {
		490,
		24911,
		1,
		52,
		"Tropical Paradise Beckons",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			44374,
			"Sherm",
			"Tanaris",
			33.3,
			76.90000000000001,
		},
	},
	[9405] = {
		3483,
		9405,
		1,
		62,
		"The Warchief's Mandate",
		"H",
		2,
		"MAGE",
		2,
		"SCOURGE",
		{
			3230,
			"Nazgrel",
			"Hellfire Peninsula",
			55.1,
			35.9,
		},
	},
	[13515] = {
		148,
		13515,
		1,
		14,
		"Ending the Threat",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			33178,
			"Huntress Sandrya Moonfall",
			"Darkshore",
			72.2,
			19.2,
		},
	},
	[27054] = {
		28,
		27054,
		1,
		38,
		"Desperate Acts",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			44454,
			"Field Agent Kaartish",
			"Western Plaguelands",
			49.3,
			54.9,
		},
	},
	[13547] = {
		148,
		13547,
		1,
		15,
		"Coaxing the Spirits",
		"A",
		2,
		"HUNTERWARRIOR",
		2,
		"DRAENEI",
		{
			6887,
			"Yalda",
			"Darkshore",
			39.1,
			43.1,
		},
	},
	[13563] = {
		148,
		13563,
		1,
		11,
		"A Love Eternal",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			32959,
			"Cerellean Whiteclaw",
			"Darkshore",
			50.9,
			17.9,
		},
	},
	[25103] = {
		440,
		25103,
		1,
		46,
		"Bootlegger Outpost",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			38703,
			"Megs Dreadshredder",
			"Tanaris",
			71.90000000000001,
			45.4,
		},
	},
	[13566] = {
		148,
		13566,
		1,
		12,
		"Ritual Materials",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			33048,
			"Keeper Karithus",
			"Darkshore",
			43,
			39.1,
		},
	},
	[27214] = {
		15,
		27214,
		1,
		36,
		"A Disturbing Development",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23951,
			"Lieutenant Aden",
			"Dustwallow Marsh",
			65.09999999999999,
			47,
		},
	},
	[27246] = {
		15,
		27246,
		1,
		36,
		"The Orc Report",
		"A",
		2,
		"DRUID",
		2,
		"NIGHTELF",
		{
			23843,
			"Mordant Grimsby",
			"Dustwallow Marsh",
			55.4,
			26.1,
		},
	},
	[13565] = {
		148,
		13565,
		1,
		12,
		"Twice Removed",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			33126,
			"Seraphine",
			"Darkshore",
			42.9,
			38.9,
		},
	},
	[25263] = {
		14,
		25263,
		1,
		12,
		"Neeru Fireblade",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			3208,
			"Margoz",
			"Durotar",
			56.3,
			20,
		},
	},
	[24467] = {
		16,
		24467,
		1,
		19,
		"Fade to Black",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35867,
			"Kalec",
			"Azshara",
			66.5,
			20.4,
		},
	},
	[24573] = {
		4709,
		24573,
		1,
		33,
		"Honoring the Dead",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			37717,
			"Winnoa Pineforest",
			"Southern Barrens",
			41.5,
			46.7,
		},
	},
	[26002] = {
		406,
		26002,
		1,
		26,
		"Alliance Attack Plans",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			40901,
			"Blastgineer Fuzzwhistle",
			"Stonetalon Mountains",
			73.3,
			56.6,
		},
	},
	[13730] = {
		331,
		13730,
		1,
		21,
		"Playing With Felfire",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			33726,
			"Splintertree Demolisher",
			"Ashenvale",
			73.5,
			62.1,
		},
	},
	[27470] = {
		1583,
		27470,
		1,
		58,
		"A Potential Ally",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			14625,
			"Overseer Oilfist",
			"Searing Gorge",
			38.1,
			26.7,
		},
	},
	[26391] = {
		12,
		26391,
		1,
		4,
		"Extinguishing Hope",
		"A",
		2,
		"WARLOCK",
		2,
		"HUMAN",
		{
			9296,
			"Milly Osworth",
			"Elwynn Forest",
			48.1,
			42.5,
		},
	},
	[27534] = {
		139,
		27534,
		1,
		44,
		"Augustus' Receipt Book",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			12384,
			"Augustus the Touched",
			"Eastern Plaguelands",
			11.5,
			28.5,
		},
	},
	[23] = {
		331,
		23,
		1,
		24,
		"Ursangous's Paw",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			[3] = "Ashenvale",
			[4] = 42,
			[5] = 68.40000000000001,
		},
	},
	[13803] = {
		331,
		13803,
		1,
		22,
		"Blood of the Weak",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			33837,
			"Kadrak",
			"Ashenvale",
			73.59999999999999,
			62.2,
		},
	},
	[13936] = {
		331,
		13936,
		1,
		23,
		"Tweedle's Dumb",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			34359,
			"Captain Goggath",
			"Ashenvale",
			38.1,
			43.8,
		},
	},
	[25615] = {
		406,
		25615,
		1,
		25,
		"Return to Stardust",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			39256,
			"Kalen Trueshot",
			"Stonetalon Mountains",
			71.8,
			45.7,
		},
	},
	[25647] = {
		406,
		25647,
		1,
		26,
		"Illegible Orc Letter",
		"A",
		2,
		"MAGE",
		2,
		"GNOME",
		{
			[3] = "Stonetalon Mountains",
			[4] = 72.2,
			[5] = 61.5,
		},
	},
	[25679] = {
		4,
		25679,
		1,
		55,
		"Into the Mountain",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			41133,
			"Rofilian Dane",
			"Blasted Lands",
			59.5,
			3.6,
		},
	},
	[13883] = {
		331,
		13883,
		1,
		22,
		"Lousy Pieces of Ship",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			34303,
			"Dagrun Ragehammer",
			"Ashenvale",
			11.6,
			35.5,
		},
	},
	[13899] = {
		148,
		13899,
		1,
		20,
		"The Darkscale Warlord",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			34402,
			"Balren of the Claw",
			"Darkshore",
			45.3,
			75.09999999999999,
		},
	},
	[13885] = {
		148,
		13885,
		1,
		19,
		"In Defense of Darkshore",
		"A",
		2,
		"WARRIOR",
		2,
		"DRAENEI",
		{
			34301,
			"Kathrena Winterwisp",
			"Darkshore",
			45.2,
			74.7,
		},
	},
	[14305] = {
		405,
		14305,
		1,
		32,
		"A Time to Reap",
		"HA",
		2,
		"PALADINMAGEWARLOCK",
		2,
		"BLOODELFTROLLGNOME",
		{
			36060,
			"Botanist Ferrah",
			"Desolace",
			58.5,
			48.8,
		},
	},
	[13947] = {
		331,
		13947,
		1,
		23,
		"Blastranaar!",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			34359,
			"Captain Goggath",
			"Ashenvale",
			38.2,
			43.1,
		},
	},
	[13963] = {
		17,
		13963,
		1,
		12,
		"By Hook Or By Crook",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			34513,
			"Togrik",
			"Northern Barrens",
			56.6,
			40.3,
		},
	},
	[13890] = {
		331,
		13890,
		1,
		22,
		"Keep the Fires Burning",
		"H",
		2,
		"DEATHKNIGHT",
		2,
		"BLOODELF",
		{
			34122,
			"Commander Grimfang",
			"Ashenvale",
			12,
			33.8,
		},
	},
	[25935] = {
		406,
		25935,
		1,
		30,
		"[30] [30] Hungry Pups",
		"A",
		2,
		"PALADINDRUIDMAGE",
		2,
		"DRAENEINIGHTELFGNOME",
		{
			41638,
			"Houndmaster Jonathan",
			"Stonetalon Mountains",
			32.7,
			59.6,
		},
	},
	[14307] = {
		405,
		14307,
		1,
		32,
		"Stubborn Winds",
		"HA",
		2,
		"PALADINMAGEWARLOCK",
		2,
		"BLOODELFTROLLGNOME",
		{
			36034,
			"Karnum Marshweaver",
			"Desolace",
			57.4,
			47.7,
		},
	},
	[25999] = {
		406,
		25999,
		1,
		26,
		"Barrier to Entry",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			34341,
			"Saurboz",
			"Stonetalon Mountains",
			74.3,
			47.7,
		},
	},
	[14306] = {
		405,
		14306,
		1,
		32,
		"Pulling Weeds",
		"HA",
		2,
		"PALADINWARLOCK",
		2,
		"BLOODELFGNOME",
		{
			36060,
			"Botanist Ferrah",
			"Desolace",
			58.5,
			48.8,
		},
	},
	[26063] = {
		406,
		26063,
		1,
		27,
		"The Queen and Her Court",
		"H",
		2,
		"WARLOCK",
		2,
		"SCOURGE",
		{
			11821,
			"Darn Talongrip",
			"Stonetalon Mountains",
			65,
			82.7,
		},
	},
	[14363] = {
		405,
		14363,
		1,
		31,
		"You'll Know It When You See It",
		"A",
		2,
		"WARLOCK",
		2,
		"GNOME",
		{
			[3] = "Desolace",
			[4] = 53.8,
			[5] = 33.7,
		},
	},
	[28174] = {
		46,
		28174,
		1,
		50,
		"Burning Vengeance",
		"A",
		2,
		"MAGE",
		2,
		"DRAENEI",
		{
			47811,
			"John J. Keeshan",
			"Burning Steppes",
			17.3,
			52,
		},
	},
	[26159] = {
		4,
		26159,
		1,
		55,
		"The First Step",
		"A",
		2,
		"WARLOCKWARRIOR",
		2,
		"HUMANDRAENEI",
		{
			42298,
			"Kasim Sharim",
			"Blasted Lands",
			62.5,
			26.3,
		},
	},
	[14253] = {
		405,
		14253,
		1,
		31,
		"Fletch Me Some Plumage!",
		"A",
		2,
		"WARLOCK",
		2,
		"GNOME",
		{
			35757,
			"Bizby",
			"Desolace",
			61,
			29.2,
		},
	},
	[14252] = {
		405,
		14252,
		1,
		31,
		"Good Gold For Bad Tail",
		"A",
		2,
		"WARLOCK",
		2,
		"GNOME",
		{
			35757,
			"Bizby",
			"Desolace",
			61,
			29.2,
		},
	},
	[14155] = {
		16,
		14155,
		1,
		11,
		"Arborcide",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			[3] = "Azshara",
			[4] = 27,
			[5] = 77.09999999999999,
		},
	},
	[28334] = {
		361,
		28334,
		1,
		49,
		"A Flare Fight",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			48127,
			"Darla Drilldozer",
			"Felwood",
			56.3,
			8.199999999999999,
		},
	},
	[28366] = {
		361,
		28366,
		1,
		49,
		"Disarming Bears",
		"H",
		2,
		"DRUID",
		2,
		"TROLL",
		{
			15395,
			"Nafien",
			"Felwood",
			64,
			10.4,
		},
	},
	[28317] = {
		46,
		28317,
		1,
		51,
		"A Delivery for Thorg'izog",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			48307,
			"Colonel Troteman",
			"Burning Steppes",
			73.59999999999999,
			67.09999999999999,
		},
	},
	[14219] = {
		405,
		14219,
		1,
		31,
		"To the Hilt!",
		"H",
		2,
		"PALADIN",
		2,
		"BLOODELF",
		{
			[3] = "Desolace",
			[4] = 75.90000000000001,
			[5] = 26.6,
		},
	},
	[28314] = {
		46,
		28314,
		1,
		51,
		"Blood Tour",
		"A",
		2,
		"PALADIN",
		2,
		"HUMAN",
		{
			48306,
			"John J. Keeshan",
			"Burning Steppes",
			73.59999999999999,
			67.09999999999999,
		},
	},
	[14251] = {
		405,
		14251,
		1,
		31,
		"New Beginnings",
		"A",
		2,
		"WARLOCK",
		2,
		"GNOME",
		{
			35757,
			"Bizby",
			"Desolace",
			61,
			29.2,
		},
	},
	[14267] = {
		16,
		14267,
		1,
		13,
		"Investigating the Sea Shrine",
		"H",
		2,
		"DRUID",
		2,
		"TAUREN",
		{
			35657,
			"Torg Twocrush",
			"Azshara",
			50.7,
			75.2,
		},
	},
	[26074] = {
		406,
		26074,
		1,
		30,
		"Beginning of the End",
		"H",
		2,
		"WARLOCKPALADIN",
		2,
		"SCOURGEBLOODELF",
		{
			41023,
			"Overlord Krom'gar",
			"Stonetalon Mountains",
			66.09999999999999,
			63.8,
		},
	},

}
qcOldDatabase = {
}
qcDataToParse = {
}